/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.andami.ui.mdiManager;

/**
 * Interfaz a implementar por aquellas ventanas que tengan
 * una identidad en la aplicacin. Por ejemplo en un
 * editor de textos mdi, habr ventanas cuyo contenido
 * es un fichero y que no se desean abrir varias ventanas
 * con el mismo fichero. Para ello habr que definir dicha
 * ventana como singleton y devolver en getViewModel la
 * identidad de dicha ventana. En el caso de ejemplo
 * podra valernos una cadena con la ruta del fichero.
 * 
 * El framework acta de la siguiente manera: Cuando se
 * aade una vista singleton, primero se busca en las que
 * hay aadidas una cuyo getViewModel sea igual a la que
 * se quiere aadir. En caso de que se encuentre se
 * traer al frente dicha ventana. si no se encuentra s
 * muestra la vista aadida
 *
 * @author Fernando Gonzlez Corts
 */
public interface SingletonView extends View {
    /**
     * Obtiene el modelo de la vista, la identidad, el
     * objeto que se usar para identificar la vista
     *
     * @return Object
     */
    public Object getViewModel();
}
