/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.View;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameView;
import com.iver.cit.gvsig.gui.layout.fframes.IFFrame;



/**
 * Extensin preparada para controlar las opciones que se pueden realizar sobre
 * una vista aadida en el Layout.
 *
 * @author Vicente Caballero Navarro
 */
public class FFrameViewExtension extends Extension {
	//private static Logger logger = Logger.getLogger(FFrameViewExtension.class.getName());
	private Layout layout = null;

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String s) {
		layout = (Layout) PluginServices.getMDIManager().getActiveView();

		if (s.compareTo("VIEW_ZOOMIN") == 0) {
			layout.setTool(Layout.VIEW_ZOOMIN);
		} else if (s.compareTo("VIEW_ZOOMOUT") == 0) {
			layout.setTool(Layout.VIEW_ZOOMOUT);
		} else if (s.compareTo("VIEW_FULL") == 0) {
			try {
				layout.viewFull();
			} catch (DriverException e) {
				NotificationManager.addError("Error de Driver", e);
			}
		} else if (s.compareTo("VIEW_PAN") == 0) {
			layout.setTool(Layout.VIEW_PAN);
		}
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		Layout l = (Layout)PluginServices.getMDIManager().getActiveView();
		IFFrame[] fframes = l.getFFrameSelected();

		for (int i = 0; i < fframes.length; i++) {
			if (fframes[i] instanceof FFrameView) {
				if (((FFrameView)fframes[i]).getView()!=null)
				return true;
			}
		}

		return false;
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		View f = PluginServices.getMDIManager().getActiveView();

		if (f == null) {
			return false;
		}

		if (f.getClass() == Layout.class) {
		//	Layout layout = (Layout) f;

			return true; //layout.m_Display.getMapControl().getMapContext().getLayers().layerCount() > 0;
		} else {
			return false;
		}
	}
}
