/*
 * Created on 15-jul-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.View;
import com.iver.cit.gvsig.gui.layout.FLayoutGraphics;
import com.iver.cit.gvsig.gui.layout.Layout;


/**
 * Extensin que actua sobre el Layout para controlas las diferentes
 * operaciones sobre los grficos.
 *
 * @author Vicente Caballero Navarro
 */
public class GraphicControls extends Extension {
	private static Logger logger = Logger.getLogger(GraphicControls.class.getName());

	/**
	 * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
	 */
	public void execute(String s) {
		Layout layout = (Layout) PluginServices.getMDIManager().getActiveView();
		FLayoutGraphics lg = new FLayoutGraphics(layout);
		logger.debug("Comand : " + s);

		if (s.compareTo("SIMPLIFICAR") == 0) {
			lg.simplify();
		} else if (s.compareTo("AGRUPAR") == 0) {
			layout.getEFS().startComplexCommand();
			lg.grouping();
			layout.getEFS().endComplexCommand();
		} else if (s.compareTo("DESAGRUPAR") == 0) {
			lg.ungrouping();
		} else if (s.compareTo("PROPIEDADES") == 0) {
			lg.openFFrameDialog();
		} else if (s.compareTo("ALINEAR") == 0) {
			lg.aligning();
		} else if (s.compareTo("DETRAS") == 0) {
			lg.behind();
		} else if (s.compareTo("DELANTE") == 0) {
			lg.before();
		} else if (s.compareTo("BORDEAR") == 0) {
			lg.border();
		} else if (s.compareTo("POSICIONAR") == 0) {
			lg.position();
		}
	}

	/**
	 * @see com.iver.mdiApp.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		View f = PluginServices.getMDIManager().getActiveView();

		if (f == null) {
			return false;
		}

		if (f.getClass() == Layout.class) {
		//	Layout layout = (Layout) f;

			return true; //layout.m_Display.getMapControl().getMapContext().getLayers().layerCount() > 0;
		} else {
			return false;
		}
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		return true;
	}
}
