/*
 * Created on 20-feb-2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;
import com.iver.andami.messages.NotificationManager;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.FMap;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.gui.Encuadrator;
import com.iver.cit.gvsig.gui.ExtentListSelectorModel;
import com.iver.cit.gvsig.gui.FPanelExtentSelector;
import com.iver.cit.gvsig.gui.FPanelLocConfig;
import com.iver.cit.gvsig.gui.View;
import com.iver.cit.gvsig.gui.selectionByTheme.DefaultSelectionByThemeModel;
import com.iver.cit.gvsig.gui.selectionByTheme.MySelectionByThemeListener;
import com.iver.cit.gvsig.gui.selectionByTheme.SelectionByTheme;
import com.iver.cit.gvsig.project.Project;
import com.iver.cit.gvsig.project.ProjectView;


//import com.iver.utiles.FPanelExtentSelector;

/**
 * Extensin que controla las operaciones basicas realizadas sobre la vista.
 *
 * @author vcn
 */
public class ViewControls extends Extension {
	private static Logger logger = Logger.getLogger(ViewControls.class.getName());

	/**
	 * @see com.iver.mdiApp.plugins.IExtension#updateUI(java.lang.String)
	 */
	public void execute(String s) {
		View vista = (View) PluginServices.getMDIManager().getActiveView();
		ProjectView model = vista.getModel();
		FMap mapa = model.getMapContext();
		MapControl mapCtrl = vista.getMapControl();
		logger.debug("Comand : " + s);

		if (s.compareTo("FULL") == 0) {
			try {
			    // mapa.beginAtomicEvent();
				mapa.getViewPort().setExtent(mapa.getLayers().getFullExtent());
				vista.repaintMap();
				// mapa.endAtomicEvent();
			} catch (DriverException e) {
				NotificationManager.addError("Error obteniendo el full extent",
					e);
			}
		} else if (s.compareTo("SELECTIONBYSHAPE") == 0) {
			SelectionByTheme dlg = new SelectionByTheme();
			//FLayer[] layers = mapa.getLayers().getActives();
			//int count = 0;
			dlg.setModel(new DefaultSelectionByThemeModel());
			dlg.addSelectionListener(new MySelectionByThemeListener());
			PluginServices.getMDIManager().addView(dlg);
		} else if (s.compareTo("ENCUADRE") == 0) {
			FPanelExtentSelector l = new FPanelExtentSelector();

			ProjectExtension p = (ProjectExtension) PluginServices.getExtension(com.iver.cit.gvsig.ProjectExtension.class);
			Project project = p.getProject();
			ExtentListSelectorModel modelo = new ExtentListSelectorModel(project);
			//ProjectExtent[] extents = project.getExtents();
			project.addPropertyChangeListener(modelo);
			l.setModel(modelo);
			l.addSelectionListener(new Encuadrator(project, mapa, vista));
			PluginServices.getMDIManager().addView(l);
		} else if (s.compareTo("INFO") == 0) {
			mapCtrl.setTool("info");
		} else if (s.compareTo("CONFIG_LOCATOR") == 0) {
			//Set up the map overview
			FPanelLocConfig m_panelLoc = new FPanelLocConfig(vista.getMapOverview());
			PluginServices.getMDIManager().addView(m_panelLoc);
			m_panelLoc.setPreferredSize(m_panelLoc.getSize());
		} else if (s.compareTo("PAN") == 0) {
			mapCtrl.setTool("pan");
		} else if (s.compareTo("ZOOM_IN") == 0) {
			mapCtrl.setTool("zoomIn");
		} else if (s.compareTo("ZOOM_OUT") == 0) {
			mapCtrl.setTool("zoomOut");
		} else if (s.compareTo("MEDICION") == 0) {
			mapCtrl.setTool("medicion");
		} else if (s.compareTo("AREA") == 0) {
			mapCtrl.setTool("area");
		} else if (s.compareTo("SELRECT") == 0) {
			mapCtrl.setTool("rectSelection");
		} else if (s.compareTo("SELPOINT") == 0) {
			mapCtrl.setTool("pointSelection");
		} else if (s.compareTo("CAPAS_VISIBLES") == 0) {
			setVisibles(true, mapa);
		} else if (s.compareTo("CAPAS_NOVISIBLES") == 0) {
			setVisibles(false, mapa);
		} else if (s.compareTo("CAPAS_ACTIVAS") == 0) {
			setActives(true, mapa);
		} else if (s.compareTo("CAPAS_NOACTIVAS") == 0) {
			setActives(false, mapa);
		}else if (s.compareTo("SAVERASTER") == 0) {
			mapCtrl.setTool("saveRaster");
		}else if (s.compareTo("SELECTIMAGE") == 0) {
			mapCtrl.setTool("selectImage");
		}
	}

	/**
	 * Pone todas las capas visibles o no visibles.
	 *
	 * @param visible true si que quieren poner a visibles.
	 * @param mapa FMap sobre el que actuar.
	 */
	private void setVisibles(boolean visible, FMap mapa) {
		for (int i = 0; i < mapa.getLayers().getLayersCount(); i++) {
			FLayer layer = mapa.getLayers().getLayer(i);
			layer.setVisible(visible);
		}
	}

	/**
	 * Pone todas las capas activas o no activas.
	 *
	 * @param active true si que quieren poner a activas.
	 * @param mapa FMap sobre el que actuar.
	 */
	private void setActives(boolean active, FMap mapa) {
		for (int i = 0; i < mapa.getLayers().getLayersCount(); i++) {
			FLayer layer = mapa.getLayers().getLayer(i);
			layer.setActive(active);
		}
	}

	/**
	 * @see com.iver.mdiApp.plugins.IExtension#isVisible()
	 */
	public boolean isVisible() {
		com.iver.andami.ui.mdiManager.View f = PluginServices.getMDIManager()
															 .getActiveView();

		if (f == null) {
			return false;
		}

		if (f.getClass() == View.class) {
			View vista = (View) f;
			ProjectView model = vista.getModel();
			FMap mapa = model.getMapContext();

			return mapa.getLayers().getLayersCount() > 0;
		} else {
			return false;
		}
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#initialize()
	 */
	public void initialize() {
	}

	/**
	 * @see com.iver.andami.plugins.IExtension#isEnabled()
	 */
	public boolean isEnabled() {
		return true;
	}
}
