/*
 * Created on 17-sep-2004
 *
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.layout;

import com.iver.cit.gvsig.gui.layout.fframes.FFrameView;
import com.iver.cit.gvsig.gui.layout.fframes.IFFrame;
import com.iver.cit.gvsig.gui.layout.fframes.IFFrameUseFMap;

import java.awt.Point;
import java.awt.Toolkit;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;


/**
 * Clase contenedora de los mtodos para cambiar los zooms.
 *
 * @author Vicente Caballero Navarro
 */
public class FLayoutZooms {
	private Layout layout = null;
	private FLayoutFunctions functions = null;

	/**
	 * Crea un nuevo Zooms.
	 *
	 * @param l Mapa sobre el que se actua.
	 */
	public FLayoutZooms(Layout l) {
		layout = l;
		functions = new FLayoutFunctions(layout);
	}

	/**
	 * Realiza un zoom por rectngulo o por punto con un escalado por defecto
	 * sobre el Layout que se le pasa como parmetro.
	 *
	 * @param p1 punto de inicio del rectngulo.
	 * @param p2 punto final del recngulo.
	 */
	public void setZoomIn(Point p1, Point p2) {
		/*if (p1.y != p2.y) {
			double points = (p2.getX() - p1.getX()) / (p2.getY() - p1.getY());
			double window = (double) layout.getWidth() / (double)layout.getHeight();

			if (points < window) {
				p2.x = (int) (p1.x + ((p2.x - p1.x) * window));
			}
		}
		*/

		if (p1.getX()>p2.getX()){
			int aux=p2.x;
			p2.x=p1.x;
			p1.x=aux;
		}
		if (p1.getY()>p2.getY()){
			int aux=p2.y;
			p2.y=p1.y;
			p1.y=aux;
		}
		Point2D.Double pSheet1 = FLayoutUtilities.toSheetPoint(new Point2D.Double(
					p1.getX(), p1.getY()), layout.getAT());
		Point2D.Double pSheet2 = FLayoutUtilities.toSheetPoint(new Point2D.Double(
					p2.getX(), p2.getY()), layout.getAT());

		double xmin;
		double xmax;
		double ymin;
		double ymax = 0;

		if (pSheet1.x > pSheet2.x) {
			xmin = pSheet2.x;
			xmax = pSheet1.x;
		} else {
			xmin = pSheet1.x;
			xmax = pSheet2.x;
		}

		if (pSheet1.y > pSheet2.y) {
			ymin = pSheet2.y;
			ymax = pSheet1.y;
		} else {
			ymin = pSheet1.y;
			ymax = pSheet2.y;
		}

		Rectangle2D.Double rScreen = new Rectangle2D.Double();
		Rectangle2D.Double rSheet = new Rectangle2D.Double();
		double x = FLayoutUtilities.toSheetDistance(layout.getRect().getX(),
				layout.getAT());
		double y = FLayoutUtilities.toSheetDistance(layout.getRect().getY(),
				layout.getAT());
		double w = FLayoutUtilities.toSheetDistance(layout.getRect().getWidth(),
				layout.getAT());
		double h = FLayoutUtilities.toSheetDistance(layout.getRect().getHeight(),
				layout.getAT());

		if (java.lang.Math.abs(layout.getFirstPoint().x - p2.x) < 4) {
			double difw = 2;

			rSheet.x = (-pSheet2.getX() * difw) - x +
				FLayoutUtilities.toSheetDistance(layout.getWidth() / 2,
					layout.getAT());
			rSheet.y = (-pSheet2.getY() * difw) - y +
				FLayoutUtilities.toSheetDistance(layout.getHeight() / 2,
					layout.getAT());

			rSheet.width = w * difw;
			rSheet.height = h * difw;

			rScreen.setRect(FLayoutUtilities.fromSheetRect(rSheet,
					layout.getAT()));
			/*IFFrame[] fframes=layout.getFFrames();
			for (int i=0;i<fframes.length;i++){
				if (fframes[i] instanceof FFrameView){
					Point2D point1=new Point2D.Double(p2.getX()-(layout.getWidth()/2)*difw,p2.getY()-(layout.getHeight()/2)*difw);
					Point2D point2=new Point2D.Double(p2.getX()+(layout.getWidth()/2)*difw,p2.getY()+(layout.getHeight()/2)*difw);
					((FFrameView)fframes[i]).getRectView(point1,point2);
				}
			}*/


		} else {
			double wv = FLayoutUtilities.toSheetDistance(layout.getVisibleRect()
															   .getWidth(),
					layout.getAT());
			double hv = FLayoutUtilities.toSheetDistance(layout.getVisibleRect()
															   .getHeight(),
					layout.getAT());
			double mw = xmax - xmin;
			double mh = ymax - ymin;
			double difw = wv / mw;
			double difh = hv / mh;

			if (difw < difh) {
				rSheet.x = (-xmin * difw) - x +
					((wv - ((pSheet2.getX() - pSheet1.getX()) * difw)) / 2);
				rSheet.y = (-ymin * difw) - y +
					((hv - ((pSheet2.getY() - pSheet1.getY()) * difw)) / 2);

				rSheet.width = w * difw;
				rSheet.height = h * difw;
			} else {
				rSheet.x = (-xmin * difh) - x +
					((wv - ((pSheet2.getX() - pSheet1.getX()) * difh)) / 2);
				rSheet.y = (-ymin * difh) - y +
					((hv - ((pSheet2.getY() - pSheet1.getY()) * difh)) / 2);

				rSheet.width = w * difh;
				rSheet.height = h * difh;
			}

			rScreen.setRect(FLayoutUtilities.fromSheetRect(rSheet,
					layout.getAT()));

	/*		IFFrame[] fframes=layout.getFFrames();
			for (int i=0;i<fframes.length;i++){
				if (fframes[i] instanceof FFrameView){
					((FFrameView)fframes[i]).getRectView(p1,p2);
				}
			}
			*/
		}

		if (FLayoutUtilities.isPosible(rScreen)) {
			layout.getRect().setRect(rScreen);
		}

	}

	/**
	 * Realiza un zoom out sobre el Layout que se le pasa como parmetro.
	 *
	 * @param p2 punto final del recngulo.
	 */
	public void setZoomOut(Point p2) {
		Point2D.Double pSheet2 = FLayoutUtilities.toSheetPoint(new Point2D.Double(
					p2.getX(), p2.getY()), layout.getAT());

		Rectangle2D.Double rScreen = new Rectangle2D.Double();
		Rectangle2D.Double rSheet = new Rectangle2D.Double();

		double difw = 0.5;

		rSheet.x = (-pSheet2.getX() * difw) -
			FLayoutUtilities.toSheetDistance(layout.getRect().getX(),
				layout.getAT()) +
			FLayoutUtilities.toSheetDistance(layout.getWidth() / 2,
				layout.getAT());
		rSheet.y = (-pSheet2.getY() * difw) -
			FLayoutUtilities.toSheetDistance(layout.getRect().getY(),
				layout.getAT()) +
			FLayoutUtilities.toSheetDistance(layout.getHeight() / 2,
				layout.getAT());

		rSheet.width = FLayoutUtilities.toSheetDistance(layout.getRect()
															  .getWidth(),
				layout.getAT()) * difw;
		rSheet.height = FLayoutUtilities.toSheetDistance(layout.getRect()
															   .getHeight(),
				layout.getAT()) * difw;

		rScreen.setRect(FLayoutUtilities.fromSheetRect(rSheet, layout.getAT()));

		if (FLayoutUtilities.isPosible(rScreen)) {
			layout.getRect().setRect(rScreen);
		}
		IFFrame[] fframes=layout.getFFrames();
		for (int i=0;i<fframes.length;i++){
			if (fframes[i] instanceof FFrameView){
				Point2D point1=new Point2D.Double(p2.getX()-(layout.getWidth()/2)*difw,p2.getY()-(layout.getHeight()/2)*difw);
				Point2D point2=new Point2D.Double(p2.getX()+(layout.getWidth()/2)*difw,p2.getY()+(layout.getHeight()/2)*difw);
				((FFrameView)fframes[i]).getRectView(point1,point2);
			}
		}
	}

	/**
	 * Realiza un zoom out sobre el Layout que se le pasa como parmetro.
	 *
	 * @param dif punto de inicio del rectngulo.
	 * @param p2 punto final del recngulo.
	 */
	public void setZoom(double dif, Point p2) {
		Point2D.Double pSheet2 = FLayoutUtilities.toSheetPoint(new Point2D.Double(
					p2.getX(), p2.getY()), layout.getAT());
		Rectangle2D.Double rScreen = new Rectangle2D.Double();
		Rectangle2D.Double rSheet = new Rectangle2D.Double();

		double difw = dif;

		rSheet.x = (-pSheet2.getX() * difw) -
			FLayoutUtilities.toSheetDistance(layout.getRect().getX(),
				layout.getAT()) +
			FLayoutUtilities.toSheetDistance(layout.getWidth() / 2,
				layout.getAT());
		rSheet.y = (-pSheet2.getY() * difw) -
			FLayoutUtilities.toSheetDistance(layout.getRect().getY(),
				layout.getAT()) +
			FLayoutUtilities.toSheetDistance(layout.getHeight() / 2,
				layout.getAT());

		rSheet.width = FLayoutUtilities.toSheetDistance(layout.getRect()
															  .getWidth(),
				layout.getAT()) * difw;
		rSheet.height = FLayoutUtilities.toSheetDistance(layout.getRect()
															   .getHeight(),
				layout.getAT()) * difw;

		rScreen.setRect(FLayoutUtilities.fromSheetRect(rSheet, layout.getAT()));

		if (FLayoutUtilities.isPosible(rScreen)) {
			layout.getRect().setRect(rScreen);
		}
	}

	/**
	 * Realiza un zoom a escala 1:1.
	 */
	public void realZoom() {
		double cm = layout.getAtributes().getPixXCm(layout.getRect());
		Toolkit kit = Toolkit.getDefaultToolkit();
		int resolution = kit.getScreenResolution();
		double dif = (cm * Attributes.PULGADA) / resolution;
		setZoom(1 / dif,
			new Point(layout.getWidth() / 2, layout.getHeight() / 2));
		layout.setStatus(Layout.DESACTUALIZADO);
		layout.repaint();
	}

	/**
	 * Realiza un zoom ms a partir del punto central de pantalla.
	 */
	public void zoomIn() {
		setZoom(2, new Point(layout.getWidth() / 2, layout.getHeight() / 2));
		layout.setStatus(Layout.DESACTUALIZADO);
		layout.repaint();
	}

	/**
	 * Realiza un zoom menos a partir del punto central de pantalla.
	 */
	public void zoomOut() {
		setZoom(0.5, new Point(layout.getWidth() / 2, layout.getHeight() / 2));
		layout.setStatus(Layout.DESACTUALIZADO);
		layout.repaint();
	}

	/**
	 * Realiza un zoom a los elementos que esten seleccionados, si no hay
	 * ningn elemento seleccionado no realiza ningn zoom
	 */
	public void zoomSelect() {
		Rectangle2D.Double recaux = null;

		for (int i = 0; i < layout.getFFrames().length; i++) {
			if (((IFFrame) layout.getFFrame(i)).getSelected() != IFFrame.NOSELECT) {
				if (recaux == null) {
					recaux = ((IFFrame) layout.getFFrame(i)).getBoundingBox(layout.getAT());
				} else {
					recaux.add(((IFFrame) layout.getFFrame(i)).getBoundingBox(
							layout.getAT()));
				}
			}
		}

		if (recaux != null) {
			Point p1 = new Point((int) recaux.x, (int) recaux.y);
			Point p2 = new Point((int) recaux.getMaxX(), (int) recaux.getMaxY());
			setZoomIn(p1, p2);
			layout.setStatus(Layout.DESACTUALIZADO);
			layout.repaint();
		}
	}

	/**
	 * Realiza un zoom ms sobre la vista del FFrameView seleccionado.
	 *
	 * @param p1 punto inicial.
	 * @param p2 punto final.
	 */
	public void setViewZoomIn(Point2D p1, Point2D p2) {
		for (int i = 0; i < layout.getFFrames().length; i++) {
			if (layout.getFFrame(i) instanceof IFFrameUseFMap) {
				IFFrameUseFMap fframe = (IFFrameUseFMap) layout.getFFrame(i);

				if (((IFFrame)fframe).getSelected() != IFFrame.NOSELECT) {
					p1 = functions.toMapPoint(p1, fframe.getATMap());
					p2 = functions.toMapPoint(p2, fframe.getATMap());

					// Borramos el anterior
					layout.setStatus(Layout.DESACTUALIZADO);

					if (java.lang.Math.abs(p1.getX() - p2.getX()) <= 3) {
						double nuevoX;
						double nuevoY;
						double cX;
						double cY;

						cX = p2.getX();
						cY = p2.getY();

						double factor = 0.6;
						Rectangle2D.Double r = new Rectangle2D.Double();

						nuevoX = cX -
							((fframe.getFMap().getViewPort().getExtent()
									.getWidth() * factor) / 2.0);
						nuevoY = cY -
							((fframe.getFMap().getViewPort().getExtent()
									.getHeight() * factor) / 2.0);
						r.x = nuevoX;
						r.y = nuevoY;
						r.width = fframe.getFMap().getViewPort().getExtent()
										.getWidth() * factor;
						r.height = fframe.getFMap().getViewPort().getExtent()
										 .getHeight() * factor;

						fframe.setNewExtent(r);
					} else {
						//	Fijamos el nuevo extent
						Rectangle2D.Double r = new Rectangle2D.Double();

						r.setFrameFromDiagonal(p1, p2);

						fframe.setNewExtent(r);
					}
					fframe.refresh();
					// Fin del else
					//layout.repaint();
				}
			}
		}
	}

	/**
	 * Realiza un zoom menos sobre la vista del FFrameView seleccionado.
	 *
	 * @param p2 Punto sobre el que realizar el zoom menos.
	 */
	public void setViewZoomOut(Point p2) {
		Point2D.Double pWorld;

		for (int i = 0; i < layout.getFFrames().length; i++) {
			if (layout.getFFrame(i) instanceof IFFrameUseFMap) {
				IFFrameUseFMap fframe = (IFFrameUseFMap) layout.getFFrame(i);

				if (((IFFrame)fframe).getSelected() != IFFrame.NOSELECT) {
					double nuevoX;
					double nuevoY;
					double cX;
					double cY;
					Point pScreen = new Point((int) p2.getX(), (int) p2.getY());
					pWorld = functions.toMapPoint(pScreen, fframe.getATMap());

					cX = pWorld.getX();
					cY = pWorld.getY();

					double factor = 1.8;
					Rectangle2D.Double r = new Rectangle2D.Double();

					nuevoX = cX -
						((fframe.getFMap().getViewPort().getExtent().getWidth() * factor) / 2.0);
					nuevoY = cY -
						((fframe.getFMap().getViewPort().getExtent().getHeight() * factor) / 2.0);
					r.x = nuevoX;
					r.y = nuevoY;
					r.width = fframe.getFMap().getViewPort().getExtent()
									.getWidth() * factor;
					r.height = fframe.getFMap().getViewPort().getExtent()
									 .getHeight() * factor;

					fframe.setNewExtent(r);
					fframe.refresh();
					///fframe.getFMap().setCancelDrawing(false);
				}
			}
		}
	}
}
