/*
 * Created on 19-jul-2004
 *
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.layout.dialogs;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.SingletonView;
import com.iver.andami.ui.mdiManager.ViewInfo;

import com.iver.cit.gvsig.AddLayer;
import com.iver.cit.gvsig.gui.layout.Layout;

import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.JToggleButton;


/**
 * Contenedor de los botones necesarios para alinear, desplazar y cambiar el
 * tamao de los fframes.
 *
 * @author Vicente Caballero Navarro
 */
public class FAlignDialog extends JPanel implements SingletonView {
	private static final ImageIcon ileft = new ImageIcon(AddLayer.class.getClassLoader()
																	.getResource("images/left.PNG"));
	private static final ImageIcon icenterV = new ImageIcon(AddLayer.class.getClassLoader()
																	   .getResource("images/centerV.PNG"));
	private static final ImageIcon iright = new ImageIcon(AddLayer.class.getClassLoader()
																	 .getResource("images/right.PNG"));
	private static final ImageIcon iup = new ImageIcon(AddLayer.class.getClassLoader()
																  .getResource("images/up.PNG"));
	private static final ImageIcon icenterH = new ImageIcon(AddLayer.class.getClassLoader()
																	   .getResource("images/centerH.PNG"));
	private static final ImageIcon idown = new ImageIcon(AddLayer.class.getClassLoader()
																	.getResource("images/down.PNG"));
	private static final ImageIcon idistUp = new ImageIcon(AddLayer.class.getClassLoader()
																	  .getResource("images/distUp.PNG"));
	private static final ImageIcon idistCenterH = new ImageIcon(AddLayer.class.getClassLoader()
																		   .getResource("images/distCenterH.PNG"));
	private static final ImageIcon idistDown = new ImageIcon(AddLayer.class.getClassLoader()
																		.getResource("images/distDown.PNG"));
	private static final ImageIcon idistLeft = new ImageIcon(AddLayer.class.getClassLoader()
																		.getResource("images/distLeft.PNG"));
	private static final ImageIcon idistCenterV = new ImageIcon(AddLayer.class.getClassLoader()
																		   .getResource("images/distCenterV.PNG"));
	private static final ImageIcon idistRight = new ImageIcon(AddLayer.class.getClassLoader()
																		 .getResource("images/distRight.PNG"));
	private static final ImageIcon isizeWidth = new ImageIcon(AddLayer.class.getClassLoader()
																		 .getResource("images/sizeWidth.PNG"));
	private static final ImageIcon isizeHeight = new ImageIcon(AddLayer.class.getClassLoader()
																		  .getResource("images/sizeHeight.PNG"));
	private static final ImageIcon isizeOther = new ImageIcon(AddLayer.class.getClassLoader()
																		 .getResource("images/sizeOther.PNG"));
	private static final ImageIcon ispaceRight = new ImageIcon(AddLayer.class.getClassLoader()
																		  .getResource("images/spaceRight.PNG"));
	private static final ImageIcon ispaceDown = new ImageIcon(AddLayer.class.getClassLoader()
																		 .getResource("images/spaceDown.PNG"));
	private static final ImageIcon iinLayout = new ImageIcon(AddLayer.class.getClassLoader()
																		.getResource("images/inLayout.PNG"));
	private javax.swing.JButton bleft = null;
	private javax.swing.JButton bcenterV = null;
	private javax.swing.JButton bright = null;
	private javax.swing.JButton bup = null;
	private javax.swing.JButton bcenterH = null;
	private javax.swing.JButton bdown = null;
	private javax.swing.JButton bdistUp = null;
	private Layout m_layout = null;
	private javax.swing.JLabel lAlineamiento = null;
	private javax.swing.JLabel lDistribuir = null;
	private javax.swing.JButton bdistcenterV = null;
	private javax.swing.JButton bdistDown = null;
	private javax.swing.JButton bdistLeft = null;
	private javax.swing.JButton bdistcenterH = null;
	private javax.swing.JButton bdistRight = null;
	private javax.swing.JLabel lTamano = null;
	private javax.swing.JButton bsizecenterV = null;
	private javax.swing.JButton bsizecenterH = null;
	private javax.swing.JButton bsizeother = null;
	private javax.swing.JButton bspaceRight = null;
	private javax.swing.JButton bspaceDown = null;
	private javax.swing.JLabel lEspacio = null;
	private javax.swing.JLabel lEnElMapa = null;
	private JToggleButton binLayout = null;

	/**
	 * This is the default constructor
	 *
	 * @param layout Referencia al Layout.
	 */
	public FAlignDialog(Layout layout) {
		super();
		m_layout = layout;
		initialize();
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.setLayout(null);

		EventsFAlign listener = new EventsFAlign(m_layout);
		this.add(getBleft(), null);
		this.add(getBcenterV(), null);
		this.add(getBright(), null);
		this.add(getBup(), null);
		this.add(getBcenterH(), null);
		this.add(getBdown(), null);
		this.add(getBdistUp(), null);
		this.add(getLAlineamiento(), null);
		this.add(getLDistribuir(), null);
		this.add(getBdistcenterV(), null);
		this.add(getBdistDown(), null);
		this.add(getBdistLeft(), null);
		this.add(getBdistcenterH(), null);
		this.add(getBdistRight(), null);
		this.add(getLTamano(), null);
		this.add(getBsizecenterV(), null);
		this.add(getBsizecenterH(), null);
		this.add(getBsizeother(), null);
		this.add(getBspaceRight(), null);
		this.add(getBspaceDown(), null);
		this.add(getLEspacio(), null);
		this.add(getLEnElMapa(), null);
		this.add(getBinLayout(), null);
		this.setSize(310, 190);
		getBleft().addActionListener(listener);
		getBleft().setActionCommand("LEFT");
		getBcenterV().addActionListener(listener);
		getBcenterV().setActionCommand("CENTERV");
		getBright().addActionListener(listener);
		getBright().setActionCommand("RIGHT");
		getBup().addActionListener(listener);
		getBup().setActionCommand("UP");
		getBcenterH().addActionListener(listener);
		getBcenterH().setActionCommand("CENTERH");
		getBdown().addActionListener(listener);
		getBdown().setActionCommand("DOWN");
		getBdistUp().addActionListener(listener);
		getBdistUp().setActionCommand("DISTUP");
		getBdistcenterV().addActionListener(listener);
		getBdistcenterV().setActionCommand("DISTCENTERV");
		getBdistDown().addActionListener(listener);
		getBdistDown().setActionCommand("DISTDOWN");
		getBdistLeft().addActionListener(listener);
		getBdistLeft().setActionCommand("DISTLEFT");
		getBdistcenterH().addActionListener(listener);
		getBdistcenterH().setActionCommand("DISTCENTERH");
		getBdistRight().addActionListener(listener);
		getBdistRight().setActionCommand("DISTRIGHT");
		getBsizecenterV().addActionListener(listener);
		getBsizecenterV().setActionCommand("SIZECENTERV");
		getBsizecenterH().addActionListener(listener);
		getBsizecenterH().setActionCommand("SIZECENTERH");
		getBsizeother().addActionListener(listener);
		getBsizeother().setActionCommand("SIZEOTHER");
		getBspaceRight().addActionListener(listener);
		getBspaceRight().setActionCommand("SPACERIGHT");
		getBspaceDown().addActionListener(listener);
		getBspaceDown().setActionCommand("SPACEDOWN");
		getBinLayout().addActionListener(listener);
		getBinLayout().setActionCommand("INLAYOUT");
	}

	/**
	 * This method initializes bleft
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBleft() {
		if (bleft == null) {
			bleft = new javax.swing.JButton();
			bleft.setSize(24, 24);
			bleft.setIcon(ileft);
			bleft.setLocation(10, 30);
			bleft.setPreferredSize(new java.awt.Dimension(30, 30));
		}

		return bleft;
	}

	/**
	 * This method initializes bcenterV
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBcenterV() {
		if (bcenterV == null) {
			bcenterV = new javax.swing.JButton();
			bcenterV.setSize(24, 24);
			bcenterV.setIcon(icenterV);
			bcenterV.setLocation(35, 30);
			bcenterV.setPreferredSize(new java.awt.Dimension(39, 20));
		}

		return bcenterV;
	}

	/**
	 * This method initializes bright
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBright() {
		if (bright == null) {
			bright = new javax.swing.JButton();
			bright.setSize(24, 24);
			bright.setIcon(iright);
			bright.setLocation(60, 30);
		}

		return bright;
	}

	/**
	 * This method initializes bup
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBup() {
		if (bup == null) {
			bup = new javax.swing.JButton();
			bup.setSize(24, 24);
			bup.setIcon(iup);
			bup.setLocation(100, 30);
		}

		return bup;
	}

	/**
	 * This method initializes bcenterH
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBcenterH() {
		if (bcenterH == null) {
			bcenterH = new javax.swing.JButton();
			bcenterH.setSize(24, 24);
			bcenterH.setIcon(icenterH);
			bcenterH.setLocation(125, 30);
		}

		return bcenterH;
	}

	/**
	 * This method initializes bdown
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBdown() {
		if (bdown == null) {
			bdown = new javax.swing.JButton();
			bdown.setSize(24, 24);
			bdown.setIcon(idown);
			bdown.setLocation(150, 30);
		}

		return bdown;
	}

	/**
	 * This method initializes bdistUp
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBdistUp() {
		if (bdistUp == null) {
			bdistUp = new javax.swing.JButton();
			bdistUp.setSize(24, 24);
			bdistUp.setIcon(idistUp);
			bdistUp.setLocation(100, 73);
		}

		return bdistUp;
	}

	/**
	 * This method initializes lAlineamiento
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLAlineamiento() {
		if (lAlineamiento == null) {
			lAlineamiento = new javax.swing.JLabel();
			lAlineamiento.setSize(107, 13);
			lAlineamiento.setText(PluginServices.getText(this, "alineamiento"));
			lAlineamiento.setLocation(10, 10);
		}

		return lAlineamiento;
	}

	/**
	 * This method initializes lDistribuir
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLDistribuir() {
		if (lDistribuir == null) {
			lDistribuir = new javax.swing.JLabel();
			lDistribuir.setBounds(10, 57, 107, 13);
			lDistribuir.setText(PluginServices.getText(this, "distribuir"));
		}

		return lDistribuir;
	}

	/**
	 * This method initializes bdistcenterV
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBdistcenterV() {
		if (bdistcenterV == null) {
			bdistcenterV = new javax.swing.JButton();
			bdistcenterV.setSize(24, 24);
			bdistcenterV.setIcon(idistCenterH);
			bdistcenterV.setLocation(125, 73);
		}

		return bdistcenterV;
	}

	/**
	 * This method initializes bdistDown
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBdistDown() {
		if (bdistDown == null) {
			bdistDown = new javax.swing.JButton();
			bdistDown.setSize(24, 24);
			bdistDown.setIcon(idistDown);
			bdistDown.setLocation(150, 73);
		}

		return bdistDown;
	}

	/**
	 * This method initializes bdistLeft
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBdistLeft() {
		if (bdistLeft == null) {
			bdistLeft = new javax.swing.JButton();
			bdistLeft.setSize(24, 24);
			bdistLeft.setIcon(idistLeft);
			bdistLeft.setLocation(10, 73);
		}

		return bdistLeft;
	}

	/**
	 * This method initializes bdistcenterH
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBdistcenterH() {
		if (bdistcenterH == null) {
			bdistcenterH = new javax.swing.JButton();
			bdistcenterH.setSize(24, 24);
			bdistcenterH.setIcon(idistCenterV);
			bdistcenterH.setLocation(35, 73);
		}

		return bdistcenterH;
	}

	/**
	 * This method initializes bdistRight
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBdistRight() {
		if (bdistRight == null) {
			bdistRight = new javax.swing.JButton();
			bdistRight.setIcon(idistRight);
			bdistRight.setBounds(60, 73, 24, 24);
		}

		return bdistRight;
	}

	/**
	 * This method initializes lTamano
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLTamano() {
		if (lTamano == null) {
			lTamano = new javax.swing.JLabel();
			lTamano.setBounds(10, 101, 107, 13);
			lTamano.setText(PluginServices.getText(this, "coincidir_tamanyo"));
		}

		return lTamano;
	}

	/**
	 * This method initializes bsizecenterV
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBsizecenterV() {
		if (bsizecenterV == null) {
			bsizecenterV = new javax.swing.JButton();
			bsizecenterV.setIcon(isizeWidth);
			bsizecenterV.setBounds(10, 115, 24, 24);
		}

		return bsizecenterV;
	}

	/**
	 * This method initializes bsizecenterH
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBsizecenterH() {
		if (bsizecenterH == null) {
			bsizecenterH = new javax.swing.JButton();
			bsizecenterH.setIcon(isizeHeight);
			bsizecenterH.setBounds(35, 115, 24, 24);
		}

		return bsizecenterH;
	}

	/**
	 * This method initializes bsizeother
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBsizeother() {
		if (bsizeother == null) {
			bsizeother = new javax.swing.JButton();
			bsizeother.setIcon(isizeOther);
			bsizeother.setBounds(60, 115, 24, 24);
		}

		return bsizeother;
	}

	/**
	 * This method initializes bspaceRight
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBspaceRight() {
		if (bspaceRight == null) {
			bspaceRight = new javax.swing.JButton();
			bspaceRight.setIcon(ispaceRight);
			bspaceRight.setBounds(125, 115, 24, 24);
		}

		return bspaceRight;
	}

	/**
	 * This method initializes bspaceDown
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBspaceDown() {
		if (bspaceDown == null) {
			bspaceDown = new javax.swing.JButton();
			bspaceDown.setIcon(ispaceDown);
			bspaceDown.setBounds(150, 115, 24, 24);
		}

		return bspaceDown;
	}

	/**
	 * This method initializes lEspacio
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLEspacio() {
		if (lEspacio == null) {
			lEspacio = new javax.swing.JLabel();
			lEspacio.setBounds(125, 100, 57, 15);
			lEspacio.setText(PluginServices.getText(this, "espacio"));
		}

		return lEspacio;
	}

	/**
	 * This method initializes lEnElMapa
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLEnElMapa() {
		if (lEnElMapa == null) {
			lEnElMapa = new javax.swing.JLabel();
			lEnElMapa.setBounds(187, 33, 77, 17);
			lEnElMapa.setText(PluginServices.getText(this, "en_el_mapa"));
		}

		return lEnElMapa;
	}

	/**
	 * This method initializes binLayout
	 *
	 * @return javax.swing.JButton
	 */
	private JToggleButton getBinLayout() {
		if (binLayout == null) {
			binLayout = new JToggleButton();
			binLayout.setIcon(iinLayout);
			binLayout.setBounds(199, 58, 51, 41);
		}

		return binLayout;
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.SingletonView#getViewModel()
	 */
	public Object getViewModel() {
		return "AlignDialog";
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_viewinfo = new ViewInfo(ViewInfo.MODELESSDIALOG);
		m_viewinfo.setTitle(PluginServices.getText(this, "alinear"));

		return m_viewinfo;
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
