/*
 * Created on 22-jun-2004
 *
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.layout.fframes.dialogs;

import java.awt.Color;
import java.awt.geom.Rectangle2D;

import javax.swing.ImageIcon;
import javax.swing.JColorChooser;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JToggleButton;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.ViewInfo;
import com.iver.cit.gvsig.AddLayer;
import com.iver.cit.gvsig.gui.Dialogs.FontChooser;
import com.iver.cit.gvsig.gui.layout.FLayoutUtilities;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameText;
import java.lang.Double;


import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JTextField;
import javax.swing.JLabel;
/**
 * Dialogo para aadir texto al Layout.
 *
 * @author Vicente Caballero Navarro
 */
public class FFrameTextDialog extends JPanel implements IFFrameDialog {
	public static final ImageIcon ileft = new ImageIcon(AddLayer.class.getClassLoader()
																   .getResource("images/left.PNG")); //$NON-NLS-1$
	public static final ImageIcon icenterV = new ImageIcon(AddLayer.class.getClassLoader()
																	  .getResource("images/centerV.PNG")); //$NON-NLS-1$
	public static final ImageIcon iright = new ImageIcon(AddLayer.class.getClassLoader()
																	.getResource("images/right.PNG")); //$NON-NLS-1$
	private javax.swing.JPanel jContentPane = null; //  @jve:visual-info  decl-index=0 visual-constraint="593,10"
	private javax.swing.JScrollPane jScrollPane = null;
	private javax.swing.JTextArea taTexto = null;
	private javax.swing.JLabel lAlinear = null;
	private JToggleButton bIzquierda = null;
	private JToggleButton bCentro = null;
	private JToggleButton bDerecha = null;
	private javax.swing.JCheckBox chkEscalaVista = null;
	private javax.swing.JButton bAceptar = null;
	private javax.swing.JButton bCancelar = null;
	private Layout m_layout = null;
	private Rectangle2D rect = new Rectangle2D.Double();
	private FFrameText fframetext = null; //new FFrameText();
	private boolean isAcepted = false;
	private javax.swing.JButton bFuente = null;
	private Color textcolor = null;
	private Color frameColor =null;
	private Color titleColor =null;
	private JButton jButton = null;
	private JCheckBox chkSurroundingRectangle = null;
	private JTextField txtCellPadding = null;
	private JLabel jLabel = null;
	private JCheckBox chkFontSize = null;
	private JTextField txtFontSize = null;
	private JCheckBox chkTitle = null;
	private JTextField txtTitle = null;
	private JPanel jPanel = null;
	private JTextField txtTitleSize = null;
	private JLabel jLabel3 = null;
    private JLabel jLabel4;
	private JPanel jPanel1 = null;
	private JTextField txtFrameSize = null;
	private JLabel jLabel5 = null;
	private JLabel jLabel6 = null;
	private JLabel jLabel7 = null;
	private JButton jButton1 = null;
	private JButton jButton2 = null;
	private JPRotation pRotation = null;
	/**
	 * This is the default constructor
	 *
	 * @param layout Referencia al Layout.
	 * @param fframe Referencia al fframe de texto.
	 */
	public FFrameTextDialog(Layout layout, FFrameText fframe) {
		super();
		fframetext = fframe;
		m_layout = layout;
		textcolor = fframe.getTextColor();
		frameColor = fframe.getFrameColor();
		titleColor = fframe.getTitleColor();
		initialize();
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.setLayout(null);
		this.add(getJContentPane(), null);
		this.setSize(419, 429);
		getPRotation().setRotation(fframetext.getRotation());
	}

	/**
	 * Inserta el rectngulo a ocupar por el fframe de texto.
	 *
	 * @param r Rectngulo.
	 */
	public void setRectangle(Rectangle2D r) {
		rect.setRect(r);
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jLabel = new JLabel();
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getJScrollPane(), null);
			jContentPane.add(getLAlinear(), null);
			jContentPane.add(getBIzquierda(), null);
			jContentPane.add(getBCentro(), null);
			jContentPane.add(getBDerecha(), null);

			//jContentPane.add(getJLabel1(), null);
			//jContentPane.add(getJComboBox(), null);
			//jContentPane.add(getJLabel2(), null);
			jContentPane.add(getChkEscalaVista(), null);
			jContentPane.add(getBAceptar(), null);
			jContentPane.add(getBCancelar(), null);
			jContentPane.add(getBFuente(), null);
			jContentPane.setSize(412, 422);
			jContentPane.setLocation(3, 4);
			jContentPane.add(getJButton(), null);
			// jaume
			jLabel.setText(PluginServices.getText(this, "Milimetros"));
			jLabel.setSize(56, 16);
			jLabel.setLocation(215, 74);
			jContentPane.add(getJPanel1(), null);
			jContentPane.add(getJPanel(), null);
			jContentPane.add(getChkFontSize(), null);
			jContentPane.add(getTxtFontSize(), null);
			jContentPane.add(getPRotation(), null);
		}

		return jContentPane;
	}

	/**
	 * This method initializes jScrollPane
	 *
	 * @return javax.swing.JScrollPane
	 */
	private javax.swing.JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new javax.swing.JScrollPane();
			jScrollPane.setViewportView(getTaTexto());
			jScrollPane.setSize(261, 83);
			jScrollPane.setVerticalScrollBarPolicy(javax.swing.JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
			jScrollPane.setLocation(5, 5);
		}

		return jScrollPane;
	}

	/**
	 * This method initializes taTexto
	 *
	 * @return javax.swing.JTextArea
	 */
	private javax.swing.JTextArea getTaTexto() {
		if (taTexto == null) {
			taTexto = new javax.swing.JTextArea();

			for (int i = 0; i < fframetext.getText().size(); i++) {
				if (!((String) fframetext.getText().get(i)).equals("")) { //$NON-NLS-1$
					taTexto.append((String) fframetext.getText().get(i));
				}
			}
		}

		return taTexto;
	}

	/**
	 * This method initializes lAlinear
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLAlinear() {
		if (lAlinear == null) {
			lAlinear = new javax.swing.JLabel();
			lAlinear.setSize(52, 27);
			lAlinear.setText(PluginServices.getText(this, "alinear")); //$NON-NLS-1$
			lAlinear.setLocation(5, 98);
		}

		return lAlinear;
	}

	/**
	 * This method initializes bIzquierda
	 *
	 * @return javax.swing.JButton
	 */
	private JToggleButton getBIzquierda() {
		if (bIzquierda == null) {
			bIzquierda = new JToggleButton();
			bIzquierda.setSize(30, 27);
			bIzquierda.setPreferredSize(new java.awt.Dimension(28, 20));
			bIzquierda.setLocation(60, 98);

			if (fframetext.getPos() == FFrameText.LEFT) {
				bIzquierda.setSelected(true);
			}

			bIzquierda.setIcon(ileft);
			bIzquierda.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						fframetext.setPos(FFrameText.LEFT);
						getBIzquierda().setSelected(true);
						getBCentro().setSelected(false);
						getBDerecha().setSelected(false);
					}
				});
		}

		return bIzquierda;
	}

	/**
	 * This method initializes bCentro
	 *
	 * @return javax.swing.JButton
	 */
	private JToggleButton getBCentro() {
		if (bCentro == null) {
			bCentro = new JToggleButton();
			bCentro.setSize(30, 27);
			bCentro.setPreferredSize(new java.awt.Dimension(28, 20));
			bCentro.setLocation(93, 98);

			if (fframetext.getPos() == FFrameText.CENTER) {
				bCentro.setSelected(true);
			}

			bCentro.setIcon(icenterV);
			bCentro.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						fframetext.setPos(FFrameText.CENTER);
						getBIzquierda().setSelected(false);
						getBCentro().setSelected(true);
						getBDerecha().setSelected(false);
					}
				});
		}

		return bCentro;
	}

	/**
	 * This method initializes bDerecha
	 *
	 * @return javax.swing.JButton
	 */
	private JToggleButton getBDerecha() {
		if (bDerecha == null) {
			bDerecha = new JToggleButton();
			bDerecha.setSize(30, 27);
			bDerecha.setPreferredSize(new java.awt.Dimension(28, 20));
			bDerecha.setLocation(126, 98);

			if (fframetext.getPos() == FFrameText.RIGTH) {
				bDerecha.setSelected(true);
			}

			bDerecha.setIcon(iright);
			bDerecha.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						fframetext.setPos(FFrameText.RIGTH);
						getBIzquierda().setSelected(false);
						getBCentro().setSelected(false);
						getBDerecha().setSelected(true);
					}
				});
		}

		return bDerecha;
	}

	/**
	 * This method initializes chbEscalaVista
	 *
	 * @return javax.swing.JCheckBox
	 */
	private javax.swing.JCheckBox getChkEscalaVista() {
		if (chkEscalaVista == null) {
			chkEscalaVista = new javax.swing.JCheckBox();
			chkEscalaVista.setSize(280, 20);
			chkEscalaVista.setText(
				PluginServices.getText(this, "__redimensionar_texto_escala")); //$NON-NLS-1$
			chkEscalaVista.setSelected(fframetext.isSizeFixed());
			chkEscalaVista.setLocation(6, 153);
			chkEscalaVista.setEnabled(true);
		}

		return chkEscalaVista;
	}

	/**
	 * This method initializes bAceptar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBAceptar() {
		if (bAceptar == null) {
			bAceptar = new javax.swing.JButton();
			bAceptar.setSize(79, 26);
			bAceptar.setText(PluginServices.getText(this, "Aceptar")); //$NON-NLS-1$
			bAceptar.setLocation(39, 388);
			bAceptar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						fframetext.setBoundBox(FLayoutUtilities.toSheetRect(
								rect, m_layout.getAT()));
						fframetext.getText().clear();

						for (int i = 0; i < getTaTexto().getLineCount(); i++) {
							try {
								String s = getTaTexto().getText(getTaTexto()
																	.getLineStartOffset(i),
										getTaTexto().getLineEndOffset(i) -
										getTaTexto().getLineStartOffset(i));

								if (!s.equals("")) { //$NON-NLS-1$
									fframetext.addText(s);
								}
							} catch (Exception ex) {
							}
						}
						fframetext.setTextColor(textcolor);
						fframetext.setSizeFixed(!getChkEscalaVista().isSelected());
						
						// jaume
						boolean b = getChkSurroundingRectangle().isSelected();
						fframetext.setSurrounded(getChkSurroundingRectangle().isSelected());
					    
						if (b){
						    // Hay rectngulo
						    fframetext.setCellPadding(Double.parseDouble(getTxtCellPadding().getText())/100);
						    double i;
						    try{
						    	i = Double.parseDouble(getTxtFrameSize().getText());
						    } catch (Exception ex){
						    	i = 0;
						    }
						    if (i==0) i = 1;
						    fframetext.setFrameBorderSize(i/100);
						    fframetext.setFrameColor(frameColor);
						}
						b=getChkFontSize().isSelected();
						fframetext.setFixedFontSize(b);
					    
						if (b){
						    // El tamao de la fuente es fijo
							int i;
						    try{
						    	i = Integer.parseInt(getTxtFontSize().getText());
						    } catch (Exception ex){
						    	i = 12;
						    }
						    fframetext.setFontSize(i);
						}
						b=getChkTitle().isSelected();
						fframetext.setHasTitle(b);
						if (b){
						    // Hay ttulo
						    fframetext.setTitle(getTxtTitle().getText());
						    int i;
						    try{
						    	i = Integer.parseInt(getTxtTitleSize().getText());
						    } catch (Exception ex){
						    	i = 12;
						    }
							fframetext.setTitleSize(i);

						    fframetext.setTitleColor(titleColor);
						}
						    
					fframetext.setRotation(getPRotation().getRotation());	
					PluginServices.getMDIManager().closeView(FFrameTextDialog.this);
						m_layout.refresh();
						isAcepted = true;
					}
				});
		}

		return bAceptar;
	}

	/**
	 * This method initializes bCancelar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBCancelar() {
		if (bCancelar == null) {
			bCancelar = new javax.swing.JButton();
			bCancelar.setSize(85, 26);
			bCancelar.setText(PluginServices.getText(this, "Cancelar")); //$NON-NLS-1$
			bCancelar.setLocation(144, 388);
			bCancelar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						PluginServices.getMDIManager().closeView(FFrameTextDialog.this);
					}
				});
		}

		return bCancelar;
	}

	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_viewinfo = new ViewInfo(ViewInfo.MODALDIALOG);

		//vi.setResizable(false);
		m_viewinfo.setTitle(PluginServices.getText(this, "Propiedades_texto")); //$NON-NLS-1$

		return m_viewinfo;
	}

	/**
	 * @see com.iver.cit.gvsig.gui.layout.fframes.dialogs.IFFrameDialog#getIsAcepted()
	 */
	public boolean getIsAcepted() {
		return isAcepted;
	}

	/**
	 * This method initializes bFuente
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBFuente() {
		if (bFuente == null) {
			bFuente = new javax.swing.JButton();
			bFuente.setBounds(157, 98, 73, 27);
			bFuente.setText(PluginServices.getText(this, "fuente")); //$NON-NLS-1$
			bFuente.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						fframetext.setFont(FontChooser.showDialog(
								PluginServices.getText(this, "__seleccion_de_fuente"), fframetext.getFont())); // fchoser=new FontChooser();	 //$NON-NLS-1$
					}
				});
		}

		return bFuente;
	}

	/**
	 * @see com.iver.mdiApp.ui.MDIManager.View#viewActivated()
	 */
	public void viewActivated() {
	}
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton() {
		if (jButton == null) {
			jButton = new JButton();
			jButton.setForeground(Color.white);
			jButton.setBackground(textcolor);
			jButton.setBounds(235, 98, 32, 27);
			jButton.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					JDialog dlg;
					JColorChooser colorChooser;
					colorChooser = new JColorChooser();
					dlg = JColorChooser.createDialog((JFrame) null,
							PluginServices.getText(this, "Elegir_Color"),
							true, colorChooser, null, null);
					dlg.show(true);

					textcolor = (Color) colorChooser.getColor();

					//getJPanel1().setBackground(textcolor);
					jButton.setBackground(textcolor);

				}
			});
		}
		return jButton;
	}
	/**
	 * This method initializes chbSurroundingRectangle	
	 * 	
	 * @return javax.swing.JCheckBox
	 * @author jaume	
	 */    
	private JCheckBox getChkSurroundingRectangle() {
		if (chkSurroundingRectangle == null) {
			chkSurroundingRectangle = new JCheckBox();
			chkSurroundingRectangle.setText(PluginServices.getText(this, "usar_marco"));
			chkSurroundingRectangle.setSelected(fframetext.isSurrounded());
			chkSurroundingRectangle.setBounds(5, 20, 143, 19);
			chkSurroundingRectangle.addItemListener(new java.awt.event.ItemListener() { 
				public void itemStateChanged(java.awt.event.ItemEvent e) {    
					getTxtCellPadding().setEnabled(getChkSurroundingRectangle().isSelected());
					getTxtFrameSize().setEnabled(getChkSurroundingRectangle().isSelected());
				}
			});
		}
		return chkSurroundingRectangle;
	}
	/**
	 * This method initializes txtCellPadding
	 * 
	 * @author jaume	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getTxtCellPadding() {
		if (txtCellPadding == null) {
			txtCellPadding = new JTextField();
			txtCellPadding.setEnabled(fframetext.isSurrounded());
			txtCellPadding.setText(fframetext.getCellPadding()*100+"");
			txtCellPadding.setSize(60, 20);
			txtCellPadding.setLocation(140, 74);
			txtCellPadding.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyReleased(java.awt.event.KeyEvent e) {    
					ensureInteger(txtCellPadding);
				}
			});
			
		}
		return txtCellPadding;
	}
	/**
	 * This method initializes chkFontSize	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getChkFontSize() {
		if (chkFontSize == null) {
			chkFontSize = new JCheckBox();
			chkFontSize.setBounds(6, 174, 143, 19);
			chkFontSize.setText(PluginServices.getText(this, "tamanyo_fuente"));
			chkFontSize.setSelected(fframetext.isFontSizeFixed());
			chkFontSize.addItemListener(new java.awt.event.ItemListener() { 
				public void itemStateChanged(java.awt.event.ItemEvent e) {    
				    getTxtFontSize().setEnabled(getChkFontSize().isSelected());
				}
			});
		}
		return chkFontSize;
	}
	/**
	 * This method initializes txtFontSize	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getTxtFontSize() {
		if (txtFontSize == null) {
			txtFontSize = new JTextField();
			txtFontSize.setBounds(153, 176, 64, 17);
			txtFontSize.setEnabled(fframetext.isFontSizeFixed());
			if (txtFontSize.isEnabled()) txtFontSize.setText(fframetext.getFontSize()+"");
			txtFontSize.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyReleased(java.awt.event.KeyEvent e) {    
					ensureInteger(txtFontSize);
				}
			});
		}
		return txtFontSize;
	}
	/**
	 * This method initializes chkTitle2	
	 * 	
	 * @return javax.swing.JCheckBox	
	 */    
	private JCheckBox getChkTitle() {
		if (chkTitle == null) {
			chkTitle = new JCheckBox();
			chkTitle.setText(PluginServices.getText(this, "usar_titulo"));
			chkTitle.setSelected(fframetext.hasTitle());
			chkTitle.setBounds(6, 17, 85, 19);
			chkTitle.addChangeListener(new javax.swing.event.ChangeListener() { 
				public void stateChanged(javax.swing.event.ChangeEvent e) {    
					getTxtTitle().setEnabled(chkTitle.isSelected());
					getTxtTitleSize().setEnabled(chkTitle.isSelected());
					jLabel3.setEnabled(chkTitle.isSelected());
				}
			});
		}
		return chkTitle;
	}
	/**
	 * This method initializes txtTitle	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getTxtTitle() {
		if (txtTitle == null) {
			txtTitle = new JTextField();
			txtTitle.setEnabled(fframetext.hasTitle());
			if (fframetext.hasTitle())
			    txtTitle.setText(fframetext.getTitle());
			txtTitle.setBounds(92, 17, 175, 20);
		}
		return txtTitle;
	}
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel() {
		if (jPanel == null) {
		    jPanel = new JPanel();
		    jLabel3 = new JLabel();
			jPanel.setLayout(null);
			jPanel.setBounds(4, 307, 273, 76);
			jPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, PluginServices.getText(this, "titulo_fframetext"),
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			jLabel3.setBounds(9, 45, 109, 22);
			jLabel3.setText(PluginServices.getText(this, "tamanyo_fuente"));
			jLabel3.setEnabled(fframetext.hasTitle());
			jPanel.add(getTxtTitleSize(), null);
			jPanel.add(jLabel3, null);
			jPanel.add(getChkTitle(), null);
			jPanel.add(getTxtTitle(), null);
			jLabel4 = new JLabel();
			jLabel4.setBounds(190, 45, 40, 16);
			jPanel.add(jLabel4, null);
			jLabel4.setText(PluginServices.getText(this, "pixeles"));
			jPanel.add(getJButton2(), null);
			
		}
		return jPanel;
	}
	/**
	 * This method initializes txtTitleSize	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getTxtTitleSize() {
		if (txtTitleSize == null) {
			txtTitleSize = new JTextField();
			txtTitleSize.setBounds(121, 45, 64, 20);
			txtTitleSize.setEnabled(fframetext.hasTitle());
			int i = fframetext.getTitleSize();
			if (i == 0 && !txtTitleSize.isEnabled()) i = 5;
			txtTitleSize.setText(i+"");
			txtTitleSize.addKeyListener(new java.awt.event.KeyAdapter() { 
				public void keyReleased(java.awt.event.KeyEvent e) {    
					ensureInteger(txtTitleSize);
				}
			});
		}
		return txtTitleSize;
	}
	
	/**
	 * Asegura cutremente que no se meten valores que no sean.
	 * El funcionamiento consiste en si el ltimo carcter escrito
	 * no vale para formar un int entonces se elimina.
	 * 
	 * enteros.
	 * @param tf
	 */
	private void ensureInteger(JTextField tf){
	    String s = tf.getText();
	    try {
	        Integer.parseInt(s);
	    } catch (Exception e){
	        if (s.length()!=0)
	            tf.setText(s.substring(0, s.length()-1));
	        else tf.setText("");
	    }
	}
	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getJPanel1() {
		if (jPanel1 == null) {
			jPanel1 = new JPanel();
			jLabel5 = new JLabel();
			jLabel6 = new JLabel();
			jLabel7 = new JLabel();
			jPanel1.setLayout(null);
			jPanel1.setBounds(4, 199, 273, 106);
			jPanel1.add(getTxtCellPadding(), null);
			jPanel1.add(getChkSurroundingRectangle(), null);
			jPanel1.add(jLabel, null);
			jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, PluginServices.getText(this, "marco"),
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			jLabel5.setText(PluginServices.getText(this, "Milimetros"));
			jLabel5.setLocation(215, 46);
			jLabel5.setSize(56, 16);
			jLabel5.setPreferredSize(new java.awt.Dimension(40,16));
			jLabel6.setBounds(35, 47, 100, 20);
			jLabel6.setText(PluginServices.getText(this, "tamanyo_borde"));
			jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jLabel7.setBounds(35, 73, 100, 20);
			jLabel7.setText(PluginServices.getText(this, "margenes"));
			jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			jPanel1.add(getTxtFrameSize(), null);
			jPanel1.add(jLabel6, null);
			jPanel1.add(jLabel7, null);
			jPanel1.add(jLabel5, null);
			jPanel1.add(getJButton1(), null);
		}
		return jPanel1;
	}
	/**
	 * This method initializes txtFrameSize	
	 * 	
	 * @return javax.swing.JTextField	
	 */    
	private JTextField getTxtFrameSize() {
		if (txtFrameSize == null) {
			txtFrameSize = new JTextField();
			txtFrameSize.setEnabled(fframetext.isSurrounded());
			//if (txtFrameSize.isEnabled()){
			    double i = fframetext.getFrameBorderSize()*100;
			    if (i==0) i = 1;
			    txtFrameSize.setText(i+"");
			//}
			txtFrameSize.setLocation(140, 47);
			txtFrameSize.setSize(60, 20);
		}
		return txtFrameSize;
	}
	/**
	 * This method initializes jButton1	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton1() {
		if (jButton1 == null) {
			jButton1 = new JButton();
			jButton1.setForeground(fframetext.getFrameColor());
			jButton1.setBackground(fframetext.getFrameColor());
			jButton1.setBounds(229, 12, 32, 27);
			jButton1.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
				    // color del marco
				    JDialog dlg;
					JColorChooser colorChooser;
					colorChooser = new JColorChooser();
					dlg = JColorChooser.createDialog((JFrame) null,
							PluginServices.getText(this, "Elegir_Color"),
							true, colorChooser, null, null);
					dlg.show(true);

					frameColor = (Color) colorChooser.getColor();

					//getJPanel1().setBackground(textcolor);
					jButton1.setBackground(frameColor);
				}
			});
		}
		return jButton1;
	}
	/**
	 * This method initializes jButton2	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	private JButton getJButton2() {
		if (jButton2 == null) {
			jButton2 = new JButton();
			jButton2.setForeground(fframetext.getTitleColor());
			jButton2.setBackground(fframetext.getTitleColor());
			jButton2.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
				    // color del ttulo
				    JDialog dlg;
					JColorChooser colorChooser;
					colorChooser = new JColorChooser();
					dlg = JColorChooser.createDialog((JFrame) null,
							PluginServices.getText(this, "Elegir_Color"),
							true, colorChooser, null, null);
					dlg.show(true);

					titleColor = (Color) colorChooser.getColor();
					jButton2.setBackground(titleColor);
				}
			});
			
			jButton2.setBounds(235, 40, 32, 27);
		}
		return jButton2;
	}

	/**
	 * This method initializes pRotation	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPRotation getPRotation() {
		if (pRotation == null) {
			pRotation = new JPRotation();
			pRotation.setBounds(281, 13, 125, 131);
		}
		return pRotation;
	}
}  //  @jve:decl-index=0:visual-constraint="10,10"
