/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.gui.toc;


import javax.swing.JPanel;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.View;
import com.iver.andami.ui.mdiManager.ViewInfo;


/**
 * Dilogo para cambiar el nombre de una capa.
 *
 * @author Vicente Caballero Navarro
 */
public class ChangeName extends JPanel implements View {
	private javax.swing.JPanel jContentPane = null;
	private javax.swing.JLabel lblName = null;
	private javax.swing.JTextField txtName = null;
	private javax.swing.JButton bAceptar = null;
	private javax.swing.JButton bCancelar = null;
	private String name;
	
	/**
	 * This is the default constructor
	 *
	 * @param layout Referencia al Layout.
	 * @param fframe Referencia al fframe de imagen.
	 */
	public ChangeName(String n) {
		super();
		if (n==null){
			name=PluginServices.getText(this, "agrupacion");
		}else{
			name=n;
		}
		initialize();
	}

	/**
	 * This method initializes this
	 */
	private void initialize() {
		this.setLayout(null);
		this.add(getJContentPane(), null);
		this.setSize(381, 88);
	}

	/**
	 * This method initializes jContentPane
	 *
	 * @return javax.swing.JPanel
	 */
	private javax.swing.JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new javax.swing.JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getLblName(), null);
			jContentPane.add(getTxtName(), null);
			jContentPane.add(getBAceptar(), null);
			jContentPane.add(getBCancelar(), null);
			jContentPane.setSize(385, 86);
			jContentPane.setLocation(0, 0);
		}

		return jContentPane;
	}

	/**
	 * This method initializes lFichero
	 *
	 * @return javax.swing.JLabel
	 */
	private javax.swing.JLabel getLblName() {
		if (lblName == null) {
			lblName = new javax.swing.JLabel();
			lblName.setSize(42, 20);
			lblName.setText(PluginServices.getText(this, "nombre"));
			lblName.setLocation(10, 9);
		}

		return lblName;
	}

	/**
	 * This method initializes tFichero
	 *
	 * @return javax.swing.JTextField
	 */
	private javax.swing.JTextField getTxtName() {
		if (txtName == null) {
			txtName = new javax.swing.JTextField();
			txtName.setBounds(62, 8, 280, 20);
			txtName.setPreferredSize(new java.awt.Dimension(200, 20));
			txtName.setText(name);
		}
		return txtName;
	}

	/**
	 * Inserta el path al TFichero.
	 *
	 * @param val path del fichero.
	 */
	public void setText(String val) {
		getTxtName().setText(val);
	}

	/**
	 * This method initializes bAceptar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBAceptar() {
		if (bAceptar == null) {
			bAceptar = new javax.swing.JButton();
			bAceptar.setSize(85, 26);
			bAceptar.setText(PluginServices.getText(this, "Aceptar"));
			bAceptar.addActionListener(new java.awt.event.ActionListener() { 
				public void actionPerformed(java.awt.event.ActionEvent e) {    
					name=getTxtName().getText();
					PluginServices.getMDIManager().closeView(ChangeName.this);
				}
			});
			bAceptar.setLocation(69, 44);
			
		}

		return bAceptar;
	}

	/**
	 * This method initializes bCancelar
	 *
	 * @return javax.swing.JButton
	 */
	private javax.swing.JButton getBCancelar() {
		if (bCancelar == null) {
			bCancelar = new javax.swing.JButton();
			bCancelar.setSize(85, 26);
			bCancelar.setText(PluginServices.getText(this, "Cancelar"));
			bCancelar.setLocation(219, 44);
			bCancelar.addActionListener(new java.awt.event.ActionListener() {
					public void actionPerformed(java.awt.event.ActionEvent e) {
						PluginServices.getMDIManager().closeView(ChangeName.this);
					}
				});
		}

		return bCancelar;
	}

	/* (non-Javadoc)
	 * @see com.iver.mdiApp.ui.MDIManager.View#getViewInfo()
	 */
	public ViewInfo getViewInfo() {
		ViewInfo m_viewinfo = new ViewInfo(ViewInfo.MODALDIALOG);
		m_viewinfo.setTitle(PluginServices.getText(this,
				"cambio_nombre"));
		return m_viewinfo;
	}
	public String getName(){
		return name;
	}
	
}  //  @jve:decl-index=0:visual-constraint="10,10"

