/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package es.gva.cit.gvsig.catalogClient.gui;

import java.util.Collection;

import javax.swing.JDialog;

import org.gvsig.i18n.Messages;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.View;
import com.iver.andami.ui.mdiManager.ViewInfo;

import es.gva.cit.catalogClient.CatalogClient;
import es.gva.cit.catalogClient.metadataXML.XMLNode;
import es.gva.cit.catalogClient.schemas.discoverer.Resource;
import es.gva.cit.catalogClient.ui.showResults.ShowResultsDialogPanel;


/**
 * DOCUMENT ME!
 *
 * @author luisw
 */
public class ShowResultsDialog extends ShowResultsDialogPanel implements View {
    private JDialog frame = null;
    /**
     * DOCUMENT ME!
     *
     * @param client
     * @param nodes
     * @param currentRecord
     */
    public ShowResultsDialog(JDialog frame,CatalogClient client, Collection nodes,
        int currentRecord) {
        super(client, nodes, currentRecord);
        this.frame = frame;
    }

    /**
     * DOCUMENT ME!
     */
    public void descriptionButtonActionPerformed() {
        ShowTreeDialog dialog = new ShowTreeDialog((XMLNode)nodes.toArray()[getCurrentNode()]);
        dialog.setBounds(0, 0, 796, 645);
      dialog.setName(Messages.getText("metadata_tree"));
        dialog.setVisible(true);
        PluginServices.getMDIManager().addView(dialog);
    }

    /**
     * DOCUMENT ME!
     */
    public void mapButtonActionPerformed() {
        Resource[] resources = controlsPanel.getTags().getResources();
        Collection col = new java.util.ArrayList();
        for (int i=0 ; i<resources.length ;i++){
            col.add(resources[i]);
        }
        ChooseResourceDialog dialog = new ChooseResourceDialog(col);
        dialog.setBounds(0, 0, 586, 145);
        dialog.setName(Messages.getText("Recursos Disponibles"));
        dialog.setVisible(true);
        PluginServices.getMDIManager().addView(dialog);
    }

    /**
     * DOCUMENT ME!
     */
    public void closeButtonActionPerformed() {
        closeJDialog();
    }

    /**
     * Cierra el Dialog
     */
    public void closeJDialog() {
        frame.setVisible(false);
    }

    /* (non-Javadoc)
     * @see com.iver.andami.ui.mdiManager.View#getViewInfo()
     */
    public ViewInfo getViewInfo() {
        ViewInfo m_viewinfo = new ViewInfo(ViewInfo.MODALDIALOG);
        m_viewinfo.setTitle(getName());

        return m_viewinfo;
    }
}
