/*
 * Created on 09-feb-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: BufferPanelIF.java,v 1.1 2006/05/24 21:14:55 azabala Exp $
* $Log: BufferPanelIF.java,v $
* Revision 1.1  2006/05/24 21:14:55  azabala
* primera version en cvs despues de refactoring orientado a crear un framework extensible de geoprocessing
*
* Revision 1.3  2006/04/11 18:01:45  azabala
* aadido metodo getFLayers
*
* Revision 1.2  2006/02/17 15:56:48  azabala
* *** empty log message ***
*
* Revision 1.1  2006/02/12 21:01:40  azabala
* *** empty log message ***
*
*
*/
package com.iver.cit.gvsig.geoprocess.buffer.gui;

import java.io.File;

import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.geoprocess.core.fmap.GeoprocessException;

/**
 * Models  funtionality of GeoProcessingBufferPanel
 * GUI component.
 * 
 * @author azabala
 *
 */
public interface BufferPanelIF {
	public void openResultFile();
	public void constantDistanceSelected();
	public void attributeDistanceSelected();
	
	public File getOutputFile();
	public FLyrVect getInputLayer();
	public FLayers getFLayers();
	public boolean isConstantDistanceSelected();
	public boolean isAttributeDistanceSelected();
	public double getConstantDistance() throws GeoprocessException;
	public String getAttributeDistanceField()throws GeoprocessException;
	public boolean isBufferOnlySelected();
	public boolean isDissolveBuffersSelected();
	
}

