/*
 * Created on 16-feb-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: ScalableConvexHullVisitor.java,v 1.1 2006/05/24 21:13:31 azabala Exp $
* $Log: ScalableConvexHullVisitor.java,v $
* Revision 1.1  2006/05/24 21:13:31  azabala
* primera version en cvs despues de refactoring orientado a crear un framework extensible de geoprocessing
*
* Revision 1.3  2006/03/15 18:31:06  azabala
* *** empty log message ***
*
* Revision 1.2  2006/03/07 21:01:33  azabala
* *** empty log message ***
*
* Revision 1.1  2006/03/06 19:48:39  azabala
* *** empty log message ***
*
* Revision 1.2  2006/03/05 19:57:48  azabala
* *** empty log message ***
*
* Revision 1.1  2006/02/17 16:32:50  azabala
* *** empty log message ***
*
*
*/
package com.iver.cit.gvsig.geoprocess.convexhull.fmap;

import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.v02.FConverter;
import com.iver.cit.gvsig.fmap.layers.FLayer;
import com.iver.cit.gvsig.fmap.layers.layerOperations.VectorialData;
import com.iver.cit.gvsig.fmap.operations.strategies.VisitException;
import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.GeometryCollection;
import com.vividsolutions.jts.geom.GeometryFactory;

public class ScalableConvexHullVisitor implements ConvexHullVisitor {
	Geometry geometry;
	GeometryFactory geomFact;
	
	public ScalableConvexHullVisitor(){
		geomFact = new GeometryFactory();
	}
	/**
	 * Returns FMap convex hull geometry.
	 * @return
	 */
	public IGeometry getConvexHull(){
		return FConverter.jts_to_igeometry(geometry);
	}
	
	public Geometry getJtsConvexHull(){
		return geometry;
	}
	
	public void visit(IGeometry g, int index) throws VisitException {
		Geometry actualGeometry = g.toJTSGeometry();
		if(geometry == null){
			geometry = actualGeometry;
		}else{
			Geometry[] geoms = new Geometry[2];
			geoms[0] = geometry;
			geoms[1] = actualGeometry;
			GeometryCollection gc = geomFact.
				createGeometryCollection(geoms);
			geometry = gc.convexHull();	
		}
	}

	public void stop(FLayer layer) {
	}

	public boolean start(FLayer layer) {
		return layer instanceof VectorialData;
	}
	
	public String getProcessDescription() {
		return "Computing convex hull in an scalable manner";
	}

}

