/*
 * Created on 01-mar-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: SpatialJoinNumericFieldSelection.java,v 1.1 2006/05/24 21:13:09 azabala Exp $
 * $Log: SpatialJoinNumericFieldSelection.java,v $
 * Revision 1.1  2006/05/24 21:13:09  azabala
 * primera version en cvs despues de refactoring orientado a crear un framework extensible de geoprocessing
 *
 * Revision 1.4  2006/04/07 19:00:58  azabala
 * *** empty log message ***
 *
 * Revision 1.3  2006/03/26 20:02:08  azabala
 * *** empty log message ***
 *
 * Revision 1.2  2006/03/23 21:02:37  azabala
 * *** empty log message ***
 *
 * Revision 1.1  2006/03/05 19:56:06  azabala
 * *** empty log message ***
 *
 *
 */
package com.iver.cit.gvsig.geoprocess.core.gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.geoprocess.core.fmap.SummarizationFunction;

import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
/**
 * FIXME: INTERNACIONALIZAR LOS TEXTOS
 * 		  QUITAR LOS LISTMODEL REPETIDOS DEL DISSOLVE
 * @author azabala
 *
 */
public class SpatialJoinNumericFieldSelection 
	extends JDialog implements SpatialJoinNumFieldIF {

	private static final long serialVersionUID = -9031708821779458450L;
	private JPanel jContentPane = null;
	private JScrollPane numericFieldScrollPane = null;
	private JList numericFieldJList = null;
	private JScrollPane functionScrollPane = null;
	private JList functionJList = null;
	private JButton linkButton = null;
	private JLabel fieldsLabel = null;
	private JLabel functionsLabel = null;
	private JButton okButton = null;
	private SumarizeFunctionsDialog sumarizeFuncDialog;
	
	private Map nField_sumFuntionList;
	private String[] numericFields;
	private boolean ok = false;
	/**
	 * This is the default constructor
	 */
	public SpatialJoinNumericFieldSelection() {
		super((JFrame)PluginServices.getMainFrame(), true);
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(351, 236);
		this.setTitle(PluginServices.getText(this,"Funciones_Sumarizacion"));
		this.setContentPane(getJContentPane());
		this.nField_sumFuntionList = new HashMap();
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.insets = new java.awt.Insets(8,6,28,2);
			gridBagConstraints5.gridy = 2;
			gridBagConstraints5.ipadx = 10;
			gridBagConstraints5.ipady = -10;
			gridBagConstraints5.gridx = 1;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new java.awt.Insets(0,66,5,12);
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.gridy = 0;
			gridBagConstraints4.ipadx = 0;
			gridBagConstraints4.gridwidth = 2;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.insets = new java.awt.Insets(0,15,5,8);
			gridBagConstraints3.gridy = 0;
			gridBagConstraints3.gridwidth = 1;
			gridBagConstraints3.gridheight = 1;
			gridBagConstraints3.gridx = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.insets = new java.awt.Insets(54,6,66,2);
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.ipadx = 16;
			gridBagConstraints2.ipady = -10;
			gridBagConstraints2.fill = java.awt.GridBagConstraints.NONE;
			gridBagConstraints2.gridx = 1;
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints1.gridx = 2;
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.ipadx = -152;
			gridBagConstraints1.ipady = -9;
			gridBagConstraints1.weightx = 1.0;
			gridBagConstraints1.weighty = 1.0;
			gridBagConstraints1.insets = new java.awt.Insets(6,2,8,21);
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 1;
			gridBagConstraints.ipadx = -134;
			gridBagConstraints.ipady = -10;
			gridBagConstraints.weightx = 1.0;
			gridBagConstraints.weighty = 1.0;
			gridBagConstraints.insets = new java.awt.Insets(7,13,8,6);
			functionsLabel = new JLabel();
			functionsLabel.setText(PluginServices.getText(this, "Funciones_Sumarizacion"));
			fieldsLabel = new JLabel();
			fieldsLabel.setText(PluginServices.getText(this, "Atributos_Numericos"));
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			jContentPane.add(getNumericFieldScrollPane(), gridBagConstraints);
			jContentPane.add(getFunctionScrollPane(), gridBagConstraints1);
			jContentPane.add(getLinkButton(), gridBagConstraints2);
			jContentPane.add(fieldsLabel, gridBagConstraints3);
			jContentPane.add(functionsLabel, gridBagConstraints4);
			jContentPane.add(getOkButton(), gridBagConstraints5);
		}
		return jContentPane;
	}

	/**
	 * This method initializes numericFieldScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getNumericFieldScrollPane() {
		if (numericFieldScrollPane == null) {
			numericFieldScrollPane = new JScrollPane();
			numericFieldScrollPane.setViewportView(getNumericFieldJList());
		}
		return numericFieldScrollPane;
	}

	/**
	 * This method initializes numericFieldJList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getNumericFieldJList() {
		if (numericFieldJList == null) {
			numericFieldJList = new JList();
		}
		return numericFieldJList;
	}

	/**
	 * This method initializes functionScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getFunctionScrollPane() {
		if (functionScrollPane == null) {
			functionScrollPane = new JScrollPane();
			functionScrollPane.setViewportView(getFunctionJList());
		}
		return functionScrollPane;
	}

	/**
	 * This method initializes functionJList	
	 * 	
	 * @return javax.swing.JList	
	 */
	private JList getFunctionJList() {
		if (functionJList == null) {
			functionJList = new JList();
		}
		return functionJList;
	}

	/**
	 * This method initializes linkButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getLinkButton() {
		if (linkButton == null) {
			linkButton = new JButton();
			linkButton.setText("<-");
			linkButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					showFunctionsDialog();
				}});
		}
		return linkButton;
	}

	/**
	 * This method initializes okButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton();
			String okText = PluginServices.getText(this, "Aceptar");
			okButton.setText(okText);
			okButton.addActionListener(new ActionListener(){
				public void actionPerformed(ActionEvent arg0) {
					ok();
					
				}});
		}
		return okButton;
	}

	public void ok() {
		ok = true;
		setVisible(false);
	}

	public Map getSumarizationFunctions() {
		return this.nField_sumFuntionList;
	}

	public void showFunctionsDialog() {
		if (sumarizeFuncDialog == null) {
			sumarizeFuncDialog = new SumarizeFunctionsDialog();
			sumarizeFuncDialog.pack();
		}
		//sumarizeFuncDialog.setSize(150, 175);
		sumarizeFuncDialog.resetCheckbox();
		sumarizeFuncDialog.setVisible(true);
		SummarizationFunction[] functions = sumarizeFuncDialog.getFunctions();
		String fieldName = (String) this.numericFieldJList.getSelectedValue();
		this.nField_sumFuntionList.put(fieldName, functions);
		SumFuncListModel functionListModel = new SumFuncListModel(
				this.nField_sumFuntionList, numericFields);
		this.functionJList.setModel(functionListModel);
		//this.functionJList.setSelectedIndex(0);
		
	}

	public void setNumericFields(String[] numericFields) {
		this.numericFields = numericFields;
		NumericFieldListModel numericListModel = new NumericFieldListModel(
				numericFields);
		this.numericFieldJList.setModel(numericListModel);
		
	}

	public boolean isOk() {
		return ok;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
