/*
 * Created on 09-may-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: AdjacencyDissolveVisitor.java,v 1.1 2006/05/24 21:11:14 azabala Exp $
 * $Log: AdjacencyDissolveVisitor.java,v $
 * Revision 1.1  2006/05/24 21:11:14  azabala
 * primera version en cvs despues de refactoring orientado a crear un framework extensible de geoprocessing
 *
 *
 */
package com.iver.cit.gvsig.geoprocess.dissolve.fmap;

import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.geoprocess.core.fmap.FeatureProcessor;
import com.vividsolutions.jts.geom.Geometry;

/**
 * <p>
 * This Visitor generates a dissolve of input layer based in adjacency criteria:
 * it dissolves two polygons, if and only if they are adjacent.
 * </p>
 * TODO: To dissolve buffers from radial rings create a DissolveVisitor
 * to compare FROM-TO Fields.
 * 
 * @author azabala
 * 
 */
public class AdjacencyDissolveVisitor extends DissolveVisitor {

	public AdjacencyDissolveVisitor(String dissolveField,
			FeatureProcessor processor) {
		super(dissolveField, processor);
	}

	protected boolean verifyIfDissolve(DissolvedFeature f1, DissolvedFeature f2) {
		Geometry geo1 = f1.getJtsGeometry();
		Geometry geo2 = f2.getJtsGeometry();
		return geo1.intersects(geo2);
	}
	
	/**
	 * Creates a new IFeature with util info for dissolve geoprocess 
	 * (it ignore non numerical values, etc)
	 * 
	 * @param g
	 * @param index
	 * @return
	 * @throws DriverException
	 */
	protected DissolvedFeature createFeature(IGeometry g, int index)
			throws DriverException {
		DissolvedFeature solution
		= new DissolvedFeature(g, null, index);
		return solution;
	}

}
