/*
 * Created on 28-mar-2006
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
*
* $Id: BufferCmd.java,v 1.1 2006/05/24 21:08:45 azabala Exp $
* $Log: BufferCmd.java,v $
* Revision 1.1  2006/05/24 21:08:45  azabala
* primera version en cvs despues de refactoring orientado a crear un framework extensible de geoprocessing
*
* Revision 1.3  2006/04/11 18:00:06  azabala
* Primera version que funciona
*
* Revision 1.2  2006/04/07 08:34:38  fjp
* Lanzando una excepcin adecuada
*
* Revision 1.1  2006/03/28 16:24:39  azabala
* *** empty log message ***
*
*
*/
package com.iver.cit.gvsig.geoprocess.wizard;


import org.cresques.cts.IProjection;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.geoprocess.buffer.BufferGeoprocessController;
import com.iver.cit.gvsig.geoprocess.buffer.gui.GeoProcessingBufferPanel;
import com.iver.cit.gvsig.geoprocess.core.gui.GeoprocessPaneContainer;
import com.iver.cit.gvsig.gui.View;
/**
 * It processes user button push on BufferGeoprocessToolbar
 * @author azabala
 *
 */
public class BufferCmd implements AndamiCmd {

	public void execute() {
		View vista = (View)PluginServices.
				getMDIManager().
				getActiveView();
        final FLayers layers = vista.getModel().
        	getMapContext().getLayers();
        IProjection proj = vista.getModel().
        	getMapContext().getProjection();
		GeoProcessingBufferPanel geoProcessingBufferPanel = new
			GeoProcessingBufferPanel(layers);
		GeoprocessPaneContainer container = new 
			GeoprocessPaneContainer(geoProcessingBufferPanel);
		BufferGeoprocessController controller =
			new BufferGeoprocessController();
		controller.setView(geoProcessingBufferPanel);
		container.setCommand(controller);
		container.validate();
		container.repaint();
		PluginServices.getMDIManager().addView(container);
	}

}

