/*
 * Created on 22-jun-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.geoprocess.wizard;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.cit.gvsig.fmap.FMap;
import com.iver.cit.gvsig.gui.View;
import com.iver.cit.gvsig.project.ProjectView;

/**
 * GeoProcessingExtension class
 * 
 * @author jmorell
 */
public class GeoProcessingExtension extends Extension {

    /* (non-Javadoc)
     * @see com.iver.andami.plugins.Extension#inicializar()
     */
    public void initialize() {
        // TODO Auto-generated method stub

    }

    /* (non-Javadoc)
     * @see com.iver.andami.plugins.Extension#execute(java.lang.String)
     */
    public void execute(String actionCommand) {
    	AndamiCmd cmd = null;
    	if(actionCommand.equalsIgnoreCase("GEOPROCESSING")){
    		cmd = new GeoProcessingWizardCmd();
    	}else if(actionCommand.equalsIgnoreCase("BUFFER")){
    		cmd = new BufferCmd();
    	}else if(actionCommand.equalsIgnoreCase("CLIP")){
    		cmd = new ClipCmd();
    	}else if(actionCommand.equalsIgnoreCase("DISSOLVE")){
    		cmd = new DissolveCmd();
    	}else if(actionCommand.equalsIgnoreCase("INTERSECT")){
    		cmd = new IntersectionCmd();
    	}else if(actionCommand.equalsIgnoreCase("DIFFERENCE")){
    		cmd = new DifferenceCmd();
    	}else if(actionCommand.equalsIgnoreCase("UNION")){
    		cmd = new UnionCmd();
    	}else if(actionCommand.equalsIgnoreCase("CONVEXHULL")){
    		cmd = new ConvexHullCmd();
    	}else if(actionCommand.equalsIgnoreCase("MERGE")){
    		cmd = new MergeCmd();
    	}else if(actionCommand.equalsIgnoreCase("SPATIAL_JOIN")){
    		cmd = new SpatialJoinCmd();
    	}
    	cmd.execute();
    }

    public boolean isEnabled() {
        return true;
    }
    
    public boolean isVisible() {
		com.iver.andami.ui.mdiManager.View f = PluginServices.getMDIManager()
		 .getActiveView();
		if (f == null) {
		    return false;
		}
		if (f.getClass() == View.class) {
		    View vista = (View) f;
		    ProjectView model = vista.getModel();
		    FMap mapa = model.getMapContext();
		    return mapa.getLayers().getLayersCount() > 0;
		} else {
		    return false;
		}
    }

}
