/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package com.iver.cit.gvsig.fmap.layers;

import org.cresques.px.Extent;


/**
 * Este interfaz debe ser implementado por la clase que tenga la pila
 * de zooms.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public interface IStackZoom {
	
	/**
	 * Aade un extent a la lista
	 * @param ext
	 */
	public void setZoom(Extent ext);
		
	/**
	 * Recupera el ltimo extent aplicado
	 * @return
	 */
	public Extent getLastZoom();
	
	/**
	 * Recupera el siguiente zoom. Se usa cuando se ha recuperado el ltimo
	 * zoom y se quiere volver al siguiente.
	 * @return
	 */
	public Extent getNextZoom();
	
	/**
	 * @return Returns the initExtent.
	 */
	public Extent getInitExtent();
	
	/**
	 * @param initExtent The initExtent to set.
	 */
	public void setInitExtent(Extent initExtent);

}
