/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.tools;

import java.awt.Cursor;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;

import javax.swing.ImageIcon;

import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.tools.BehaviorException;
import com.iver.cit.gvsig.fmap.tools.Events.PointEvent;
import com.iver.cit.gvsig.fmap.tools.Listeners.PointListener;


/**
 * Implementacin de la interfaz PointListener como herramienta para seleccionar
 * puntos georeferenciados sobre una capa LyrPoints
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class GeorefPointerListenerImpl implements PointListener {
	private final Image img = new ImageIcon(MapControl.class.getResource(
	"images/PointSelectCursor.gif")).getImage();
	private Cursor cur = Toolkit.getDefaultToolkit().createCustomCursor(img,
	new Point(16, 16), "");
	
	/**
	* Crea un nuevo GeorefPointerListenerImpl.
	*
	* @param mc MapControl.
	*/
	public GeorefPointerListenerImpl() {
		
	}
	
	/**
	* Mtodo vacio para ser implementado por las clases derivadas
	*/
	public void point(PointEvent event) throws BehaviorException {

	}
	
	/**
	* Obtiene el puntero del ratn
	* @return cursor
	*/
	public Cursor getCursor() {
		return cur;
	}
	
	/**
	* @see com.iver.cit.gvsig.fmap.tools.Listeners.ToolListener#cancelDrawing()
	*/
	public boolean cancelDrawing() {
		return false;
	}
	
	// TODO LWS daba error y lo he aadido ... vaco, claro
	public void pointDoubleClick(PointEvent event) throws BehaviorException {
		// TODO Auto-generated method stub
		
	}
}
