package org.gvsig.georeferencing.gui.pointsTable;

import java.awt.FlowLayout;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;

import com.iver.andami.PluginServices;

/**
 * Control para el manejo de tablas. No contiene eventos, estos deben 
 * ser manejados desde la clase que lo llame.
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public class ButtonsExportImportPanel extends JPanel{
	
	//**********************Vars**********************************		
	private JButton 		bSave = null;
	private JButton 		bLoad = null;
	private JButton 		bExportToAscii = null;
	private String			pathToImages = "images/";//"/com/iver/cit/gvsig/gui/panels/images/";
	//**********************End Vars******************************
	
	//**********************Methods*******************************
	/**
	 * This is the default constructor
	 */
	public ButtonsExportImportPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {                
		this.setSize(new java.awt.Dimension(68,22));
		FlowLayout flowLayout5 = new FlowLayout();
		flowLayout5.setHgap(0);
		flowLayout5.setVgap(0);
        
		this.setLayout(flowLayout5);

		this.add(getBSave(), null);
		this.add(getBLoad(), null);
		this.add(getBExportToAscii(), null);
	}
	//**********************End Methods***************************	
	
	//**********************Getters & Setters*********************
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	public JButton getBLoad() {
		if (bLoad == null) {
			bLoad = new JButton();
			bLoad.setPreferredSize(new java.awt.Dimension(22,22));
			bLoad.setEnabled(true);
			bLoad.setIcon(new ImageIcon(getClass().getClassLoader().getResource(pathToImages + "load.png")));
			bLoad.setToolTipText(PluginServices.getText(this, "load_from_xml"));
		}
		return bLoad;
	}
	
	/**
	 * This method initializes bSave	
	 * 	
	 * @return javax.swing.JButton	
	 */
	public JButton getBSave() {
		if (bSave == null) {
			bSave = new JButton();
			bSave.setText("");
			bSave.setEnabled(false);
			bSave.setPreferredSize(new java.awt.Dimension(22,22));
			bSave.setIcon(new ImageIcon(getClass().getClassLoader().getResource(pathToImages + "save.png")));
			bSave.setActionCommand("");
			bSave.setToolTipText(PluginServices.getText(this, "save_to_xml"));
		}
		return bSave;
	}
	
	/**
	 * This method initializes jButton	
	 * 	
	 * @return javax.swing.JButton	
	 */    
	public JButton getBExportToAscii() { 
		if (bExportToAscii == null) {
			bExportToAscii = new JButton();
			bExportToAscii.setPreferredSize(new java.awt.Dimension(22,22));
			bExportToAscii.setEnabled(false);
			bExportToAscii.setIcon(new ImageIcon(getClass().getClassLoader().getResource(pathToImages + "exportToAscii.png")));
			bExportToAscii.setToolTipText(PluginServices.getText(this, "save_to_ascii"));
		}
		return bExportToAscii;
	}
	
	/**
	 * Activa o desactiva los botones de exportar capa de puntos y salvar
	 * la tabla a Ascii.
	 *@param isPossible Si vale true activa los controles de salvar y exportacin
	 *y si vale false los desactiva
	 */
	public void setSaveToDisk(boolean isPossible){
		this.getBSave().setEnabled(isPossible);
		this.getBExportToAscii().setEnabled(isPossible);
	}
	//**********************End Getters & Setters*****************
 }
