package org.gvsig.georeferencing.gui.selectPoints;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import com.iver.andami.PluginServices;
/**
 * Panel que contiene la informacin de cada punto. 
 * No contiene eventos, estos deben ser manejados desde la 
 * clase que lo llame.
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public class ErrorPointPanel extends JPanel{

	private JPanel pInfoPoint = null;
	private JPanel pX = null;
	private JPanel pY = null;
	private JPanel pRms = null;
	private JPanel pTotal = null;
	private JTextField tResX = null;
	private JLabel lX = null;
	private JLabel lY = null;
	private JTextField tResY = null;
	private JLabel lRms = null;
	private JLabel lTotal = null;
	private JTextField tTotal = null;
	private JTextField tRms = null;

	
	
	private JPanel pError = null;
	/**
	 * This is the default constructor
	 */
	public ErrorPointPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {                
		GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
		GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
		gridBagConstraints6.insets = new java.awt.Insets(0,0,0,0);
		gridBagConstraints6.gridy = 1;
		gridBagConstraints6.gridx = 0;
		
		this.setLayout(new GridBagLayout());
		this.setBorder(javax.swing.BorderFactory.createEmptyBorder(0,0,0,0));
		this.setSize(new java.awt.Dimension(175,125));
		this.setPreferredSize(new java.awt.Dimension(175,125));
		gridBagConstraints4.gridx = 0;
		gridBagConstraints4.gridy = 0;
		this.add(getPTotal(), gridBagConstraints6);
		this.add(getPError(), gridBagConstraints4);
	}
	
	/**
	 * This method initializes pX	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPX() {
		if (pX == null) {
			lX = new JLabel();
			lX.setText("Res X: ");
			lX.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			FlowLayout flowLayout2 = new FlowLayout();
			flowLayout2.setAlignment(java.awt.FlowLayout.RIGHT);
			pX = new JPanel();
			pX.setLayout(flowLayout2);
			pX.setPreferredSize(new java.awt.Dimension(140,20));
			flowLayout2.setHgap(0);
			flowLayout2.setVgap(1);
			pX.add(lX, null);
			pX.add(getTResX(), null);
		}
		return pX;
	}

	/**
	 * This method initializes pY	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPY() {
		if (pY == null) {
			lY = new JLabel();
			lY.setText("Res Y:");
			lY.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			FlowLayout flowLayout1 = new FlowLayout();
			flowLayout1.setAlignment(java.awt.FlowLayout.RIGHT);
			pY = new JPanel();
			pY.setLayout(flowLayout1);
			pY.setPreferredSize(new java.awt.Dimension(140,20));
			flowLayout1.setHgap(0);
			flowLayout1.setVgap(1);
			pY.add(lY, null);
			pY.add(getTResY(), null);
		}
		return pY;
	}

	/**
	 * This method initializes pLatitud	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPRms() {
		if (pRms == null) {
			lRms = new JLabel();
			lRms.setText("RMS:");
			lRms.setFont(new java.awt.Font("Dialog", java.awt.Font.PLAIN, 12));
			FlowLayout flowLayout3 = new FlowLayout();
			flowLayout3.setAlignment(java.awt.FlowLayout.RIGHT);
			pRms = new JPanel();
			pRms.setLayout(flowLayout3);
			pRms.setPreferredSize(new java.awt.Dimension(140,20));
			flowLayout3.setHgap(0);
			flowLayout3.setVgap(1);
			pRms.add(lRms, null);
			pRms.add(getTRMS(), null);
		}
		return pRms;
	}

	/**
	 * This method initializes pLongitud	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPTotal() {
		if (pTotal == null) {
			lTotal = new JLabel();
			lTotal.setText(PluginServices.getText(this, "total")+":");
			FlowLayout flowLayout4 = new FlowLayout();
			flowLayout4.setAlignment(java.awt.FlowLayout.RIGHT);
			pTotal = new JPanel();
			pTotal.setLayout(flowLayout4);
			pTotal.setPreferredSize(new java.awt.Dimension(160,20));
			flowLayout4.setHgap(7);
			flowLayout4.setVgap(1);
			pTotal.add(lTotal, null);
			pTotal.add(getTTotal(), null);
		}
		return pTotal;
	}
	
	/**
	 * Este mtodo inicializa el campo de texto que tiene la coordenada en X 
	 * de la vista. Controla que le sean introducidos valores numericos y
	 * salva el valor que contiene en la capa.	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTResX() {
		if (tResX == null) {
			tResX = new JTextField();
			tResX.setPreferredSize(new java.awt.Dimension(75,18));
			tResX.setEnabled(false);
		}
		return tResX;
	}

	/**
	 * Este mtodo inicializa el campo de texto que tiene la coordenada en Y 
	 * de la vista. Controla que le sean introducidos valores numericos y
	 * salva el valor que contiene en la capa.	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTResY() {
		if (tResY == null) {
			tResY = new JTextField();
			tResY.setPreferredSize(new java.awt.Dimension(75,18));
			tResY.setEnabled(false);
		}
		return tResY;
	}

	/**
	 * Este mtodo inicializa el campo de texto que tiene la coordenada en Y 
	 * del mundo real. Controla que le sean introducidos valores numericos y
	 * salva el valor que contiene en la capa.	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTTotal() {
		if (tTotal == null) {
			tTotal = new JTextField();
			tTotal.setPreferredSize(new java.awt.Dimension(90,18));
			tTotal.setEnabled(false);
			tTotal.setHorizontalAlignment(javax.swing.JTextField.LEFT);
		}
		return tTotal;
	}

	/**
	 * Este mtodo inicializa el campo de texto que tiene la coordenada en X 
	 * del mundo real. Controla que le sean introducidos valores numericos y
	 * salva el valor que contiene en la capa.
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getTRMS() {
		if (tRms == null) {
			tRms = new JTextField();
			tRms.setPreferredSize(new java.awt.Dimension(75,18));
			tRms.setEnabled(false);
			tRms.setHorizontalAlignment(javax.swing.JTextField.LEFT);
		}
		return tRms;
	}
	
	
	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */    
	private JPanel getPError() {
		if (pError == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			pError = new JPanel();
			pError.setLayout(new GridBagLayout());
			gridBagConstraints1.gridx = 0;
			gridBagConstraints1.gridy = 0;
			gridBagConstraints1.ipadx = 0;
			gridBagConstraints1.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints1.gridwidth = 2;
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridy = 1;
			gridBagConstraints2.weighty = 0.0D;
			gridBagConstraints2.insets = new Insets(0, 0, 0, 0);
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridy = 2;
			gridBagConstraints3.weighty = 0.0D;
			gridBagConstraints3.insets = new Insets(0, 0, 0, 0);
			pError.setPreferredSize(new java.awt.Dimension(175,105));
			pError.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Error", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			pError.add(getPX(), gridBagConstraints1);
			pError.add(getPY(), gridBagConstraints2);
			pError.add(getPRms(), gridBagConstraints3);
		}
		return pError;
	}
	
	/**
     * Activa o desactiva este panel y todos los que lo componen
     * @param enabled variable booleana para la activacin y/o desactivacin
     */
    public void setEnabled(boolean enabled){
    	Color color = Color.WHITE;
    	if(!enabled)
    		color = this.getBackground();
    	this.getTResX().setBackground(color);
    	this.getTResY().setBackground(color);
    	this.getTRMS().setBackground(color);
    	this.getTTotal().setBackground(color);
    }
    
    /**
	 * Esta funcin resetea los controles del panel de info de un punto.
	 */
	public void resetControls(String value){
		String data = "";
		if(value != null)
			data = value;
		getTResX().setText(data);
		getTResY().setText(data);
		getTRMS().setText(data);
		getTTotal().setText(data);
	}
 }
