/*
 * Created on 20-sep-2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
package org.gvsig.georeferencing.utils;

import java.util.ArrayList;

import org.cresques.px.Extent;

import com.iver.cit.gvsig.fmap.layers.IStackZoom;

/**
 * Clase para almacenar los extents que se van seleccionando al manipular
 * una imagen para su georreferenciacin. Esto permite recuperar extents anteriores.
 * 
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class StackZoom implements IStackZoom{
		
	private ArrayList extentList = new ArrayList();
	private Extent initExtent = null;
		
	private int selectElem = -1;
	
	public StackZoom(){}
	
	/**
	 * Aade un extent a la lista
	 * @param ext
	 */
	public void setZoom(Extent ext){
		extentList.add(ext);
		selectElem ++;
	}
		
	/**
	 * Recupera el ltimo extent aplicado
	 * @return
	 */
	public Extent getLastZoom(){
		if(extentList.size() == 0)
			return null;
		
		if((selectElem - 1)== -1){
			selectElem = -1;
			extentList.clear();
			return null;
		}
				
		selectElem --;
				
		Extent ex = (Extent)extentList.get(selectElem);
		return ex;
	}
	
	/**
	 * Recupera el siguiente zoom. Se usa cuando se ha recuperado el ltimo
	 * zoom y se quiere volver al siguiente.
	 * @return
	 */
	public Extent getNextZoom(){
		if(selectElem == (extentList.size() - 1) || extentList.size() == 0)
			return null;
		selectElem ++;
		Extent ex = (Extent)extentList.get(selectElem);
		return ex;
	}
	
	/**
	 * @return Returns the initExtent.
	 */
	public Extent getInitExtent() {
		return initExtent;
	}
	
	/**
	 * @param initExtent The initExtent to set.
	 */
	public void setInitExtent(Extent initExtent) {
		this.initExtent = initExtent;
	}

}
