package org.gvsig.rasterTools.brightnessContrast.filter;

import java.awt.Image;
import java.awt.image.BufferedImage;

import org.cresques.io.raster.RasterBuf;
import org.cresques.io.raster.RasterFilter;
import org.cresques.io.raster.RasterFilterStack;

/**
 * Filtro de contraste para imgenes raster. Toma como entrada la imagen
 * raster y el incremento de contraste introducido por el usuario y devuelve
 * la imagen con el filtro aplicado.
 * @author Miguel ngel Querol Carratal  <querol_mig@gva.es>
 *
 */
public class ContrastImageFilter extends ContrastFilter {

	public ContrastImageFilter(){
		super();
	}
	RasterFilterStack stack = null;
	
	public void pre(){
		exec = true;
		this.image = (Image) params.get("raster");
		this.stack = (RasterFilterStack) params.get("stack");
		height = image.getHeight(null);
        width = image.getWidth(null);
        this.incrContraste = ((Integer)this.params.get("incrContraste")).intValue();
        
        desplazamiento = incrContraste/2;
        estiramiento = incrContraste/80;
       
        if(estiramiento == 0)	
        	estiramiento += 1;
        if(estiramiento < 0)
        	estiramiento = -estiramiento;
		
		super.pre();
	}
	
	public void process(int x, int y) {
		int px = ((BufferedImage) image).getRGB(x, y);
		int px3[] = {(px & 0xff000000) >> 24, 
					(px & 0x00ff0000) >> 16, 
					(px & 0x0000ff00) >> 8, 
					(px & 0x000000ff)};
		
		for (int i = 1 ; i < 4 ; i++){			
			/*if(incrContraste < 0)
				result = (int)((px3[i] + desplazamiento) / estiramiento);
			else
				result = (int)((px3[i] - desplazamiento) * Math.pow(estiramiento, 2));
			*/
			desp = px3[i] - desplazamiento;
			if(desp <= 0) desp = 1;
			result = desp * (int)estiramiento;
			
			if(result > 255)
				px3[i] = 255;
			else if(result < 0)
				px3[i] = 0;
			else
				px3[i] = result;
		}
		
		((BufferedImage) this.image).setRGB(x, y, 	((px3[0] << 24) & 0xff000000) | 
												((px3[1] << 16) & 0x00ff0000) |
												((px3[2] << 8) & 0x0000ff00) |
												(px3[3] & 0x000000ff));
	}
	
	public int getInRasterDataType() {
		return RasterBuf.TYPE_IMAGE;
	}

	public int getOutRasterDataType() {
		return RasterBuf.TYPE_IMAGE;
	}

	public Object getResult(String name) {
		if (name.equals("raster")) {
            return (Object) this.image;
        } else {
            return null;
        }
	}

	public void processLine(int y) {
		// TODO Auto-generated method stub
		
	}

}
