package org.gvsig.rasterTools.brightnessContrast.ui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;


/**
 * Clase base para un componente con un slider y un campo de texto
 * @author Miguel ngel Querol Carratal  <querol_mig@gva.es>
 *
 */
public class SliderTextPanel extends JPanel implements ChangeListener, FocusListener, ActionListener{

	private JPanel pName = null;
	private JPanel pSliderText = null;
	private JSlider jSlider = null;
	private JTextField jTextField = null;
	private JLabel lPercent = null;
	/**
	 * This is the default constructor
	 */
	public SliderTextPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.gridy = 1;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.gridy = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(180, 45);
		this.setPreferredSize(new java.awt.Dimension(180,45));
		this.add(getJPanel(), gridBagConstraints);
		this.add(getJPanel1(), gridBagConstraints1);
		this.getJSlider().addChangeListener(this);
		this.getJTextField().addFocusListener(this);
		this.getJTextField().addActionListener(this);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	protected JPanel getJPanel() {
		if (pName == null) {
			pName = new JPanel();
			pName.setLayout(new GridBagLayout());
			pName.setPreferredSize(new java.awt.Dimension(180,25));
		}
		return pName;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getJPanel1() {
		if (pSliderText == null) {
			GridBagConstraints gridBagConstraints6 = new GridBagConstraints();
			gridBagConstraints6.gridx = 1;
			gridBagConstraints6.gridy = 0;
			lPercent = new JLabel();
			lPercent.setText("");
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 1;
			gridBagConstraints5.gridy = 0;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints4.gridy = 0;
			gridBagConstraints4.weightx = 1.0;
			gridBagConstraints4.insets = new java.awt.Insets(0,6,0,6);
			gridBagConstraints4.gridx = 2;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 1;
			gridBagConstraints3.gridy = 0;
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.fill = java.awt.GridBagConstraints.HORIZONTAL;
			gridBagConstraints2.gridy = 0;
			gridBagConstraints2.weightx = 1.0;
			gridBagConstraints2.gridx = 0;
			pSliderText = new JPanel();
			pSliderText.setLayout(new GridBagLayout());
			pSliderText.setPreferredSize(new java.awt.Dimension(180,20));
			pSliderText.add(getJSlider(), gridBagConstraints2);
			pSliderText.add(getJTextField(), gridBagConstraints4);
			pSliderText.add(lPercent, gridBagConstraints6);
		}
		return pSliderText;
	}

	/**
	 * This method initializes jSlider	
	 * 	
	 * @return javax.swing.JSlider	
	 */
	public JSlider getJSlider() {
		if (jSlider == null) {
			jSlider = new JSlider();
			jSlider.setPreferredSize(new java.awt.Dimension(100,16));
		}
		return jSlider;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getJTextField() {
		if (jTextField == null) {
			jTextField = new JTextField();
			jTextField.setPreferredSize(new java.awt.Dimension(20,19));
			jTextField.setComponentOrientation(java.awt.ComponentOrientation.LEFT_TO_RIGHT);
			jTextField.setText(String.valueOf(this.getJSlider().getValue()) + ".0");
		}
		return jTextField;
	}

	/**
	 * Pone una cadena con el tipo de unidad del cuadro de texto entre el slider
	 * y el TextField.
	 * @param cadena a poner entre el slider y el cudro de texto.
	 */
	
	protected void setUnitText(String unit){
		lPercent.setText(unit);
	}
	
	/**
	 * Activa o desactiva el control del panel
	 * @param active
	 */
	
	public void setControlEnabled(boolean active){
		this.jSlider.setEnabled(active);
		this.jTextField.setEnabled(active);
		this.lPercent.setEnabled(active);
		if(active == false){
			this.jTextField.setForeground(this.getBackground());
		}else{
			this.jTextField.setForeground(java.awt.Color.black);
		}
		
	}
	
	/**
	 * Ponel el slider al valor que le pasamos
	 * @param value
	 */
	
	public void setSliderValue(int value){
		jSlider.setValue(value);
	}
	
	
	/**
	 * Pone en el campo de texto a la derecha del slider el valor que le pasamos
	 * como parametro
	 * @param value: valor que aparecera en el campo de texto.
	 */
	public void setTextValue(String value){
		this.getJTextField().setText(value);
	}

	/**
	 * Devuelve el valor actual del campo de texto
	 * @return: valor del campo de texto.
	 */
	public String getTextValue(){
		return this.jTextField.getText();
	}
	
	public void stateChanged(ChangeEvent e) {
		if(e.getSource() == this.jSlider){
			this.jTextField.setText(String.valueOf(this.jSlider.getValue()) + ".0");
		}
	}
	
	/**
	 * Da el rango de valores en el que se mover el slider
	 * @param min
	 * @param max
	 */
	public void setSliderRange(int min, int max){
		this.jSlider.setMaximum(max);
		this.jSlider.setMinimum(min);
	}

	public void focusGained(FocusEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void focusLost(FocusEvent e) {
		if(e.getSource() == this.jTextField){
			String text = this.getJTextField().getText();
			double value = Double.valueOf(text).doubleValue();
			this.getJSlider().setValue((int) Math.round(value));
			this.getJTextField().setText(text);
		}
		
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == this.jTextField){
			String text = this.getJTextField().getText();
			double value = Double.valueOf(text).doubleValue();
			this.getJSlider().setValue((int) Math.round(value));
			this.getJTextField().setText(text);
		}
	}

	
}
