/*
 * Cresques Mapping Suite. Graphic Library for constructing mapping applications.
 *
 * Copyright (C) 2004-5.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 * cresques@gmail.com
 */
package org.gvsig.rasterTools.saveRaster.ui.listener;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JOptionPane;

import org.gvsig.rasterTools.saveRaster.operations.SaveRasterThread;
import org.gvsig.rasterTools.saveRaster.ui.properties.ProgressSaveRasterDialog;

import com.iver.andami.PluginServices;


/**
 * Clase encargada de manejar los eventos del los controles de la 
 * barra de progreso de salvar a raster
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class ProgressBarListener implements ActionListener, KeyListener {
    final private static long 			serialVersionUID = -3370601314380922368L;
    private SaveRasterThread			saver = null;
    private ProgressSaveRasterDialog	panel = null;

    public ProgressBarListener(SaveRasterThread saver, ProgressSaveRasterDialog panel){
    	this.saver = saver;
    	this.panel = panel;
    	panel.getBCancel().addKeyListener(this);
    	panel.getBCancel().addActionListener(this);
    }
    
	public void keyPressed(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void keyReleased(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void keyTyped(KeyEvent e) {
		// TODO Auto-generated method stub
		
	}

	public void actionPerformed(ActionEvent e) {
		//Cancelacin del proceso de salvar a raster. Solicita primero confirmacin
		if(e.getSource() == panel.getBCancel()){
			String string1 = PluginServices.getText(this, "yes");
			String string2 = PluginServices.getText(this, "no");
			Object[] options = {string1, string2};
			int n = JOptionPane.showOptionDialog((Component)PluginServices.getMainFrame(),
					PluginServices.getText(this, "msg_save_raster"),
					PluginServices.getText(this, "salvar_raster"),
					JOptionPane.YES_NO_OPTION,
					JOptionPane.QUESTION_MESSAGE,
					null,     
					options,  
					string1); 
			if (n == JOptionPane.YES_OPTION){ 
				saver.stopThread();
				if(panel != null)
						PluginServices.getMDIManager().closeView(panel.getParentWindow());
			}
		}	
	}
   
}

