package org.gvsig.rasterTools.saveRaster.ui.main;

import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class DoubleJTextInputPanel extends JPanel {

	private JLabel lNameField = null;
	private JLabel llabelField1 = null;
	private JTextField tField1 = null;
	private JLabel llabelField2 = null;
	private JTextField tField2 = null;

	/**
	 * This is the default constructor
	 */
	public DoubleJTextInputPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		llabelField2 = new JLabel();
		llabelField2.setText(" Y: ");
		llabelField1 = new JLabel();
		llabelField1.setText("X: ");
		lNameField = new JLabel();
		lNameField.setText("Default Text ");
		FlowLayout flowLayout = new FlowLayout();
		flowLayout.setHgap(2);
		flowLayout.setAlignment(java.awt.FlowLayout.RIGHT);
		flowLayout.setVgap(1);
		this.setLayout(flowLayout);
		this.setSize(337, 21);
		this.setPreferredSize(new java.awt.Dimension(299,19));
		this.add(lNameField, null);
		this.add(llabelField1, null);
		this.add(getJTextField(), null);
		this.add(llabelField2, null);
		this.add(getJTextField1(), null);
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getJTextField() {
		if (tField1 == null) {
			tField1 = new JTextField();
			tField1.setPreferredSize(new java.awt.Dimension(100,19));
		}
		return tField1;
	}

	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	public JTextField getJTextField1() {
		if (tField2 == null) {
			tField2 = new JTextField();
			tField2.setPreferredSize(new java.awt.Dimension(100,19));
		}
		return tField2;
	}

	/**
	 * Asigna los textos al componente
	 * @param label	Texto de descripcin del componente
	 * @param llabelField1 texto asociado al field de la izquierda
	 * @param llabelField2 texto asociado al field de la derecha
	 */
	public void setTexts(String label, String llabelField1, String llabelField2){
		this.lNameField.setText(label);
		this.llabelField1.setText(llabelField1);
		this.llabelField2.setText(llabelField2);
	}
	
	/**
	 * Asigna el ancho al JTextField de la izquierda
	 * @param width ancho del campo en pixeles
	 */
	public void setWidthText1(int width){
		tField1.setPreferredSize(new Dimension(width, 19));
	}
	
	/**
	 * Asigna el ancho al JTextField de la derecha
	 * @param width ancho del campo en pixeles
	 */
	public void setWidthText2(int width){
		tField2.setPreferredSize(new Dimension(width, 19));
	}
}
