package org.gvsig.rasterTools.saveRaster.ui.main;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.cresques.cts.IProjection;

import com.iver.andami.PluginServices;

/**
 * Panel General de salvar a raster
 * @author Nacho Brodin (brodin_ign@gva.es)
 *
 */
public class SaveRasterControlsPanel extends JPanel {

	//Panels
	private JPanel 						pWorldCoordinates = null;
	private JPanel 						pMethod = null;
	private JPanel 						pButtons = null;
	private JPanel 						pInfDer = null;
	private JPanel 						pSupIzq = null;
	
    private IProjection					proj = null;
	private int							widthInPixelsGeodesicas = 0;
    private int							heightInPixelsGeodesicas = 0;
			
	/**
	 * This is the default constructor
	 */
	public SaveRasterControlsPanel() {
		super();
		initialize();
	}
	
	/**
	 * Asigna las traducciones del dialogo
	 */
	public void setTranslation(){
		MethodDataInputPanel method = ((MethodDataInputPanel)pMethod);
		InputScaleDataPanel scaleData = ((InputScaleDataPanel)method.getPEast());
		scaleData.getLScale().setText(PluginServices.getText(this,"scale"));
		scaleData.getLResolution().setText(PluginServices.getText(this,"resolution"));
		scaleData.getLMtsPixel().setText(PluginServices.getText(this,"mtspixel"));
		
		MethodSaveRasterSelectorPanel selector = ((MethodSaveRasterSelectorPanel)method.getPWest());
		selector.getRbMtsPixel().setText(PluginServices.getText(this,"mtspixel"));
		selector.getRbSize().setText(PluginServices.getText(this,"size"));
		selector.getRbScale().setText(PluginServices.getText(this,"scale"));
		
		InputSizeDataPanel size = ((InputSizeDataPanel)method.getPSouth());
		size.getLHeight().setText(" "+PluginServices.getText(this,"height"));
		size.getLWidth().setText(PluginServices.getText(this,"width"));
		
		ButtonsPanel but = ((ButtonsPanel)pButtons);
		but.setTag(PluginServices.getText(this,"file")+": ");
		but.getBSelect().setText(PluginServices.getText(this,"select"));
		((DoubleJTextInputPanel)pInfDer).setTexts(	PluginServices.getText(this,"linf_der"),
													PluginServices.getText(this," X: "),
													PluginServices.getText(this," Y: "));
		((DoubleJTextInputPanel)pSupIzq).setTexts(	PluginServices.getText(this,"lsup_izq"),
													PluginServices.getText(this," X: "),
													PluginServices.getText(this," Y: "));
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
		gridBagConstraints2.gridx = 0;
		gridBagConstraints2.insets = new java.awt.Insets(3,0,0,0);
		gridBagConstraints2.gridy = 2;
		GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
		gridBagConstraints1.gridx = 0;
		gridBagConstraints1.insets = new java.awt.Insets(0,0,0,0);
		gridBagConstraints1.gridy = 1;
		GridBagConstraints gridBagConstraints = new GridBagConstraints();
		gridBagConstraints.gridx = 0;
		gridBagConstraints.insets = new java.awt.Insets(0,0,3,0);
		gridBagConstraints.gridy = 0;
		this.setLayout(new GridBagLayout());
		this.setSize(390, 320);
		this.setPreferredSize(new java.awt.Dimension(341,232));
		this.add(getPWorldCoordinates(), gridBagConstraints);
		this.add(getPMethod(), gridBagConstraints1);
		this.add(getPButtons(), gridBagConstraints2);
		this.setTranslation();
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPWorldCoordinates() {
		if (pWorldCoordinates == null) {
			GridBagConstraints gridBagConstraints5 = new GridBagConstraints();
			gridBagConstraints5.gridx = 0;
			gridBagConstraints5.gridy = 0;
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 0;
			gridBagConstraints4.gridy = 0;
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridy = 1;
			pWorldCoordinates = new JPanel();
			pWorldCoordinates.setLayout(new GridBagLayout());
			pWorldCoordinates.setPreferredSize(new java.awt.Dimension(371,70));
			pWorldCoordinates.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Coordenadas", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10), null));
			pWorldCoordinates.add(getPInfDer(), gridBagConstraints3);
			pWorldCoordinates.add(getPSupIzq(), gridBagConstraints5);
		}
		return pWorldCoordinates;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPMethod() {
		if (pMethod == null) {
			pMethod = new MethodDataInputPanel();
			pMethod.setPreferredSize(new java.awt.Dimension(371,160));
			pMethod.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Seleccion", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10), null));
		}
		return pMethod;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPButtons() {
		if (pButtons == null) {
			pButtons = new ButtonsPanel();
			pButtons.setPreferredSize(new java.awt.Dimension(371,70));
			pButtons.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Fichero", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", java.awt.Font.PLAIN, 10), null));
		}
		return pButtons;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPInfDer() {
		if (pInfDer == null) {
			pInfDer = new DoubleJTextInputPanel();
			((DoubleJTextInputPanel)pInfDer).setWidthText1(105);
			((DoubleJTextInputPanel)pInfDer).setWidthText2(105);
			pInfDer.setPreferredSize(new java.awt.Dimension(337,21));
		}
		return pInfDer;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPSupIzq() {
		if (pSupIzq == null) {
			pSupIzq = new DoubleJTextInputPanel();
			((DoubleJTextInputPanel)pSupIzq).setWidthText1(105);
			((DoubleJTextInputPanel)pSupIzq).setWidthText2(105);
			pSupIzq.setPreferredSize(new java.awt.Dimension(337,21));
		}
		return pSupIzq;
	}
	
	//-------------------------------------------
	
	public JLabel getLFileName(){
		return ((ButtonsPanel)pButtons).getLabelText();
	}
	
	public JButton getBProperties(){
		return ((ButtonsPanel)pButtons).getBProperties();
	}
	
	public JButton getBSelect(){
		return ((ButtonsPanel)pButtons).getBSelect();
	}
	
	public JTextField getTSupIzqX(){
		return ((DoubleJTextInputPanel)pSupIzq).getJTextField();
	}
	
	public JTextField getTSupIzqY(){
		return ((DoubleJTextInputPanel)pSupIzq).getJTextField1();
	}
	
	public JTextField getTInfDerX(){
		return ((DoubleJTextInputPanel)pInfDer).getJTextField();
	}
	
	public JTextField getTInfDerY(){
		return ((DoubleJTextInputPanel)pInfDer).getJTextField1();
	}
	
	public JTextField getTWidth(){
		return ((InputSizeDataPanel)((MethodDataInputPanel)getPMethod()).getPSouth()).getTWidth();
	}
	
	public JTextField getTHeight(){
		return ((InputSizeDataPanel)((MethodDataInputPanel)getPMethod()).getPSouth()).getTHeight();
	}
	
	public JComboBox getCbMeasureType(){
		return ((InputSizeDataPanel)((MethodDataInputPanel)getPMethod()).getPSouth()).getCbMeasureType();
	}
	
	public JTextField getTScale(){
		return ((InputScaleDataPanel)((MethodDataInputPanel)getPMethod()).getPEast()).getTScale();
	}
	
	public JComboBox getCbResolution(){
		return ((InputScaleDataPanel)((MethodDataInputPanel)getPMethod()).getPEast()).getCbResolution();
	}
	
	public JTextField getTMtsPixel(){
		return ((InputScaleDataPanel)((MethodDataInputPanel)getPMethod()).getPEast()).getTMtsPixel();
	}
	
	public JRadioButton getRbScale(){
		return ((MethodSaveRasterSelectorPanel)((MethodDataInputPanel)getPMethod()).getPWest()).getRbScale();
	}
	
	public JRadioButton getRbMtsPixel(){
		return ((MethodSaveRasterSelectorPanel)((MethodDataInputPanel)getPMethod()).getPWest()).getRbMtsPixel();
	}
	
	public JRadioButton getRbSize(){
		return ((MethodSaveRasterSelectorPanel)((MethodDataInputPanel)getPMethod()).getPWest()).getRbSize();
	}
	
	/**
	 * Obtiene el ancho en pixeles del recuadro seleccionado para su uso en 
	 * el calculo cuando la vista est en coordenadas geograficas
	 * @return ancho en pixeles de la seleccin
	 */
	public int getWidthInPixelsGeodesicas() {
		return widthInPixelsGeodesicas;
	}

	/**
	 * Asigna el ancho en pixeles del recuadro seleccionado para su uso en 
	 * el calculo cuando la vista est en coordenadas geograficas
	 * @param widthInPixelsGeodesicas ancho en pixeles de la seleccin
	 */
	public void setWidthInPixelsGeodesicas(int widthInPixelsGeodesicas) {
		this.widthInPixelsGeodesicas = widthInPixelsGeodesicas;
	}
	
	/**
	 * Obtiene el alto en pixeles del recuadro seleccionado para su uso en 
	 * el calculo cuando la vista est en coordenadas geograficas
	 * @return alto en pixeles de la seleccin
	 */
	public int getHeightInPixelsGeodesicas() {
		return heightInPixelsGeodesicas;
	}

	/**
	 * Asigna el alto en pixeles del recuadro seleccionado para su uso en 
	 * el calculo cuando la vista est en coordenadas geograficas
	 * @param heightInPixelsGeodesicas alto en pixeles de la seleccin
	 */
	public void setHeightInPixelsGeodesicas(int heightInPixelsGeodesicas) {
		this.heightInPixelsGeodesicas = heightInPixelsGeodesicas;
	}
	
	/**
	 * Asigna la proyeccin 
	 * @param proj Interfaz IProjection
	 */
	public void setProjection(IProjection proj){
		this.proj = proj;
	}
	
	/**
	 * Obtiene la proyeccin
	 * @return Interfaz IProjection
	 */
	public IProjection getProjection(){
		return proj;
	}
}
