/*
 * Creado el 7-marzo-2005
 */
package org.gvsig.rasterTools.saveRaster.ui.properties;

import java.awt.Container;
import java.awt.event.ActionEvent;

import javax.swing.JDialog;

import org.cresques.io.CXMLParser;
import org.cresques.io.GeoRasterWriter;
import org.gvsig.rasterTools.saveRaster.ui.main.SaveRasterDefaultPanel;



/**
 * Dialogo para abrir fichero.
 * @author Nacho Brodin (brodin_ign@gva.es)
 */
public class SaveRasterPropsDialog extends JDialog {
	
	//Ancho y alto ventana de propiedades de salvar a raster
	private int 						widthWindow=386;
	private int 						heightWindow=310;
	
	private SaveRasterPropsDialogPanel 	contentPane = null;  
	private GeoRasterWriter 			writer=null;
	private String 						formato = null;
	private String[]					properties = null;
	private SaveRasterDefaultPanel		parentDialog = null;
	
	/**
	 * Constructor
	 * @param writer
	 */
	public SaveRasterPropsDialog(GeoRasterWriter writer) {
		super();
		super.setModal(true);
		this.writer = writer;
		this.formato = writer.getIdent();
		//Obtenemos el tamao de la ventana del XML generado por el driver
		String xml = writer.getXMLPropertiesDialog();
		if(xml!=null){
			CXMLParser parser = new CXMLParser(xml);
			widthWindow = Integer.parseInt(parser.getAttr("window","sizex"));
			heightWindow = Integer.parseInt(parser.getAttr("window","sizey"));
		}
		initialize();
	}
	
	/**
	 * Inicializacin del dialogo	
	 * 	
	 * @return javax.swing.JDialog	
	 */    
	private void initialize() {
		setBounds(0, 0, widthWindow, heightWindow);  //Size Ventana
		setResizable(false);
		setName("saveRasterProps");
		setTitle("Propiedades de "+formato);
		setContentPane(getContentPane());
	 	//contentPane.getAcceptButton().setEnabled(false);
		contentPane.getAcceptButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	acceptButtonActionPerformed(evt);
                closeJDialog();
            }
        });
		contentPane.getCancelButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeJDialog();
            }
        });
		contentPane.getApplyButton().addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	acceptButtonActionPerformed(evt);
             }
        });
	}
	
	/**
	 * Asigna el dialogo padre a una variable.
	 * @param parentDialog	Cuadro de dialogo padre.
	 */
	public void setParentDialog(SaveRasterDefaultPanel parentDialog){
		this.parentDialog = parentDialog;
	}
	
	/**
	 * Inicializa contenPane	
	 * @return Container	
	 */    
	public Container getContentPane() {
		if (contentPane == null) {
			contentPane = new SaveRasterPropsDialogPanel(writer); 
		}
		return contentPane;
	}	
		
	public void closeJDialog() {
		this.hide();
	}
	
	
	/**
	 * Cuando se acepta se obtienen las propiedades seleccionadas
	 * @param e
	 */
    private void acceptButtonActionPerformed(ActionEvent e) {
    	if(((SaveRasterPropsDialogPanel)getContentPane()).getListener().getProperties() != null){            
    		properties = ((SaveRasterPropsDialogPanel)getContentPane()).getListener().getProperties();
    		//Salvamos las propiedades seleccionadas en el DriverProperties
    		parentDialog.driverProps.setProperties(writer.getIdent(), properties);
    	}	
    }
}  
