package com.iver.cit.gvsig.fmap.layers;

import java.util.Hashtable;
import java.util.Vector;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSLayerNode.java,v 1.4 2006/05/25 10:31:55 jorpiell Exp $
 * $Log: WFSLayerNode.java,v $
 * Revision 1.4  2006/05/25 10:31:55  jorpiell
 * Se ha renombrado la clase WFSFields por WFSAttributes porque era algo confusa
 *
 * Revision 1.3  2006/05/23 08:08:17  jorpiell
 * Eliminados los atributos innecesarios
 *
 * Revision 1.2  2006/04/20 16:38:24  jorpiell
 * Ahora mismo ya se puede hacer un getCapabilities y un getDescribeType de la capa seleccionada para ver los atributos a dibujar. Queda implementar el panel de opciones y hacer el getFeature().
 *
 * Revision 1.1  2006/04/19 12:50:16  jorpiell
 * Primer commit de la aplicacin. Se puede hacer un getCapabilities y ver el mensaje de vienvenida del servidor
 *
 *
 */
/**
 * This class represents one node of the layer tree of a
 * common WFS service.
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSLayerNode {
	private String	name = null;
	private String	title = null;
	private String	_abstract = null;
	private Vector fields = new Vector();
	private Vector selectedFields = new Vector();
	private String userName = "";

	
	/**
	 * @return Returns the fields.
	 */
	public Vector getFields() {
		return fields;
	}
	/**
	 * @param fields The fields to set.
	 */
	public void setFields(Vector fields) {
		this.fields = fields;
	}
	
	/**
	 * @param fields The fields to set.
	 */
	public void setFields(Object[] fields) {
		this.fields.clear();
		for (int i=0 ; i<fields.length ; i++){
			this.fields.add(fields[i]);
		}
	}
	
	
	/**
	 * 
	 */
	public String toString(){
		String str;
		if (getName()==null)
			str = getTitle();
		else
			str = "["+getName()+"] "+getTitle();
		return str;
	}
	/**
	 * @return Returns the _abstract.
	 */
	public String getAbstract() {
		return _abstract;
	}
	/**
	 * @param _abstract The _abstract to set.
	 */
	public void setAbstract(String _abstract) {
		this._abstract = _abstract;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		return title;
	}
	/**
	 * @param title The title to set.
	 */
	public void setTitle(String title) {
		this.title = title;
	}
	/**
	 * @return Returns the _abstract.
	 */
	public String get_abstract() {
		return _abstract;
	}
	/**
	 * @param _abstract The _abstract to set.
	 */
	public void set_abstract(String _abstract) {
		this._abstract = _abstract;
	}	
	/**
	 * @return Returns the userName.
	 */
	public String getUserName() {
		return userName;
	}
	/**
	 * @param userName The userName to set.
	 */
	public void setUserName(String userName) {
		this.userName = userName;
	}
	/**
	 * @return Returns the selectedFields.
	 */
	public Vector getSelectedFields() {
		return selectedFields;
	}
	/**
	 * @param selectedFields The selectedFields to set.
	 */
	public void setSelectedFields(Vector selectedFields) {
		this.selectedFields = selectedFields;
	}
	
	/**
	 * @param fields The fields to set.
	 */
	public void setSelectedFields(Object[] selectedFields) {
		this.selectedFields.clear();
		for (int i=0 ; i<selectedFields.length ; i++){
			this.selectedFields.add(selectedFields[i]);
		}
	}
	
	
	
	
}
