package com.iver.cit.gvsig.gui.panels;

import java.awt.Rectangle;
import java.text.NumberFormat;

import javax.swing.BorderFactory;
import javax.swing.JFormattedTextField;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;

import com.iver.andami.PluginServices;
import com.iver.utiles.StringUtilities;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSOptionsPanel.java,v 1.3 2006/05/23 08:09:39 jorpiell Exp $
 * $Log: WFSOptionsPanel.java,v $
 * Revision 1.3  2006/05/23 08:09:39  jorpiell
 * Se ha cambiado la forma en la que se leian los valores seleccionados en los paneles y se ha cambiado el comportamiento de los botones
 *
 * Revision 1.2  2006/05/19 12:57:08  jorpiell
 * Modificados algunos paneles
 *
 * Revision 1.1  2006/04/20 16:38:24  jorpiell
 * Ahora mismo ya se puede hacer un getCapabilities y un getDescribeType de la capa seleccionada para ver los atributos a dibujar. Queda implementar el panel de opciones y hacer el getFeature().
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSOptionsPanel extends JPanel{

	private JPanel credentialsPanel = null;
	private JLabel usernameLabel = null;
	private JTextField usernameText = null;
	private JLabel passwordLabel = null;
	private JPasswordField passwordText = null;
	private JPanel connectionParamsPanel = null;
	private JLabel timeoutLabel = null;
	private JFormattedTextField bufferText = null;
	private JLabel bufferLabel = null;
	private JFormattedTextField timeOutText = null;
	/**
	 * This method initializes 
	 * 
	 */
	public WFSOptionsPanel() {
		super();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 */
	private void initialize() {
		this.setLayout(null);
		this.setBounds(10, 5, 481, 427);
		this.add(getCredentialsPanel(), null);
		this.add(getConnectionParamsPanel(), null);
			
	}

	/**
	 * This method initializes credentialsPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getCredentialsPanel() {
		if (credentialsPanel == null) {
			passwordLabel = new JLabel();
			passwordLabel.setBounds(new java.awt.Rectangle(10,25,85,16));
			passwordLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			passwordLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
			passwordLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			passwordLabel.setText(PluginServices.getText(this, "username"));
			usernameLabel = new JLabel();
			usernameLabel.setBounds(new java.awt.Rectangle(10,50,85,16));
			usernameLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			usernameLabel.setText(PluginServices.getText(this, "pwd"));
			credentialsPanel = new JPanel();
			credentialsPanel.setLayout(null);
			credentialsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(
					null, PluginServices.getText(this, "credentials"),
					javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
					javax.swing.border.TitledBorder.DEFAULT_POSITION, null, null));
			credentialsPanel.setLocation(new java.awt.Point(4,5));
			credentialsPanel.setSize(new java.awt.Dimension(457,80));
			credentialsPanel.add(usernameLabel, null);
			credentialsPanel.add(getUsernameText(), null);
			credentialsPanel.add(passwordLabel, null);
			credentialsPanel.add(getPasswordText(), null);
			
		}
		return credentialsPanel;
	}

	/**
	 * This method initializes usernameText	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getUsernameText() {
		if (usernameText == null) {
			usernameText = new JTextField();
			usernameText.setBounds(new java.awt.Rectangle(100,25,200,20));
		}
		return usernameText;
	}

	/**
	 * This method initializes passwordText	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JPasswordField getPasswordText() {
		if (passwordText == null) {
			passwordText = new JPasswordField();
			passwordText.setBounds(new java.awt.Rectangle(100,50,200,20));
		}
		return passwordText;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getConnectionParamsPanel() {
		if (connectionParamsPanel == null) {
			bufferLabel = new JLabel();
			bufferLabel.setBounds(new Rectangle(10, 25, 85, 16));
			bufferLabel.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
			bufferLabel.setText(PluginServices.getText(this, "buffer"));
			bufferLabel.setVerticalAlignment(javax.swing.SwingConstants.TOP);
			bufferLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			timeoutLabel = new JLabel();
			timeoutLabel.setBounds(new Rectangle(10, 50, 85, 16));
			timeoutLabel.setText(PluginServices.getText(this, "timeout"));
			timeoutLabel.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
			connectionParamsPanel = new JPanel();
			connectionParamsPanel.setLayout(null);
			connectionParamsPanel.setBounds(new java.awt.Rectangle(5,95,457,80));
			connectionParamsPanel.setBorder(BorderFactory.createTitledBorder(null, PluginServices.getText(this, "conection"), TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));
			connectionParamsPanel.add(timeoutLabel, null);
			connectionParamsPanel.add(getBufferText(), null);
			connectionParamsPanel.add(bufferLabel, null);
			connectionParamsPanel.add(getTimeOutText(), null);
		}
		return connectionParamsPanel;
	}

	/**
	 * This method initializes jTextField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JFormattedTextField getBufferText() {
		if (bufferText == null) {
			bufferText = new JFormattedTextField(NumberFormat.getIntegerInstance());
			bufferText.setValue(new Integer(100));
			bufferText.setBounds(new Rectangle(100, 25, 70, 20));
		}
		return bufferText;
	}

	/**
	 * This method initializes jTextField1	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JFormattedTextField getTimeOutText() {
		if (timeOutText == null) {
			timeOutText = new JFormattedTextField(NumberFormat.getIntegerInstance());
			timeOutText.setValue(new Integer(10000));
			timeOutText.setBounds(new Rectangle(100, 50, 70, 20));
		}
		return timeOutText;
	}

	/**
	 * 
	 * @return the username
	 */
	public String getUserName(){
		return getUsernameText().getText();
	}
	
	/**
	 * 
	 * @return the password
	 */
	public String getPassword(){
		return getPasswordText().getText();
	}
	
	/**
	 * 
	 * @return the buffer
	 */
	public int getBuffer(){
		String buffer = StringUtilities.replace(getBufferText().getText(),".","");
		return Integer.parseInt(buffer);
	}
	
	/**
	 * 
	 * @return the timeout
	 */
	public int getTimeout(){
		String timeOut = StringUtilities.replace(getTimeOutText().getText(),".","");
		return Integer.parseInt(timeOut);
	}
}
