package org.cresques.ui.raster;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JRadioButton;

import org.cresques.io.raster.TransparencyRange;


public class TransparencyByPixelListener implements ActionListener {

	private TransparencyByPixelPanel 	panel = null;
	private RGBInputPanel				rgbInputPanel = null;
	private	JList						list = null;
	private JButton						addButton = null;
	private JButton						removeButton = null;
	private JRadioButton				andRb = null;
	private JRadioButton				orRb = null;
	private ArrayList					entries = new ArrayList();
	
	/**
	 * This is the default constructor
	 */
	public TransparencyByPixelListener(TransparencyByPixelPanel panel) {
		this.panel = panel;
		rgbInputPanel = ((RGBInputPanel)panel.getPRGBInput());
		list = panel.getJList();
		
		addButton = ((AddRemoveButtonsPanel)panel.getPButtons()).getBAdd();
		removeButton = ((AddRemoveButtonsPanel)panel.getPButtons()).getBRemove();
		andRb = ((AndOrSelectorPanel)panel.getPOperation()).getRbAnd();
		orRb = ((AndOrSelectorPanel)panel.getPOperation()).getRbOr();
		
		addButton.addActionListener(this);
		removeButton.addActionListener(this);
		andRb.addActionListener(this);
		orRb.addActionListener(this);
	}

	//*******************************
	//ActionListener
	
	public void actionPerformed(ActionEvent e) {
		
		//Aade elementos a la lista
		if(e.getSource() == addButton){
			if(rgbInputPanel.isValidValue()){
				TransparencyRange entry = new TransparencyRange();
				entry.setRed(rgbInputPanel.getRangeRed());
				entry.setGreen(rgbInputPanel.getRangeGreen());
				entry.setBlue(rgbInputPanel.getRangeBlue());
								
				String textR = rgbInputPanel.getTRed().getText();
				if(textR.equals(""))
					textR = "*";
				String textG = rgbInputPanel.getTGreen().getText();
				if(textG.equals(""))
					textG = "*";
				String textB = rgbInputPanel.getTBlue().getText();
				if(textB.equals(""))
					textB = "*";
				if(andRb.isSelected()){	
					entry.setStrEntry(textR+" & "+textG+" & "+textB);
					entry.setAnd(true);
				}
				
				if(orRb.isSelected()){
					entry.setStrEntry(textR+" | "+textG+" | "+textB);
					entry.setAnd(false);
				}
				panel.getListModel().addElement(entry.getStrEntry());
				entries.add(entry);
				
				//Limpiamos los textField
				rgbInputPanel.getTRed().setText("");
				rgbInputPanel.getTGreen().setText("");
				rgbInputPanel.getTBlue().setText("");
			}
		}
		
		//Elimina elementos de la lista
		if(e.getSource() == removeButton){
			if(list.getSelectedIndex() != -1){
				String rule = (String)panel.getListModel().get(list.getSelectedIndex());
				String[] s = rule.split(" & ");
				if(s.length < 3){
					s = rule.split(" \\| ");
					andRb.setSelected(false);
					orRb.setSelected(true);
				}else{
					andRb.setSelected(true);
					orRb.setSelected(false);
				}
				
				for(int i=0;i<s.length;i++){
					if(s[i].equals("*"))
						s[i] = "";
				}
				
				if(s.length == 3){
					rgbInputPanel.getTRed().setText(s[0].trim());	
					rgbInputPanel.getTGreen().setText(s[1].trim());
					rgbInputPanel.getTBlue().setText(s[2].trim());
					
					for(int i=0;i<entries.size();i++){
						if( ((TransparencyRange)entries.get(i)).getStrEntry().equals(rule) )
							entries.remove(i);
					}
					panel.getListModel().remove(list.getSelectedIndex());
				}
			}
		}
	}
	
	/**
	 * Obtiene el array de entradas de valores aadidos a la lista
	 * @return ArrayList
	 */
	public ArrayList getEntries(){
		return entries;
	}
	
	/**
	 * Asigna el array de entradas de valores aadidos a la lista
	 * @param list ArrayList
	 */
	public void setEntries(ArrayList list){
		entries = list;
	}
}
