package org.cresques.ui.raster;

import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.ArrayList;

import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JPanel;

public class TransparencyByPixelPanel extends JPanel {

	private JPanel 							pBorder = null;
	private RGBInputPanel 					pWest = null;
	private JPanel 							pEast = null;
	private JPanel 							pCenter = null;
	private AddRemoveButtonsPanel 			pButtons = null;
	private AndOrSelectorPanel 				pOperation = null;
	private JList 							jList = null;
	private TransparencyByPixelListener 	listener = null;	
	private DefaultListModel				listModel = null;
	private boolean							controlEnabled = false;					
		
	/**
	 * This is the default constructor
	 */
	public TransparencyByPixelPanel() {
		super();
		initialize();
		listener = new TransparencyByPixelListener(this);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(410, 118);
		this.add(getPBorder(), null);
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPBorder() {
		if (pBorder == null) {
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.insets = new java.awt.Insets(0,15,0,0);
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
			gridBagConstraints2.gridx = 0;
			gridBagConstraints2.gridheight = 1;
			gridBagConstraints2.insets = new java.awt.Insets(0,0,0,15);
			gridBagConstraints2.gridy = 0;
			pBorder = new JPanel();
			pBorder.setLayout(new GridBagLayout());
			pBorder.setPreferredSize(new java.awt.Dimension(410,118));
			pBorder.add(getPRGBInput(), gridBagConstraints2);
			pBorder.add(getPCenter(), new GridBagConstraints());
			pBorder.add(getPList(), gridBagConstraints4);
		}
		return pBorder;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public RGBInputPanel getPRGBInput() {
		if (pWest == null) {
			FlowLayout flowLayout = new FlowLayout();
			flowLayout.setHgap(1);
			flowLayout.setVgap(1);
			pWest = new RGBInputPanel();
			pWest.setLayout(flowLayout);
			pWest.setPreferredSize(new java.awt.Dimension(90,80));
		}
		return pWest;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPList() {
		if (pEast == null) {
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
			gridBagConstraints3.fill = java.awt.GridBagConstraints.BOTH;
			gridBagConstraints3.gridx = 0;
			gridBagConstraints3.gridy = 0;
			gridBagConstraints3.weightx = 1.0;
			gridBagConstraints3.weighty = 1.0;
			gridBagConstraints3.insets = new java.awt.Insets(0,0,0,0);
			pEast = new JPanel();
			pEast.setLayout(new GridBagLayout());
			pEast.setPreferredSize(new java.awt.Dimension(170,110));
			pEast.setBorder(javax.swing.BorderFactory.createEtchedBorder(javax.swing.border.EtchedBorder.RAISED));
			pEast.add(getJList(), gridBagConstraints3);
		}
		return pEast;
	}

	/**
	 * This method initializes jPanel2	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getPCenter() {
		if (pCenter == null) {
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
			gridBagConstraints1.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints1.gridy = 1;
			gridBagConstraints1.gridx = 0;
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.insets = new java.awt.Insets(0,0,0,0);
			gridBagConstraints.gridy = 0;
			gridBagConstraints.gridx = 0;
			pCenter = new JPanel();
			pCenter.setLayout(new GridBagLayout());
			pCenter.setPreferredSize(new java.awt.Dimension(60,115));
			pCenter.add(getPButtons(), gridBagConstraints);
			pCenter.add(getPOperation(), gridBagConstraints1);
		}
		return pCenter;
	}

	/**
	 * This method initializes jPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPButtons() {
		if (pButtons == null) {
			pButtons = new AddRemoveButtonsPanel();
			pButtons.setPreferredSize(new java.awt.Dimension(60,63));
		}
		return pButtons;
	}

	/**
	 * This method initializes jPanel1	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	public JPanel getPOperation() {
		if (pOperation == null) {
			pOperation = new AndOrSelectorPanel();
			pOperation.setPreferredSize(new java.awt.Dimension(60,50));
		}
		return pOperation;
	}

	/**
	 * This method initializes jList	
	 * 	
	 * @return javax.swing.JList	
	 */
	public JList getJList() {
		if (jList == null) {
			listModel = new DefaultListModel();
			jList = new JList(listModel);
			//jList.setPreferredSize(new java.awt.Dimension(120,110));
			jList.setSize(new java.awt.Dimension(135,125));
			jList.setFont(new java.awt.Font("Monospaced", java.awt.Font.PLAIN, 10));
		}
		return jList;
	}
	
	/**
	 * Obtiene el ListModel de la lista
	 * @return DefaultListModel
	 */
	public DefaultListModel getListModel(){
		return listModel;
	}
	
	/**
	 * Activa o desactiva el control
	 * @param enable True activa el control y false lo desactiva
	 */
	public void setControlEnabled(boolean enabled){
		jList.setEnabled(enabled);
		if(enabled)
			jList.setBackground(Color.WHITE);
		else
			jList.setBackground(this.getBackground());
		pWest.setControlEnabled(enabled);
		pButtons.setControlEnabled(enabled);
		pOperation.setControlEnabled(enabled);
		controlEnabled = enabled;
	}
	
	/**
	 * Obtiene true si el control est activo y false si no lo est
	 * @return
	 */
	public boolean isControlEnabled(){
		return controlEnabled;
	}
	
	/**
	 * Asigna el nmero de bandas activas 
	 * @param n Nmero de bandas
	 */
	public void setActiveBands(int n){
		((RGBInputPanel)getPRGBInput()).setActiveBands(n);
	}
	
	/**
	 * Obtiene el array de entradas de valores aadidos a la lista
	 * @return ArrayList
	 */
	public ArrayList getEntries(){
		return listener.getEntries();
	}
	
	/**
	 * Asigna el array de entradas de valores aadidos a la lista
	 * @return ArrayList
	 */
	public void setEntries(ArrayList list){
		this.listener.setEntries(list);
	}

	/**
	 * Obtiene la clase manejadora de eventos asociada a esta
	 * @return TransparencyByPixelListener
	 */
	public TransparencyByPixelListener getListener() {
		return listener;
	}

}
