package com.iver.cit.gvsig.fmap.core;

import org.geotools.styling.Fill;
import org.geotools.styling.GraphicImpl;
import org.geotools.styling.LineSymbolizer;
import org.geotools.styling.Mark;
import org.geotools.styling.PointSymbolizer;
import org.geotools.styling.PolygonSymbolizer;
import org.geotools.styling.StrokeImpl;
import org.geotools.styling.StyleBuilder;
import org.geotools.styling.StyleFactory;
import org.geotools.styling.Symbolizer;

import com.iver.cit.gvsig.fmap.core.v02.FConstant;
import com.iver.cit.gvsig.fmap.core.v02.FSymbol;

/**
 * utility class for SLD functionality
 * @author laura
 */
public class SLDUtils {
	
	public static String convertColorToHexString(java.awt.Color c)
	{
		String str = Integer.toHexString( c.getRGB() & 0xFFFFFF );
		return ( "#" + "000000".substring( str.length() ) + str.toUpperCase() );
	}
	public String getWellKnownName(int symbolType)
	{
		return "";
	}
	
    public static Symbolizer toGeotoolsSymbol(FSymbol symbol)
    {
    	StyleFactory styleFactory = StyleFactory.createStyleFactory();
		StyleBuilder styleBuilder = new StyleBuilder();			
		StrokeImpl theStroke = (StrokeImpl)styleBuilder.createStroke();
		GraphicImpl graphic = (GraphicImpl)styleBuilder.createGraphic(); 
    	try
    	{
    		switch (symbol.getSymbolType()) 
    		{    		
				case FConstant.SYMBOL_TYPE_POINT:								
					PointSymbolizer point = styleFactory.createPointSymbolizer();
					graphic.setSize(symbol.getSize());					
					Mark[] mark = new Mark[1];
					mark[0] = styleFactory.createMark();
					//
					//mark[0].setWellKnownName( getWellKnownName(symbol.getStyle()));
					graphic.setMarks(mark);
					
					// add, color, graphic, size, ...
					return point;					
				case FConstant.SYMBOL_TYPE_LINE:
					LineSymbolizer line = styleFactory.createLineSymbolizer();					
					theStroke.setColor(convertColorToHexString(symbol.getColor()));					
					line.setStroke(theStroke);
					return line;
				case FConstant.SYMBOL_TYPE_FILL:
					PolygonSymbolizer polygon = styleFactory.createPolygonSymbolizer();
					Fill theFill = styleBuilder.createFill(symbol.getColor());
					//theFill.setOpacity();
					polygon.setFill( theFill );										
					//theStroke.setColor(symbol.getOutlineColor());
					return polygon;
				case FShape.MULTI:
					// To implement: ver que clase de simbolo corresponde					
					return null;
    		}    
    		return null;
    	}
    	catch(Exception e)
    	{
    		e.printStackTrace();
    		return null;
    	}    	
    }	
}
