/*
 * Created on 26-oct-2005
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 * 
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *  
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 * 
 *    or
 * 
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 * 
 *   +34 963163400
 *   dac@iver.es
 */
package com.iver.cit.gvsig.fmap.drivers;

import com.iver.cit.gvsig.fmap.core.FShape;

/**
 * @author fjp
 *
 */
public abstract class LayerDefinition implements ILayerDefinition {
	protected String layerName = null;

	protected FieldDescription[] fieldsDesc = null;

	protected int shapeType = FShape.MULTI;

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.iver.cit.gvsig.fmap.drivers.ITableDefinition#getName()
	 */
	public String getName() {
		return layerName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.iver.cit.gvsig.fmap.drivers.ITableDefinition#setName(java.lang.String)
	 */
	public void setName(String layerName) {
		this.layerName = layerName;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.iver.cit.gvsig.fmap.drivers.ITableDefinition#getFieldsDesc()
	 */
	public FieldDescription[] getFieldsDesc() {
		return fieldsDesc;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see com.iver.cit.gvsig.fmap.drivers.ITableDefinition#setFieldsDesc(com.iver.cit.gvsig.fmap.drivers.FieldDescription[])
	 */
	public void setFieldsDesc(FieldDescription[] fieldsDesc) {
		this.fieldsDesc = fieldsDesc;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.drivers.ILayerDefinition#getShapeType()
	 */
	public int getShapeType() {
		return shapeType;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.drivers.ILayerDefinition#setShapeType(int)
	 */
	public void setShapeType(int shapeType) {
		this.shapeType = shapeType;
	}

}
