/*
 * Created on 12-ene-2006 by fjp
 *
 * gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: VectorialEditableAdapter.java,v 1.52 2006/05/24 09:29:30 caballero Exp $
 * $Log: VectorialEditableAdapter.java,v $
 * Revision 1.52  2006/05/24 09:29:30  caballero
 * aadir flatness
 *
 * Revision 1.51  2006/05/16 16:07:19  fjp
 * snapping. Revisar
 *
 * Revision 1.50  2006/05/16 07:07:46  caballero
 * Modificar la geometra desde fuera
 *
 * Revision 1.49  2006/05/15 10:52:23  caballero
 * Saber si se realiza una operacin desde la vista o desde la tabla.
 *
 * Revision 1.48  2006/05/09 15:58:37  caballero
 * Para el IGN
 *
 * Revision 1.47  2006/05/09 10:28:28  caballero
 * faltaba controlar undo y redo
 *
 * Revision 1.46  2006/04/27 06:44:56  caballero
 * Solucin undo y redo de anotaciones
 *
 * Revision 1.45  2006/04/18 06:56:55  caballero
 * Cambiar VectorialAdapter por ReadableVectorial
 *
 * Revision 1.44  2006/04/12 17:13:39  fjp
 * *** empty log message ***
 *
 * Revision 1.43  2006/04/11 12:12:29  fjp
 * Con edicin en PostGIS y guardando pseudo-arcos en los shapes.
 *
 * Revision 1.42  2006/04/11 06:53:20  fjp
 * Preparando el driver de escritura PostGIS
 *
 * Revision 1.41  2006/04/04 11:27:16  fjp
 * Consola escuchando bien y seleccin en tabla sincronizada cuando hay edicin
 *
 * Revision 1.40  2006/04/03 11:04:48  caballero
 * Posibilidad de aadir una anotacin
 *
 * Revision 1.39  2006/03/29 06:26:37  caballero
 * acelerar con una imagen las herramientas
 *
 * Revision 1.38  2006/03/23 16:20:52  fjp
 * Un fallo un tanto inverosimil con el mapOverview
 *
 * Revision 1.37  2006/03/23 10:08:11  caballero
 * calculo del fullExtent recorriendo todas las geometras
 *
 * Revision 1.36  2006/03/22 11:46:29  caballero
 * Editar capa de anotaciones
 *
 * Revision 1.35  2006/02/28 18:15:22  fjp
 * Consola de CAD
 *
 * Revision 1.34  2006/02/24 11:30:32  fjp
 * FUNCIONA!!! (Creo)
 *
 * Revision 1.33  2006/02/24 07:57:58  fjp
 * FUNCIONA!!! (Creo)
 *
 * Revision 1.32  2006/02/23 17:55:45  fjp
 * Preparando para poder editar con el EditionManager
 *
 * Revision 1.31  2006/02/21 16:44:08  fjp
 * Preparando para poder editar con el EditionManager
 *
 * Revision 1.30  2006/02/20 18:14:59  fjp
 * Preparando para poder editar con el EditionManager
 *
 * Revision 1.29  2006/02/20 10:32:54  fjp
 * Preparando para poder editar con el EditionManager
 *
 * Revision 1.28  2006/02/17 13:40:03  fjp
 * Preparando para poder editar con el EditionManager
 *
 * Revision 1.27  2006/02/17 10:41:14  fjp
 * Evento de edicin lanzado cuando una capa se pone en edicin
 *
 * Revision 1.26  2006/02/17 08:21:19  fjp
 * *** empty log message ***
 *
 * Revision 1.25  2006/02/16 09:38:10  fjp
 * Preparando compatibilidad para bases de datos (y de paso, acelerando :-)
 *
 * Revision 1.24  2006/02/16 09:06:28  caballero
 * commandStack
 *
 * Revision 1.23  2006/02/15 18:16:02  fjp
 * POR TERMINAR
 *
 * Revision 1.22  2006/02/13 18:18:31  fjp
 * POR TERMINAR
 *
 * Revision 1.21  2006/02/10 13:28:23  caballero
 * poder cambiar la seleccin
 *
 * Revision 1.20  2006/02/09 13:11:54  caballero
 * *** empty log message ***
 *
 * Revision 1.19  2006/02/08 16:45:29  caballero
 * elimnar cdio no usado
 *
 * Revision 1.18  2006/02/08 15:18:45  caballero
 * control de las rows eliminadas
 *
 * Revision 1.17  2006/02/07 10:18:44  caballero
 * Con BoundedShape
 *
 * Revision 1.16  2006/02/06 12:01:41  caballero
 * driver del ova
 *
 * Revision 1.15  2006/02/03 14:09:32  fjp
 * Preparando edicin
 *
 * Revision 1.14  2006/02/03 12:16:33  fjp
 * Preparando edicin
 *
 * Revision 1.13  2006/02/03 11:54:12  caballero
 * tablas con vectorialEditableAdapter en edicin
 *
 * Revision 1.11  2006/01/31 08:10:05  caballero
 * cambio de feature a row
 *
 * Revision 1.10  2006/01/30 08:18:14  caballero
 * mtodos para deshacer y rehacer
 *
 * Revision 1.9  2006/01/23 17:30:28  caballero
 * coger los datos del ova
 *
 * Revision 1.8  2006/01/23 16:16:16  caballero
 * getRowIndex
 *
 * Revision 1.7  2006/01/20 08:37:10  fjp
 * Preparando la edicin
 *
 * Revision 1.6  2006/01/19 12:48:20  caballero
 * poder modificar su vectorial Adapter
 *
 * Revision 1.5  2006/01/19 09:28:11  fjp
 * Preparando la edicin
 *
 * Revision 1.4  2006/01/17 10:24:02  fjp
 * Preparando edicin
 *
 * Revision 1.3  2006/01/16 12:47:38  fjp
 * Preparando edicin
 *
 * Revision 1.2  2006/01/16 11:23:00  fjp
 * Preparando edicin
 *
 * Revision 1.1  2006/01/12 13:39:14  fjp
 * preaparar edicion
 *
 *
 */
package com.iver.cit.gvsig.fmap.edition;

import java.awt.Image;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.List;

import com.hardcode.driverManager.DriverLoadException;
import com.hardcode.gdbms.engine.data.DataSource;
import com.hardcode.gdbms.engine.values.Value;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.DefaultFeature;
import com.iver.cit.gvsig.fmap.core.FShape;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.IRow;
import com.iver.cit.gvsig.fmap.core.v02.FConverter;
import com.iver.cit.gvsig.fmap.drivers.BoundedShapes;
import com.iver.cit.gvsig.fmap.drivers.DriverAttributes;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.VectorialDriver;
import com.iver.cit.gvsig.fmap.layers.FBitSet;
import com.iver.cit.gvsig.fmap.layers.ReadableVectorial;
import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.index.SpatialIndex;
import com.vividsolutions.jts.index.quadtree.Quadtree;

/**
 * @author fjp
 *
 */
public class VectorialEditableAdapter extends EditableAdapter implements
		ReadableVectorial, BoundedShapes {
	protected ReadableVectorial ova;

	protected Quadtree index;

	protected Rectangle2D fullExtent;

	protected Image selectionImage;

	protected BufferedImage handlersImage;

	private double flatness=0.8;
	/*
	 * private class MyFeatureIterator implements IFeatureIterator { int numReg =
	 * 0; Rectangle2D rect; String epsg; IFeatureIterator origFeatIt; boolean
	 * bHasNext = true;
	 *
	 * public MyFeatureIterator(Rectangle2D r, String strEPSG) throws
	 * DriverException { rect = r; epsg = strEPSG; origFeatIt =
	 * ova.getFeatureIterator(r, epsg); } public boolean hasNext() throws
	 * DriverException { return bHasNext; }
	 *
	 * public IFeature next() throws DriverException { IFeature aux =
	 * origFeatIt.next(); return null; }
	 *
	 * public void closeIterator() throws DriverException {
	 *  }
	 *  }
	 */

	public VectorialEditableAdapter() {
		super();
	}

	public void setOriginalVectorialAdapter(ReadableVectorial rv) {
		ova = rv;
		try {
			setOriginalDataSource(rv.getRecordset());
		} catch (DriverLoadException e) {
			e.printStackTrace();
		}
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#start()
	 */
	public void start() throws DriverIOException {
		ova.start();
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#stop()
	 */
	public void stop() throws DriverIOException {
		ova.stop();
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#getShape(int)
	 */
	public IGeometry getShape(int rowIndex) throws DriverIOException {
		// Si no est en el fichero de expansin
		int calculatedIndex = getCalculatedIndex(rowIndex);
		Integer integer = new Integer(calculatedIndex);
		if (!relations.containsKey(integer)) {
			// Si ha sido eliminada
			/*
			 * if (delRows.get(integer.intValue())) { return null; } else {
			 */
			return ova.getShape(calculatedIndex);
			// }
		} else {
			int num = ((Integer) relations.get(integer)).intValue();
			DefaultRowEdited feat;
			try {
				feat = (DefaultRowEdited) expansionFile.getRow(num);
				return ((IFeature) feat.getLinkedRow()).getGeometry()
						.cloneGeometry();// getGeometry();
			} catch (IOException e) {
				e.printStackTrace();
				throw new DriverIOException(e);
			}
		}

	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#getShapeType()
	 */
	public int getShapeType() throws DriverIOException {
		return ova.getShapeType();
	}

	public ReadableVectorial getOriginalAdapter() {
		return ova;
	}

	public VectorialDriver getDriver() {
		return ova.getDriver();
	}

	public void setDriver(VectorialDriver driver) {
		this.ova.setDriver(driver);
	}

	public DriverAttributes getDriverAttributes() {
		return ova.getDriverAttributes();
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @throws EditionException
	 *             DOCUMENT ME!
	 */
	public void startEdition(int sourceType) throws EditionException {
		super.startEdition(sourceType);

		try {
			expansionFile.open();
			if (index == null || fullExtent == null) {
				// TODO: Si la capa dispone de un ndice espacial, hacer
				// algo aqu para que se use ese ndice espacial.
				index = new Quadtree();

				for (int i = 0; i < ova.getShapeCount(); i++) {
					IGeometry g = null;
					try {
						g = ((DefaultFeature) ova.getFeature(i)).getGeometry();
					} catch (DriverException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}

					if (g == null) {
						continue;
					}

					Rectangle2D r = g.getBounds2D();
					Envelope e = new Envelope(r.getX(),
							r.getX() + r.getWidth(), r.getY(), r.getY()
									+ r.getHeight());
					index.insert(e, new Integer(i));
					if (fullExtent == null) {
						fullExtent = r;
					} else {
						fullExtent = fullExtent.createUnion(r);
					}
				}
			}
		} catch (DriverIOException e) {
			throw new EditionException(e);
		} catch (IOException e) {
			throw new EditionException(e);
		}

		System.err.println("Se han metido en el ndice "
				+ index.queryAll().size() + " geometras");
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.edition.IEditableSource#getRow(int)
	 */
	public IRowEdited getRow(int index) throws DriverIOException, IOException {
		int calculatedIndex = getCalculatedIndex(index);
		Integer integer = new Integer(calculatedIndex);
		// Si no est en el fichero de expansin
		DefaultRowEdited edRow = null;
		if (!relations.containsKey(integer)) {
			try {
				edRow = new DefaultRowEdited(ova.getFeature(calculatedIndex),
						DefaultRowEdited.STATUS_ORIGINAL, index);
				// /System.out.println("Piden la feature con ID= " + index);
				/*
				 * Exception e = new Exception(); e.printStackTrace();
				 */
			} catch (DriverException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			return edRow;
		} else {
			int num = ((Integer) relations.get(integer)).intValue();
			IRowEdited aux = expansionFile.getRow(num);
			edRow = new DefaultRowEdited(aux.getLinkedRow().cloneRow(), aux
					.getStatus(), index);
			return edRow;
		}
	}

	/**
	 * Elimina una geometria. Si es una geometra original de la capa en edicin
	 * se marca como eliminada (haya sido modificada o no). Si es una geometra
	 * aadida posteriormente se invalida en el fichero de expansin, para que
	 * una futura compactacin termine con ella.
	 *
	 * @param index
	 *            ndice de la geometra.
	 *
	 * @throws DriverIOException
	 * @throws IOException
	 */
	public IRow doRemoveRow(int index, int sourceType)
			throws DriverIOException, IOException {
		boolean cancel = fireBeforeRemoveRow(index, sourceType);
		if (cancel)
			return null;
		// Llega el calculatedIndex
		Integer integer = new Integer(index);

		IFeature feat = null;
		delRows.set(index, true);
		// Si la geometra no ha sido modificada
		if (!relations.containsKey(integer)) {

			try {
				feat = (DefaultFeature) (ova.getFeature(index));
			} catch (DriverException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {
			int num = ((Integer) relations.get(integer)).intValue();
			feat = (IFeature) expansionFile.getRow(num).getLinkedRow();
			// expansionFile.invalidateRow(num);
		}
		System.err.println("Elimina una Row en la posicin: " + index);
		// Se actualiza el ndice
		if (feat != null) {
			Rectangle2D r = feat.getGeometry().getBounds2D();
			boolean borrado = this.index.remove(new Envelope(r.getX(), r.getX()
					+ r.getWidth(), r.getY(), r.getY() + r.getHeight()),
					new Integer(index));
			System.out.println("Est borrado : " + borrado);
			System.out.println("Index.lenght : " + this.index.size());

		}
		setSelection(new FBitSet());
		fireAfterRemoveRow(index, sourceType);
		return feat;
	}

	/**
	 * Si se intenta modificar una geometra original de la capa en edicin se
	 * aade al fichero de expansin y se registra la posicin en la que se
	 * aadi. Si se intenta modificar una geometria que se encuentra en el
	 * fichero de expansin (por ser nueva o original pero modificada) se invoca
	 * el mtodo modifyGeometry y se actualiza el ndice de la geometria en el
	 * fichero.
	 *
	 * @param calculatedIndex
	 *            DOCUMENT ME!
	 * @param feat
	 *            DOCUMENT ME!
	 *
	 * @return position inside ExpansionFile
	 *
	 * @throws IOException
	 * @throws DriverIOException
	 */
	public int doModifyRow(int calculatedIndex, IRow feat, int sourceType)
			throws IOException, DriverIOException {
		boolean cancel = fireBeforeModifyRow(feat, calculatedIndex, sourceType);
		if (cancel)
			return -1;
		int posAnteriorInExpansionFile = -1;
		Integer integer = new Integer(calculatedIndex);

		IFeature featAnt = null;
		System.err.println("Modifica una Row en la posicin: "
				+ calculatedIndex);
		// Si la geometra no ha sido modificada
		if (!relations.containsKey(integer)) {
			int newPosition = expansionFile.addRow(feat,
					IRowEdited.STATUS_MODIFIED);
			relations.put(integer, new Integer(newPosition));

			// Se actualiza el ndice espacial
			try {
				featAnt = (DefaultFeature) (ova.getFeature(calculatedIndex));
			} catch (DriverException e) {
				e.printStackTrace();
			}
			IGeometry g = featAnt.getGeometry();
			Rectangle2D rAnt = g.getBounds2D();
			Rectangle2D r = ((IFeature) feat).getGeometry().getBounds2D();
			this.index.remove(new Envelope(rAnt.getX(), rAnt.getX()
					+ rAnt.getWidth(), rAnt.getY(), rAnt.getY()
					+ rAnt.getHeight()), new Integer(calculatedIndex));
			this.index.insert(new Envelope(r.getX(), r.getX() + r.getWidth(), r
					.getY(), r.getY() + r.getHeight()), new Integer(
					calculatedIndex));
		} else {
			// Obtenemos el ndice en el fichero de expansin
			int num = ((Integer) relations.get(integer)).intValue();
			posAnteriorInExpansionFile = num;

			// Obtenemos la geometra para actualiza el ndice
			// espacialposteriormente
			featAnt = (IFeature) expansionFile.getRow(num).getLinkedRow();

			/*
			 * Se modifica la geometra y nos guardamos el ndice dentro del
			 * fichero de expansin en el que se encuentra la geometra
			 * modificada
			 */
			num = expansionFile.modifyRow(num, feat);

			/*
			 * Actualiza la relacin del ndice de la geometra al ndice en el
			 * fichero de expansin.
			 */
			relations.put(integer, new Integer(num));

			// Se modifica el ndice espacial
			Rectangle2D rAnt = featAnt.getGeometry().getBounds2D();
			Rectangle2D r = ((IFeature) feat).getGeometry().getBounds2D();
			this.index.remove(new Envelope(rAnt.getX(), rAnt.getX()
					+ rAnt.getWidth(), rAnt.getY(), rAnt.getY()
					+ rAnt.getHeight()), new Integer(calculatedIndex));
			this.index.insert(new Envelope(r.getX(), r.getX() + r.getWidth(), r
					.getY(), r.getY() + r.getHeight()), new Integer(
					calculatedIndex));
		}
		fireAfterModifyRow(calculatedIndex, sourceType);
		return posAnteriorInExpansionFile;
	}

	/**
	 * Actualiza en el mapa de ndices, la posicin en la que estaba la
	 * geometra antes de ser modificada. Se marca como vlida, en caso de que
	 * fuera una modificacin de una geometra que estuviese en el fichero de
	 * expansin antes de ser modificada y se pone el puntero de escritura del
	 * expansion file a justo despues de la penultima geometra
	 *
	 * @param calculatedIndex
	 *            ndice de la geometra que se quiere deshacer su modificacin
	 * @param previousExpansionFileIndex
	 *            ndice que tena antes la geometra en el expansionFile. Si
	 *            vale -1 quiere decir que es una modificacin de una geometra
	 *            original y por tanto no hay que actualizar el mapa de indices
	 *            sino eliminar su entrada.
	 *
	 * @throws IOException
	 * @throws DriverIOException
	 */
	public void undoModifyRow(int calculatedIndex,
			int previousExpansionFileIndex, int sourceType) throws IOException,
			DriverIOException {

		// Llega el CalculatedIndex
		/*
		 * Si la accin de modificar se realiz sobre una geometra original
		 */
		if (previousExpansionFileIndex == -1) {

			// Se obtiene la geometra para actualizar el ndice
			// IGeometry g = ((DefaultFeature)
			// getRow(calculatedIndex).getLinkedRow()).getGeometry();
			int inverse = getInversedIndex(calculatedIndex);
			DefaultFeature df = (DefaultFeature) getRow(inverse).getLinkedRow();
			boolean cancel = fireBeforeModifyRow(df, calculatedIndex,
					sourceType);
			if (cancel)
				return;
			IGeometry g = df.getGeometry();
			// IGeometry g = ova.getShape(calculatedIndex);
			Rectangle2D r = g.getBounds2D();

			// Se elimina de las relaciones y del fichero de expansin
			relations.remove(new Integer(calculatedIndex));
			expansionFile.deleteLastRow();

			// Se actualizan los ndices
			IGeometry gAnt = ova.getShape(calculatedIndex);
			/*
			 * IGeometry gAnt = ((DefaultFeature) getRow(calculatedIndex)
			 * .getLinkedRow()).getGeometry();
			 */
			Rectangle2D rAnt = gAnt.getBounds2D();
			this.index.remove(new Envelope(r.getX(), r.getX() + r.getWidth(), r
					.getY(), r.getY() + r.getHeight()), new Integer(
					calculatedIndex));
			this.index.insert(new Envelope(rAnt.getX(), rAnt.getX()
					+ rAnt.getWidth(), rAnt.getY(), rAnt.getY()
					+ rAnt.getHeight()), new Integer(calculatedIndex));
		} else {
			// Se obtiene la geometra para actualizar el ndice
			IGeometry g = null;
			int inverse = getInversedIndex(calculatedIndex);
			DefaultFeature df = (DefaultFeature) getRow(inverse).getLinkedRow();
			boolean cancel = fireBeforeModifyRow(df, calculatedIndex,
					sourceType);
			if (cancel)
				return;
			g = df.getGeometry();
			System.out.println("Actual: " + g.toString());

			Rectangle2D r = g.getBounds2D();
			this.index.remove(new Envelope(r.getX(), r.getX() + r.getWidth(), r
					.getY(), r.getY() + r.getHeight()), new Integer(
					calculatedIndex));

			// Se actualiza la relacin de ndices
			// Integer integer = new Integer(geometryIndex);
			relations.put(new Integer(calculatedIndex), new Integer(
					previousExpansionFileIndex));

			// Se recupera la geometra
			// expansionFile.validateRow(previousExpansionFileIndex);

			// Se actualizan los ndices
			// g = ((IFeature)
			// (expansionFile.getRow(previousExpansionFileIndex).getLinkedRow())).getGeometry();
			// System.out.println("Anterior a la que volvemos : " +
			// g.toString());
			g = ((DefaultFeature) getRow(inverse).getLinkedRow()).getGeometry();
			r = g.getBounds2D();
			this.index.insert(new Envelope(r.getX(), r.getX() + r.getWidth(), r
					.getY(), r.getY() + r.getHeight()), new Integer(
					calculatedIndex));

		}
		fireAfterModifyRow(calculatedIndex, sourceType);
	}

	/**
	 * Aade una geometria al fichero de expansin y guarda la correspondencia
	 * en la tabla relations.
	 *
	 * @param feat
	 *            geometra a guardar.
	 *
	 * @return calculatedIndex
	 *
	 * @throws DriverIOException
	 * @throws IOException
	 */
	public int doAddRow(IRow feat, int sourceType) throws DriverIOException,
			IOException {
		int calculatedIndex = super.doAddRow(feat, sourceType);
		// Actualiza el ndice espacial
		IGeometry g = ((IFeature) feat).getGeometry();
		Rectangle2D r = g.getBounds2D();
		index.insert(new Envelope(r.getX(), r.getX() + r.getWidth(), r.getY(),
				r.getY() + r.getHeight()), new Integer(calculatedIndex));

		return calculatedIndex;
	}

	/**
	 * Se desmarca como invalidada en el fichero de expansion o como eliminada
	 * en el fichero original
	 *
	 * @param index
	 *            DOCUMENT ME!
	 *
	 * @throws IOException
	 * @throws DriverIOException
	 */
	public void undoRemoveRow(int index, int sourceType) throws IOException,
			DriverIOException {
		super.undoRemoveRow(index, sourceType);

		IGeometry g = null;
		g = ((IFeature) getRow(index).getLinkedRow()).getGeometry();

		Rectangle2D r = g.getBounds2D();
		this.index.insert(new Envelope(r.getX(), r.getX() + r.getWidth(), r
				.getY(), r.getY() + r.getHeight()), new Integer(index));
	}

	/**
	 * Se elimina del final del fichero de expansin poniendo el puntero de
	 * escritura apuntando al final de la penltima geometra. Deber quitar la
	 * relacin del mapa de relaciones
	 *
	 * @param index
	 *            ndice de la geometra que se aadi
	 *
	 * @throws DriverIOException
	 * @throws IOException
	 */
	public void undoAddRow(int calculatedIndex, int sourceType)
			throws DriverIOException, IOException {
		int inverse = getInversedIndex(calculatedIndex);
		IGeometry g = ((IFeature) getRow(inverse).getLinkedRow()).getGeometry();
		Rectangle2D r = g.getBounds2D();
		this.index.remove(new Envelope(r.getX(), r.getX() + r.getWidth(), r
				.getY(), r.getY() + r.getHeight()),
				new Integer(calculatedIndex));

		super.undoAddRow(calculatedIndex, sourceType);
		setSelection(new FBitSet());
	}

	/**
	 * Obtiene las geometras que se encuentran en el rectngulo que se pasa
	 * como parmetro haciendo uso del ndice espacial
	 *
	 * @param r
	 *            Rectngulo indicando la porcin del espacio para el cual se
	 *            quiere saber los ndices de las geometras que se encuentran
	 *            dentro de l
	 *
	 * @return Array de ndices para su uso con getGeometry, removeGeometry, ...
	 */
	/*
	 * public int[] getRowsIndexes_OL(Rectangle2D r) { Envelope e = new
	 * Envelope(r.getX(), r.getX() + r.getWidth(), r.getY(), r.getY() +
	 * r.getHeight()); List l = index.query(e); int[] indexes = new
	 * int[l.size()];
	 *
	 * for (int index = 0; index < l.size(); index++) { Integer i = (Integer)
	 * l.get(index); indexes[index] = getInversedIndex(i.intValue()); }
	 *
	 * return indexes; }
	 */
	/**
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#getShapeCount()
	 */
	public int getShapeCount() throws DriverIOException {
		try {
			return getRowCount();
		} catch (IOException e) {
			throw new DriverIOException(e);
		}
	}

	/**
	 * @see com.iver.cit.gvsig.fmap.layers.ReadableVectorial#getFullExtent()
	 */
	public Rectangle2D getFullExtent() throws DriverIOException {
		if (fullExtent == null) {
			fullExtent = ova.getFullExtent();
		}
		return fullExtent;
	}

	/**
	 * Use it BEFORE writing to a file.
	 *
	 * @return real full extent.
	 * @throws DriverIOException
	 */
	public Rectangle2D reCalculateFullExtent() throws DriverIOException {
		if (getShapeCount() > 0) {
			fullExtent = getShape(0).getBounds2D();
			for (int i = 1; i < getShapeCount(); i++) {
				fullExtent.add(getShape(i).getBounds2D());
			}
		} else {
			fullExtent = ova.getFullExtent();
		}
		return fullExtent;
	}

	/**
	 * En la implementacin por defecto podemos hacer que cada feature tenga ID =
	 * numero de registro. En el DBAdapter podramos "overrride" este mtodo y
	 * poner como ID de la Feature el campo nico escogido en la base de datos.
	 *
	 * @param numReg
	 * @return
	 * @throws DriverException
	 */
	public IFeature getFeature(int numReg) throws DriverException {
		IGeometry geom;
		IFeature feat = null;
		try {
			geom = getShape(numReg);
			DataSource rs = getRecordset();
			Value[] regAtt = new Value[rs.getFieldCount()];
			for (int fieldId = 0; fieldId < rs.getFieldCount(); fieldId++) {
				regAtt[fieldId] = rs.getFieldValue(numReg, fieldId);
			}

			feat = new DefaultFeature(geom, regAtt, numReg + "");
		} catch (DriverIOException e) {
			throw new DriverException(e);
		} catch (DriverLoadException e) {
			throw new DriverException(e);
		} catch (com.hardcode.gdbms.engine.data.driver.DriverException e) {
			throw new DriverException(e);
		}
		return feat;
	}

	public void stopEdition(IWriter writer, int sourceType)
			throws EditionException {
		writer.setFlatness(getFlatness());
		super.stopEdition(writer, sourceType);
		try {
			ova.getDriver().reLoad();
		} catch (IOException e) {
			e.printStackTrace();
			throw new EditionException(e);
		}
	}

	public Rectangle2D getShapeBounds(int index) throws IOException {
		// Solo se utiliza cuando el driver es BoundedShapes
		// Si no est en el fichero de expansin
		Integer integer = new Integer((int) index);
		if (!relations.containsKey(integer)) {
			if (ova.getDriver() instanceof BoundedShapes) {
				BoundedShapes bs = (BoundedShapes) ova.getDriver();
				return bs.getShapeBounds(index);
			} else {
				return ova.getDriver().getShape(index).getBounds2D();
			}

		} else {
			int num = ((Integer) relations.get(integer)).intValue();
			DefaultRowEdited feat;
			feat = (DefaultRowEdited) expansionFile.getRow(num);
			if (feat.getStatus() == IRowEdited.STATUS_DELETED)
				return null;
			IGeometry geom = ((IFeature) feat.getLinkedRow()).getGeometry();
			return geom.getBounds2D();// getGeometry();
		}

	}

	public int getShapeType(int index) {
		try {
			return ova.getShapeType();
		} catch (DriverIOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return FShape.MULTI;
	}

	/**
	 * Usar solo cuando ests seguro de que puedes gastar memoria. Nosotros lo
	 * usamos para las bsquedas por ndice espacial con el handle. La idea es
	 * usarlo una vez, guardar las geometras que necesitas en ese extent y
	 * trabajar con ellas hasta el siguiente cambio de extent.
	 *
	 * @param r
	 * @param strEPSG
	 * @return
	 * @throws DriverException
	 */
	public IRowEdited[] getFeatures(Rectangle2D r, String strEPSG)
			throws DriverException {
		// En esta clase suponemos random access.
		// Luego tendremos otra clase que sea VectorialEditableDBAdapter
		// que reescribir este mtodo.
		Envelope e = FConverter.convertRectangle2DtoEnvelope(r);
		List l = index.query(e);
		IRowEdited[] feats = new IRowEdited[l.size()];
		try {
			for (int index = 0; index < l.size(); index++) {
				Integer i = (Integer) l.get(index);
				int inverse = getInversedIndex(i.intValue());
				feats[index] = (IRowEdited) getRow(inverse);
			}
		} catch (DriverIOException e1) {
			throw new DriverException(e1);
		} catch (IOException e1) {
			throw new DriverException(e1);
		}

		return feats;
	}

	public void setSpatialIndex(SpatialIndex spatialIndex) {
		index = (Quadtree) spatialIndex;
	}

	public void setFullExtent(Rectangle2D fullExtent2) {
		fullExtent = fullExtent2;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @return DOCUMENT ME!
	 */
	public Image getSelectionImage() {
		return selectionImage;
	}

	public Image getHandlersImage() {
		return handlersImage;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param i
	 *            DOCUMENT ME!
	 */
	public void setSelectionImage(Image i) {
		selectionImage = i;
	}

	public void setHandlersImage(BufferedImage handlersImage) {
		this.handlersImage = handlersImage;
	}

	public double getFlatness() {
		return flatness;
	}

	public void setFlatness(double d) {
		flatness=d;
	}
}
