/**
 *
 */
package com.iver.cit.gvsig.fmap.edition;

import java.awt.geom.Rectangle2D;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.core.IFeature;
import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.IRow;
import com.iver.cit.gvsig.fmap.core.v02.FConverter;
import com.iver.cit.gvsig.fmap.drivers.DBLayerDefinition;
import com.iver.cit.gvsig.fmap.drivers.DriverIOException;
import com.iver.cit.gvsig.fmap.drivers.IFeatureIterator;
import com.iver.cit.gvsig.fmap.drivers.VectorialDatabaseDriver;
import com.iver.cit.gvsig.fmap.layers.ISpatialDB;
import com.iver.cit.gvsig.fmap.layers.ReadableVectorial;
import com.iver.cit.gvsig.fmap.layers.VectorialDBAdapter;
import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.index.quadtree.Quadtree;

/**
 * @author fjp
 *
 */
public class VectorialEditableDBAdapter extends VectorialEditableAdapter
		implements ISpatialDB {

	private class MyIterator implements IFeatureIterator {
		private Rectangle2D extent = null;

		private VectorialDBAdapter orig;

		private IFeature feat;

		private IFeatureIterator featIt;

		private String epsg;

		private VectorialDatabaseDriver dbDriver;

		Hashtable alreadyDone = new Hashtable();

		private int idFromExpansion = 0;

		private List listFromExpansion;

		private boolean bOriginalCursorOpened = true;

		public MyIterator(Rectangle2D r, String strEPSG) throws DriverException {
			extent = r;
			epsg = strEPSG;
			orig = (VectorialDBAdapter) ova;
			featIt = orig.getFeatureIterator(extent, epsg);
			dbDriver = (VectorialDatabaseDriver) getDriver();
			getFeaturesFromExpansionFile();
		}

		public boolean hasNext() throws DriverException {
			feat = null;
			int calculatedIndex = -1;
			if (bOriginalCursorOpened) // Si hay originales (Es porque si se ha
										// llegado al final, se cierra el
										// iterador y salta un fallo
			{
				bOriginalCursorOpened = featIt.hasNext();
				if (bOriginalCursorOpened) {
					feat = featIt.next();
					int originalIndex = dbDriver.getRowIndexByFID(feat);

					// Iteramos hasta que encontremos alguno no borrado.
					// Aqu suponemos que el orden es el original. Si no, no funcionar.
					if (delRows.get(originalIndex)) // Si est borrado
					{
						feat = null;
						boolean bFound = false;
						while (featIt.hasNext())
						{
							feat = featIt.next();
							originalIndex = dbDriver.getRowIndexByFID(feat);
							// calculatedIndex = getCalculatedIndex(originalIndex);
							if (delRows.get(originalIndex) == false) // Si NO est borrado
							{
								bFound = true;
								break;
							}
						}
						if (bFound == false) // Todos los ltimos estn borrados.
						{
							bOriginalCursorOpened = false; // para que busque en el fichero de expansin
						}
					} // if delRows
					if (bOriginalCursorOpened) // Si todava quedan features por leer, y no estn borradas
					{
						calculatedIndex = originalIndex; //getCalculatedIndex(originalIndex);
						Integer integer = new Integer(calculatedIndex);
						if (!relations.containsKey(integer)) { // Si no est en el
																// fichero de
																// expansin
							alreadyDone.put(integer, feat);
						} else { // Si est en el fichero de expansin
							int num = ((Integer) relations.get(integer)).intValue();
							IRowEdited auxR;
							try {
								auxR = expansionFile.getRow(num);
								feat = (IFeature) auxR.getLinkedRow().cloneRow();
								// feat = (IFeature) auxR.getLinkedRow();
								alreadyDone.put(integer, feat);
							} catch (IOException e) {
								e.printStackTrace();
								throw new DriverException(e);
							}
						} // else
					} // if tercer bOriginalCursorOpened
				} // if segundo bOriginalCursorOpened
			} // if primer bOriginalCursorOpened
			if (!bOriginalCursorOpened) {
				// Si ya no hay ms de las originales, todava tenemos
				// que revisar las aadidas que hay en el fichero
				// de expansin
				try {
					while ((idFromExpansion < expansionFile.getSize()) && (feat == null))
					{
						IRowEdited rowEd = expansionFile.getRow(idFromExpansion);
						IFeature aux = (IFeature) rowEd.getLinkedRow();
						Integer calculated = (Integer) mapFID2index.get(aux.getID());
						calculatedIndex = calculated.intValue();
						System.out.println("El elemento idFromExpansion = " + idFromExpansion + " es " + aux.getID());

						// Revisamos los borrados
						if (delRows.get(calculatedIndex) == true)
						{
							boolean bFound = false;
							while ((!bFound) && (idFromExpansion < expansionFile.getSize()-1))
							{
								// calculatedIndex++;
								idFromExpansion++;
								rowEd = expansionFile.getRow(idFromExpansion);
								aux = (IFeature) rowEd.getLinkedRow();



								Integer auxCalculated = (Integer) mapFID2index.get(aux.getID());
								calculatedIndex = auxCalculated.intValue();
								// Si no est borrado y es una entidad vlida, que est siendo usada (no es algo que est en el expansionFile sin usarse)
								if ((delRows.get(calculatedIndex) == false) && (relations.containsKey(auxCalculated)))
								{
									bFound = true;
									calculated = auxCalculated;
									break;
								}
								else
								{
									System.out.println("El elemento idFromExpansion = " + idFromExpansion + " est borrado");
								}
							}
							if (bFound)
							{
								calculated = new Integer(calculatedIndex);
								rowEd = expansionFile.getRow(idFromExpansion);
								aux = (IFeature) rowEd.getLinkedRow();
							}
							else
							{
								return false; // El resto estn borrados
							}
						} // if primer borrado
						if (relations.containsKey(calculated))
						{
							Integer realExpansionIndex = (Integer) relations.get(calculated);
							if (realExpansionIndex.intValue() == idFromExpansion)
							{
								feat = (IFeature) aux.cloneRow();
							}
						}
						idFromExpansion++;
					}
				} catch (IOException e) {
					throw new DriverException(e);
				}
			}

			if (calculatedIndex == -1)
				return false;
			else {
				if (feat == null)
				{
					if (idFromExpansion == expansionFile.getSize())
						return false;
					else
						System.err.println("ERROR DE ENTREGA DE FEATURE EN hasNext del Iterador");
				}
				/* if (delRows.get(calculatedIndex))
					feat = null; */
				return true;
			}

		}

		public IFeature next() throws DriverException {
			return feat;
		}

		public void closeIterator() throws DriverException {
			// TODO Auto-generated method stub

		}

		private void getFeaturesFromExpansionFile() {
			Envelope e = FConverter.convertRectangle2DtoEnvelope(extent);
			listFromExpansion = index.query(e);
		}
	}


	private Hashtable mapFID2index = new Hashtable();
	private Hashtable mapIndex2FID = new Hashtable();
	/**
	 *
	 */
	public VectorialEditableDBAdapter() {
		super();
		// TODO Auto-generated constructor stub
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#getFeatures(java.awt.geom.Rectangle2D,
	 *      java.lang.String)
	 */
	public IRowEdited[] getFeatures(Rectangle2D r, String strEPSG)
			throws DriverException {
		ArrayList aux = new ArrayList();
		IFeatureIterator featIt = getFeatureIterator(r, strEPSG, null);
		int numEntities = 0;
		while (featIt.hasNext()) {
			IFeature feat = featIt.next();
			// TODO:
			assert(feat !=null);
			int index = getRowIndexByFID(feat);
			IRowEdited edRow = new DefaultRowEdited(feat, IRowEdited.STATUS_ORIGINAL, index);
			aux.add(edRow);
			numEntities++;
		}

		return (IRowEdited[]) aux.toArray(new IRowEdited[0]);
		// return (IFeature[]) aux.toArray(new IFeature[0]);

	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#startEdition()
	 */
	public void startEdition(int sourceType) throws EditionException {
		isEditing = true;
		try {
			expansionFile.open();

			// TODO: Si la capa dispone de un ndice espacial, hacer
			// algo aqu para que se use ese ndice espacial.
			index = new Quadtree();
			// No metemos ninguna entidad de las originales dentro
			// de la base de datos porque esa consulta ya la
			// hace getFeatures sin tener en cuenta el ndice local.
			 for (int i = 0; i < ova.getShapeCount(); i++)
			 {
				 IFeature feat = ova.getFeature(i);
				 Integer calculatedIndex = new Integer(i);
				 mapFID2index.put(feat.getID(), calculatedIndex);
				 mapIndex2FID.put(calculatedIndex, feat.getID());
			 }

			/*
			 * for (int i = 0; i < ova.getShapeCount(); i++) { IGeometry g=null;
			 * try { g = ((DefaultFeature) ova.getFeature(i)).getGeometry(); }
			 * catch (DriverException e1) { // TODO Auto-generated catch block
			 * e1.printStackTrace(); }
			 *
			 * if (g == null) { continue; }
			 *
			 * Rectangle2D r = g.getBounds2D(); Envelope e = new
			 * Envelope(r.getX(), r.getX() + r.getWidth(), r.getY(), r.getY() +
			 * r.getHeight()); index.insert(e, new Integer(i)); } } catch
			 * (DriverIOException e) { throw new EditionException(e);
			 */
		} catch (IOException e) {
			throw new EditionException(e);
		} catch (DriverIOException e) {
			throw new EditionException(e);
		} catch (DriverException e) {
			throw new EditionException(e);
		}

		System.err.println("Se han metido en el ndice "
				+ index.queryAll().size() + " geometras");

	}

	/*
	 * (non-Javadoc)
	 *
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#stopEdition(com.iver.cit.gvsig.fmap.edition.IWriter)
	 */
	public void stopEdition(IWriter writer, int sourceType) throws EditionException {
		// TODO Auto-generated method stub
		super.stopEdition(writer, sourceType);
	}

	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG)
			throws DriverException {
		return new MyIterator(r, strEPSG);
	}

	public IFeatureIterator getFeatureIterator(Rectangle2D r, String strEPSG,
			String[] alphaNumericFieldsNeeded) throws DriverException {
		return new MyIterator(r, strEPSG);
	}

	public String[] getFields() {
		VectorialDBAdapter orig = (VectorialDBAdapter) ova;
		return orig.getFields();
	}

	public String getWhereClause() {
		VectorialDBAdapter orig = (VectorialDBAdapter) ova;
		return orig.getWhereClause();
	}

	public String getTableName() {
		VectorialDBAdapter orig = (VectorialDBAdapter) ova;
		return orig.getTableName();
	}

	public DBLayerDefinition getLyrDef() {
		VectorialDBAdapter orig = (VectorialDBAdapter) ova;
		return orig.getLyrDef();
	}

	public int getRowIndexByFID(IFeature feat) {
		/* int resul;
		VectorialDBAdapter orig = (VectorialDBAdapter) ova;
		resul = orig.getRowIndexByFID(feat);
		int externalIndex = -1;
		if (resul == -1)
		{
			// No est en los originales. Si no est borrado,
			// estar en el fichero de expansin.
			Integer integer = (Integer) hashFIDtoExpansionFile.get(feat.getID());
			resul = integer.intValue();
			IRowEdited rowEd;
			try {
				rowEd = expansionFile.getRow(resul);
				externalIndex = rowEd.getIndex();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}


		}
		else
		{
			externalIndex = getInversedIndex(resul);
		} */
		Integer calculatedIndex = (Integer) mapFID2index.get(feat.getID());
		return getInversedIndex(calculatedIndex.intValue());
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#doAddRow(com.iver.cit.gvsig.fmap.core.IRow)
	 */
	public int doAddRow(IRow feat, int sourceType) throws DriverIOException, IOException {
		int calculatedIndex = super.doAddRow(feat, sourceType);
		Integer posInExpansionFile = (Integer) relations.get(new Integer(calculatedIndex));
		Integer virtual = new Integer(calculatedIndex); // calculatedIndex es igual al numero de shapes originales + el numero de entidades aadidas.
					// es decir, virtual es el calculatedIndex (no tiene en cuenta los borrados)
					// calculatedIndex = indiceExterno + borrados hasta ese punto.
		mapFID2index.put(feat.getID(), virtual);
		mapIndex2FID.put(virtual, feat.getID());
		return calculatedIndex;

	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#doModifyRow(int, com.iver.cit.gvsig.fmap.core.IRow)
	 */
	public int doModifyRow(int calculatedIndex, IRow feat,int sourceType) throws IOException, DriverIOException {
		int posAnteriorInExpansionFile = super.doModifyRow(calculatedIndex, feat, sourceType); // devolver -1 si es original
		// No hacemos nada con las modificaciones sobre los ndices.
		// Suponiendo que feat tenga la misma ID que la que haba antes.
		Integer virtual = new Integer(calculatedIndex);
		String theIDoriginal = (String) mapIndex2FID.get(virtual);
		if (!theIDoriginal.equals(feat.getID()))
		{
			AssertionError err = new AssertionError("Fallo al modificar la fila. ID viejo=" + theIDoriginal + " ID nuevo = " + feat.getID());
			err.printStackTrace();
		}
		// hashFIDtoExpansionFile.put(feat.getID(), new Integer(posInExpansionFile));
		mapFID2index.put(feat.getID(), virtual);
		mapIndex2FID.put(virtual, feat.getID());
		return posAnteriorInExpansionFile;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#doRemoveRow(int)
	 */
	public IRow doRemoveRow(int index,int sourceType) throws DriverIOException, IOException {
		// Le entra un calculatedIndex, as que delRows tiene guardados
		// los ndices internos, no los externos.
		IFeature deletedFeat = (IFeature) super.doRemoveRow(index, sourceType);
		// Lo borramos de hashFIDtoExpansionFile
		// hashFIDtoExpansionFile.remove(deletedFeat.getID());
		return deletedFeat;
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#getFeature(int)
	 */
	public IFeature getFeature(int numReg) throws DriverException {
		// TODO Auto-generated method stub
		return super.getFeature(numReg);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#getRow(int)
	 */
	public IRowEdited getRow(int index) throws DriverIOException, IOException {
		// TODO Auto-generated method stub
		return super.getRow(index);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#getShape(int)
	 */
	public IGeometry getShape(int rowIndex) throws DriverIOException {
		// TODO Auto-generated method stub
		return super.getShape(rowIndex);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#getShapeBounds(int)
	 */
	public Rectangle2D getShapeBounds(int index) throws IOException {
		// TODO Auto-generated method stub
		return super.getShapeBounds(index);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#getShapeType(int)
	 */
	public int getShapeType(int index) {
		// TODO Auto-generated method stub
		return super.getShapeType(index);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#setOriginalVectorialAdapter(com.iver.cit.gvsig.fmap.layers.ReadableVectorial)
	 */
	public void setOriginalVectorialAdapter(ReadableVectorial rv) {
		// El ndice espacial se est calcualndo en el startEdition, pero
		// OJO: No se hace con un while, sino con un getRow().
		// Si va lento, habr que reescribirlo.
		super.setOriginalVectorialAdapter(rv);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#undoAddRow(int)
	 */
	public void undoAddRow(int calculatedIndex, int sourceType) throws DriverIOException, IOException {
		// TODO Auto-generated method stub
		super.undoAddRow(calculatedIndex,sourceType);
		Integer calculated = new Integer(calculatedIndex);
		String theID = (String) mapIndex2FID.get(calculated);
		mapFID2index.remove(calculated);
		mapIndex2FID.remove(theID);

	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#undoModifyRow(int, int)
	 */
	public void undoModifyRow(int geometryIndex, int previousExpansionFileIndex, int sourceType) throws IOException, DriverIOException {
		// TODO Auto-generated method stub
		super.undoModifyRow(geometryIndex, previousExpansionFileIndex, sourceType);
	}

	/* (non-Javadoc)
	 * @see com.iver.cit.gvsig.fmap.edition.VectorialEditableAdapter#undoRemoveRow(int)
	 */
	public void undoRemoveRow(int index, int sourceType) throws IOException, DriverIOException {
		// TODO Auto-generated method stub
		super.undoRemoveRow(index, sourceType);
	}

}
