package com.iver.cit.gvsig.fmap.layers;

import java.awt.geom.Rectangle2D;

import com.iver.cit.gvsig.fmap.core.IGeometry;
import com.iver.cit.gvsig.fmap.core.v02.FConverter;
import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.index.ItemVisitor;
import com.vividsolutions.jts.index.quadtree.Quadtree;

public class SpatialCache extends Quadtree {
	int maxFeatures = 1000; // Por defecto, pero se puede cambiar

	public int getMaxFeatures() {
		return maxFeatures;
	}

	public void setMaxFeatures(int maxFeatures) {
		this.maxFeatures = maxFeatures;
	}

	/**
	 * Mtodo de conveniencia
	 * 
	 * @param r
	 * @param igeometry
	 */
	public synchronized void insert(Rectangle2D bounds, IGeometry geom) {
		Envelope env = FConverter.convertRectangle2DtoEnvelope(bounds);
		this.insert(env, geom);
	}

	public synchronized void query(Envelope searchEnv, ItemVisitor visitor)
	{
		super.query(searchEnv, visitor);
	}


}
