package com.hardcode.gdbms.engine.data.driver;

import com.hardcode.gdbms.engine.data.edition.DataWare;



/**
 * Interfaz que define los mtodos de acceso de lectura
 *
 * @author Fernando Gonzlez Corts
 */
public interface ObjectDriver extends GDBMSDriver, ReadAccess {
    /**
     * Gets the primary key field indexes
     *
     * @return int[]
     *
     * @throws DriverException If the operation fails
     */
    public int[] getPrimaryKeys() throws DriverException;

    /**
     * Writes the content in the DataWare to the specified file
     *
     * @param dataWare DataWare with the contents
     */
    void write(DataWare dataWare) throws DriverException;
}
