package com.hardcode.gdbms.engine.strategies;

import java.io.IOException;

import com.hardcode.gdbms.engine.data.DataSource;
import com.hardcode.gdbms.engine.data.DataSourceCommonImpl;
import com.hardcode.gdbms.engine.data.DataSourceFactory;
import com.hardcode.gdbms.engine.data.SourceInfo;
import com.hardcode.gdbms.engine.data.driver.DriverException;
import com.hardcode.gdbms.engine.data.edition.DataWare;
import com.hardcode.gdbms.engine.values.ValueCollection;


/**
 * operation layer DataSource base class
 *
 * @author Fernando Gonzlez Corts
 */
public abstract class OperationDataSource extends DataSourceCommonImpl implements DataSource {
	private DataSourceFactory dsf;
	private String sql;
	private String name;

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getName()
	 */
	public String getName() {
		return name;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getDBMS()
	 */
	public String getDBMS() {
		return null;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getWhereFilter()
	 */
	public long[] getWhereFilter() throws IOException {
		return null;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getDataSourceFactory()
	 */
	public DataSourceFactory getDataSourceFactory() {
		return dsf;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#setDataSourceFactory(com.hardcode.gdbms.engine.data.DataSourceFactory)
	 */
	public void setDataSourceFactory(DataSourceFactory dsf) {
		this.dsf = dsf;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.HasProperties#getProperty(java.lang.String)
	 */
	public String getProperty(String propertyName) {
		return null;
	}

	/**
	 * sets the sql query of this operation DataSource. It's needed by the
	 * getMemento method which contains basically the sql
	 *
	 * @param sql query
	 */
	public void setSQL(String sql) {
		this.sql = sql;
	}

	/**
	 * Gets the SQL string that created this DataSource
	 *
	 * @return String with the query
	 */
	public String getSQL() {
		return sql;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#setSourceInfo(com.hardcode.gdbms.engine.data.DataSourceFactory.DriverInfo)
	 */
	public void setSourceInfo(SourceInfo sourceInfo) {
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getSourceInfo()
	 */
	public SourceInfo getSourceInfo() {
		return null;
	}

	/**
	 * DOCUMENT ME!
	 *
	 * @param tableAlias
	 */
	public void setName(String tableAlias) {
		name = tableAlias;
	}

	/**
	 * @see com.hardcode.gdbms.engine.data.DataSource#remove()
	 */
	public void remove() throws DriverException {
		dsf.remove(this);
	}

    /**
	 * @see com.hardcode.gdbms.engine.data.DataSource#getPrimaryKeys()
	 */
    public int[] getPrimaryKeys() throws DriverException {
        return null;
    }

    /**
     * @see com.hardcode.gdbms.engine.data.DataSource#getPKValue(long)
     */
    public ValueCollection getPKValue(long rowIndex) throws DriverException {
	    throw new UnsupportedOperationException("OperationDataSources do not have primary keys");
    }

    /**
     * @see com.hardcode.gdbms.engine.data.DataSource#getPKName(int)
     */
    public String getPKName(int fieldId) throws DriverException {
	    throw new UnsupportedOperationException("OperationDataSources do not have primary keys");
    }

    /**
     * @see com.hardcode.gdbms.engine.data.DataSource#getPKType(int)
     */
    public int getPKType(int i) throws DriverException {
	    throw new UnsupportedOperationException("OperationDataSources do not have primary keys");
    }

    /**
     * @see com.hardcode.gdbms.engine.data.DataSource#getPKCardinality()
     */
    public int getPKCardinality() {
	    throw new UnsupportedOperationException("OperationDataSources do not have primary keys");
    }
    /**
     * @see com.hardcode.gdbms.engine.data.DataSource#getPKNames()
     */
    public String[] getPKNames() throws DriverException {
	    throw new UnsupportedOperationException("OperationDataSources do not have primary keys");
    }
    /**
     * @see com.hardcode.gdbms.engine.data.DataSource#getPKNames()
     */
    public DataWare getDataWare(int mode){
	    throw new UnsupportedOperationException("OperationDataSources do not have primary keys");
    }
    
    public boolean isVirtualField(int fieldId) throws DriverException  {
    	return false;
    }
}
