package org.gvsig.remoteClient.wfs;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Vector;

import org.gvsig.remoteClient.utils.BoundaryBox;
import org.gvsig.remoteClient.wcs.WCSCoverage.RectifiedGrid;

/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: WFSFeature.java,v 1.4 2006/05/23 13:23:22 jorpiell Exp $
 * $Log: WFSFeature.java,v $
 * Revision 1.4  2006/05/23 13:23:22  jorpiell
 * Se ha cambiado el final del bucle de parseado y se tiene en cuenta el online resource
 *
 * Revision 1.2  2006/04/20 16:39:16  jorpiell
 * Aadida la operacion de describeFeatureType y el parser correspondiente.
 *
 * Revision 1.1  2006/04/19 12:51:35  jorpiell
 * Aadidas algunas de las clases del servicio WFS
 *
 *
 */
/**
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class WFSFeature {
	 private String	name = null;
	 private String	title = null;
	 private String	_abstract = null;
	 private Vector keykords = new Vector();
	 private String defaultSRS = null;
	 private Vector otherSRS = new Vector();
	 private String noSRS = null;
	 private Vector operations = new Vector();
	 private String outputFormat = null;
	 private String wgs84BoundingBox = null;
	 private Vector metadataURL = new Vector();
	 private Vector fields = new Vector();
	 
	/**
	 * @return Returns the fields.
	 */
	public Vector getFields() {
		return fields;
	}
	/**
	 * @param fields The fields to set.
	 */
	public void setFields(Vector fields) {
		this.fields = fields;
	}
	/**
	 * @return Returns the _abstract.
	 */
	public String getAbstract() {
		return _abstract;
	}
	/**
	 * @param _abstract The _abstract to set.
	 */
	public void setAbstract(String _abstract) {
		this._abstract = _abstract;
	}
	/**
	 * @return Returns the defaultSRS.
	 */
	public String getDefaultSRS() {
		return defaultSRS;
	}
	/**
	 * @param defaultSRS The defaultSRS to set.
	 */
	public void setDefaultSRS(String defaultSRS) {
		this.defaultSRS = defaultSRS;
	}
	/**
	 * @return Returns the keykords.
	 */
	public Vector getKeykords() {
		return keykords;
	}
	/**
	 * @param keykords The keykords to set.
	 */
	public void setKeykords(Vector keykords) {
		this.keykords = keykords;
	}
	/**
	 * @return Returns the metadataURL.
	 */
	public Vector getMetadataURL() {
		return metadataURL;
	}
	/**
	 * @param metadataURL The metadataURL to set.
	 */
	public void setMetadataURL(Vector metadataURL) {
		this.metadataURL = metadataURL;
	}
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	/**
	 * @return Returns the noSRS.
	 */
	public String getNoSRS() {
		return noSRS;
	}
	/**
	 * @param noSRS The noSRS to set.
	 */
	public void setNoSRS(String noSRS) {
		this.noSRS = noSRS;
	}
	/**
	 * @return Returns the operations.
	 */
	public Vector getOperations() {
		return operations;
	}
	/**
	 * @param operations The operations to set.
	 */
	public void setOperations(Vector operations) {
		this.operations = operations;
	}
	/**
	 * @return Returns the otherSRS.
	 */
	public Vector getOtherSRS() {
		return otherSRS;
	}
	/**
	 * @param otherSRS The otherSRS to set.
	 */
	public void setOtherSRS(Vector otherSRS) {
		this.otherSRS = otherSRS;
	}
	/**
	 * @return Returns the outputFormat.
	 */
	public String getOutputFormat() {
		return outputFormat;
	}
	/**
	 * @param outputFormat The outputFormat to set.
	 */
	public void setOutputFormat(String outputFormat) {
		this.outputFormat = outputFormat;
	}
	/**
	 * @return Returns the title.
	 */
	public String getTitle() {
		return title;
	}
	/**
	 * @param title The title to set.
	 */
	public void setTitle(String title) {
		this.title = title;
	}
	/**
	 * @return Returns the wgs84BoundingBox.
	 */
	public String getWgs84BoundingBox() {
		return wgs84BoundingBox;
	}
	/**
	 * @param wgs84BoundingBox The wgs84BoundingBox to set.
	 */
	public void setWgs84BoundingBox(String wgs84BoundingBox) {
		this.wgs84BoundingBox = wgs84BoundingBox;
	}
	
}    
